// Copyright 2015, VIXL authors
// All rights reserved.
//
// Redistribution and use in source and binary forms, with or without
// modification, are permitted provided that the following conditions are met:
//
//   * Redistributions of source code must retain the above copyright notice,
//     this list of conditions and the following disclaimer.
//   * Redistributions in binary form must reproduce the above copyright notice,
//     this list of conditions and the following disclaimer in the documentation
//     and/or other materials provided with the distribution.
//   * Neither the name of ARM Limited nor the names of its contributors may be
//     used to endorse or promote products derived from this software without
//     specific prior written permission.
//
// THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS CONTRIBUTORS "AS IS" AND
// ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
// WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
// DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE
// FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
// DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
// SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
// CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
// OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
// OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.


// ---------------------------------------------------------------------
// This file is auto generated using tools/generate_simulator_traces.py.
//
// PLEASE DO NOT EDIT.
// ---------------------------------------------------------------------

#ifndef VIXL_SIMULATOR_COND_RD_RN_OPERAND_RM_ASR_A32_H_
#define VIXL_SIMULATOR_COND_RD_RN_OPERAND_RM_ASR_A32_H_

const Inputs kOutputs_Asr_Condition_eq_r0_r0_r0[] = {
  { 0x80000000, 0xabababab, 0xabababab, 0xabababab },
  { 0x40000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x20000000, 0xabababab, 0xabababab, 0xabababab },
  { 0x10000000, 0xabababab, 0xabababab, 0xabababab },
  { 0xc0000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0xa0000000, 0xabababab, 0xabababab, 0xabababab },
  { 0x90000000, 0xabababab, 0xabababab, 0xabababab },
  { 0x60000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x50000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x30000000, 0xabababab, 0xabababab, 0xabababab },
  { 0xe0000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0xd0000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0xb0000000, 0xabababab, 0xabababab, 0xabababab },
  { 0x70000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0xf0000000, 0xffffffff, 0xffffffff, 0xffffffff },
};
const Inputs kOutputs_Asr_Condition_ne_r0_r0_r0[] = {
  { 0x80000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x40000000, 0xabababab, 0xabababab, 0xabababab },
  { 0x20000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x10000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0xc0000000, 0xabababab, 0xabababab, 0xabababab },
  { 0xa0000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x90000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x60000000, 0xabababab, 0xabababab, 0xabababab },
  { 0x50000000, 0xabababab, 0xabababab, 0xabababab },
  { 0x30000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0xe0000000, 0xabababab, 0xabababab, 0xabababab },
  { 0xd0000000, 0xabababab, 0xabababab, 0xabababab },
  { 0xb0000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x70000000, 0xabababab, 0xabababab, 0xabababab },
  { 0xf0000000, 0xabababab, 0xabababab, 0xabababab },
};
const Inputs kOutputs_Asr_Condition_cs_r0_r0_r0[] = {
  { 0x80000000, 0xabababab, 0xabababab, 0xabababab },
  { 0x40000000, 0xabababab, 0xabababab, 0xabababab },
  { 0x20000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x10000000, 0xabababab, 0xabababab, 0xabababab },
  { 0xc0000000, 0xabababab, 0xabababab, 0xabababab },
  { 0xa0000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x90000000, 0xabababab, 0xabababab, 0xabababab },
  { 0x60000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x50000000, 0xabababab, 0xabababab, 0xabababab },
  { 0x30000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0xe0000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0xd0000000, 0xabababab, 0xabababab, 0xabababab },
  { 0xb0000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x70000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0xf0000000, 0xffffffff, 0xffffffff, 0xffffffff },
};
const Inputs kOutputs_Asr_Condition_cc_r0_r0_r0[] = {
  { 0x80000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x40000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x20000000, 0xabababab, 0xabababab, 0xabababab },
  { 0x10000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0xc0000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0xa0000000, 0xabababab, 0xabababab, 0xabababab },
  { 0x90000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x60000000, 0xabababab, 0xabababab, 0xabababab },
  { 0x50000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x30000000, 0xabababab, 0xabababab, 0xabababab },
  { 0xe0000000, 0xabababab, 0xabababab, 0xabababab },
  { 0xd0000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0xb0000000, 0xabababab, 0xabababab, 0xabababab },
  { 0x70000000, 0xabababab, 0xabababab, 0xabababab },
  { 0xf0000000, 0xabababab, 0xabababab, 0xabababab },
};
const Inputs kOutputs_Asr_Condition_mi_r0_r0_r0[] = {
  { 0x80000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x40000000, 0xabababab, 0xabababab, 0xabababab },
  { 0x20000000, 0xabababab, 0xabababab, 0xabababab },
  { 0x10000000, 0xabababab, 0xabababab, 0xabababab },
  { 0xc0000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0xa0000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x90000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x60000000, 0xabababab, 0xabababab, 0xabababab },
  { 0x50000000, 0xabababab, 0xabababab, 0xabababab },
  { 0x30000000, 0xabababab, 0xabababab, 0xabababab },
  { 0xe0000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0xd0000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0xb0000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x70000000, 0xabababab, 0xabababab, 0xabababab },
  { 0xf0000000, 0xffffffff, 0xffffffff, 0xffffffff },
};
const Inputs kOutputs_Asr_Condition_pl_r0_r0_r0[] = {
  { 0x80000000, 0xabababab, 0xabababab, 0xabababab },
  { 0x40000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x20000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x10000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0xc0000000, 0xabababab, 0xabababab, 0xabababab },
  { 0xa0000000, 0xabababab, 0xabababab, 0xabababab },
  { 0x90000000, 0xabababab, 0xabababab, 0xabababab },
  { 0x60000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x50000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x30000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0xe0000000, 0xabababab, 0xabababab, 0xabababab },
  { 0xd0000000, 0xabababab, 0xabababab, 0xabababab },
  { 0xb0000000, 0xabababab, 0xabababab, 0xabababab },
  { 0x70000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0xf0000000, 0xabababab, 0xabababab, 0xabababab },
};
const Inputs kOutputs_Asr_Condition_vs_r0_r0_r0[] = {
  { 0x80000000, 0xabababab, 0xabababab, 0xabababab },
  { 0x40000000, 0xabababab, 0xabababab, 0xabababab },
  { 0x20000000, 0xabababab, 0xabababab, 0xabababab },
  { 0x10000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0xc0000000, 0xabababab, 0xabababab, 0xabababab },
  { 0xa0000000, 0xabababab, 0xabababab, 0xabababab },
  { 0x90000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x60000000, 0xabababab, 0xabababab, 0xabababab },
  { 0x50000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x30000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0xe0000000, 0xabababab, 0xabababab, 0xabababab },
  { 0xd0000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0xb0000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x70000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0xf0000000, 0xffffffff, 0xffffffff, 0xffffffff },
};
const Inputs kOutputs_Asr_Condition_vc_r0_r0_r0[] = {
  { 0x80000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x40000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x20000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x10000000, 0xabababab, 0xabababab, 0xabababab },
  { 0xc0000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0xa0000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x90000000, 0xabababab, 0xabababab, 0xabababab },
  { 0x60000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x50000000, 0xabababab, 0xabababab, 0xabababab },
  { 0x30000000, 0xabababab, 0xabababab, 0xabababab },
  { 0xe0000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0xd0000000, 0xabababab, 0xabababab, 0xabababab },
  { 0xb0000000, 0xabababab, 0xabababab, 0xabababab },
  { 0x70000000, 0xabababab, 0xabababab, 0xabababab },
  { 0xf0000000, 0xabababab, 0xabababab, 0xabababab },
};
const Inputs kOutputs_Asr_Condition_hi_r0_r0_r0[] = {
  { 0x80000000, 0xabababab, 0xabababab, 0xabababab },
  { 0x40000000, 0xabababab, 0xabababab, 0xabababab },
  { 0x20000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x10000000, 0xabababab, 0xabababab, 0xabababab },
  { 0xc0000000, 0xabababab, 0xabababab, 0xabababab },
  { 0xa0000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x90000000, 0xabababab, 0xabababab, 0xabababab },
  { 0x60000000, 0xabababab, 0xabababab, 0xabababab },
  { 0x50000000, 0xabababab, 0xabababab, 0xabababab },
  { 0x30000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0xe0000000, 0xabababab, 0xabababab, 0xabababab },
  { 0xd0000000, 0xabababab, 0xabababab, 0xabababab },
  { 0xb0000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x70000000, 0xabababab, 0xabababab, 0xabababab },
  { 0xf0000000, 0xabababab, 0xabababab, 0xabababab },
};
const Inputs kOutputs_Asr_Condition_ls_r0_r0_r0[] = {
  { 0x80000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x40000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x20000000, 0xabababab, 0xabababab, 0xabababab },
  { 0x10000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0xc0000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0xa0000000, 0xabababab, 0xabababab, 0xabababab },
  { 0x90000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x60000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x50000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x30000000, 0xabababab, 0xabababab, 0xabababab },
  { 0xe0000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0xd0000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0xb0000000, 0xabababab, 0xabababab, 0xabababab },
  { 0x70000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0xf0000000, 0xffffffff, 0xffffffff, 0xffffffff },
};
const Inputs kOutputs_Asr_Condition_ge_r0_r0_r0[] = {
  { 0x80000000, 0xabababab, 0xabababab, 0xabababab },
  { 0x40000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x20000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x10000000, 0xabababab, 0xabababab, 0xabababab },
  { 0xc0000000, 0xabababab, 0xabababab, 0xabababab },
  { 0xa0000000, 0xabababab, 0xabababab, 0xabababab },
  { 0x90000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x60000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x50000000, 0xabababab, 0xabababab, 0xabababab },
  { 0x30000000, 0xabababab, 0xabababab, 0xabababab },
  { 0xe0000000, 0xabababab, 0xabababab, 0xabababab },
  { 0xd0000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0xb0000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x70000000, 0xabababab, 0xabababab, 0xabababab },
  { 0xf0000000, 0xffffffff, 0xffffffff, 0xffffffff },
};
const Inputs kOutputs_Asr_Condition_lt_r0_r0_r0[] = {
  { 0x80000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x40000000, 0xabababab, 0xabababab, 0xabababab },
  { 0x20000000, 0xabababab, 0xabababab, 0xabababab },
  { 0x10000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0xc0000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0xa0000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x90000000, 0xabababab, 0xabababab, 0xabababab },
  { 0x60000000, 0xabababab, 0xabababab, 0xabababab },
  { 0x50000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x30000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0xe0000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0xd0000000, 0xabababab, 0xabababab, 0xabababab },
  { 0xb0000000, 0xabababab, 0xabababab, 0xabababab },
  { 0x70000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0xf0000000, 0xabababab, 0xabababab, 0xabababab },
};
const Inputs kOutputs_Asr_Condition_gt_r0_r0_r0[] = {
  { 0x80000000, 0xabababab, 0xabababab, 0xabababab },
  { 0x40000000, 0xabababab, 0xabababab, 0xabababab },
  { 0x20000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x10000000, 0xabababab, 0xabababab, 0xabababab },
  { 0xc0000000, 0xabababab, 0xabababab, 0xabababab },
  { 0xa0000000, 0xabababab, 0xabababab, 0xabababab },
  { 0x90000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x60000000, 0xabababab, 0xabababab, 0xabababab },
  { 0x50000000, 0xabababab, 0xabababab, 0xabababab },
  { 0x30000000, 0xabababab, 0xabababab, 0xabababab },
  { 0xe0000000, 0xabababab, 0xabababab, 0xabababab },
  { 0xd0000000, 0xabababab, 0xabababab, 0xabababab },
  { 0xb0000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x70000000, 0xabababab, 0xabababab, 0xabababab },
  { 0xf0000000, 0xabababab, 0xabababab, 0xabababab },
};
const Inputs kOutputs_Asr_Condition_le_r0_r0_r0[] = {
  { 0x80000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x40000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x20000000, 0xabababab, 0xabababab, 0xabababab },
  { 0x10000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0xc0000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0xa0000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x90000000, 0xabababab, 0xabababab, 0xabababab },
  { 0x60000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x50000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x30000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0xe0000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0xd0000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0xb0000000, 0xabababab, 0xabababab, 0xabababab },
  { 0x70000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0xf0000000, 0xffffffff, 0xffffffff, 0xffffffff },
};
const Inputs kOutputs_Asr_Condition_al_r0_r0_r0[] = {
  { 0x80000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x40000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x20000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x10000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0xc0000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0xa0000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x90000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x60000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x50000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x30000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0xe0000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0xd0000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0xb0000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x70000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0xf0000000, 0xffffffff, 0xffffffff, 0xffffffff },
};
const Inputs kOutputs_Asr_RdIsRn_al_r3_r3_r4[] = {
  { 0x00000000, 0xffffffe0, 0xffffffe0, 0xffff8002 },
  { 0x00000000, 0x00000000, 0x00000000, 0x7fffffff },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffffe0 },
  { 0x00000000, 0x1fffffff, 0x1fffffff, 0x00000002 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xfffffffd },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00007fff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffff83 },
  { 0x00000000, 0xffffc001, 0xffffc001, 0x80000001 },
  { 0x00000000, 0x00000fff, 0x00000fff, 0xffff8003 },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffffff },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffff80 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x33333333 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x0000007e },
  { 0x00000000, 0x00000000, 0x00000000, 0x7ffffffd },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xfffffffd },
  { 0x00000000, 0x00000008, 0x00000008, 0xffff8002 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xfffffffe },
  { 0x00000000, 0x00000002, 0x00000002, 0x00000000 },
  { 0x00000000, 0x0000003f, 0x0000003f, 0x00000001 },
  { 0x00000000, 0x00000000, 0x00000000, 0x0000007f },
  { 0x00000000, 0x80000000, 0x80000000, 0x80000000 },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffff80 },
  { 0x00000000, 0x00000000, 0x00000000, 0xfffffffe },
  { 0x00000000, 0x00000000, 0x00000000, 0x0000007d },
  { 0x00000000, 0x00000000, 0x00000000, 0x7ffffffe },
  { 0x00000000, 0x00000000, 0x00000000, 0x7fffffff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffff83 },
  { 0x00000000, 0x00000000, 0x00000000, 0x7ffffffe },
  { 0x00000000, 0x00000000, 0x00000000, 0x0000007f },
  { 0x00000000, 0x00000000, 0x00000000, 0xcccccccc },
  { 0x00000000, 0xffffffe0, 0xffffffe0, 0x00000002 },
  { 0x00000000, 0x00000000, 0x00000000, 0xaaaaaaaa },
  { 0x00000000, 0xe6666666, 0xe6666666, 0xffff8001 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffff8001 },
  { 0x00000000, 0x00000000, 0x00000000, 0x00000020 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00007ffe },
  { 0x00000000, 0x80000001, 0x80000001, 0xffff8000 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x0000007d },
  { 0x00000000, 0x00000000, 0x00000000, 0x7ffffffe },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffff80 },
  { 0x00000000, 0x00000000, 0x00000000, 0x0000007e },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x7fffffff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x0000007f },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffff81 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x0000007e },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xaaaaaaaa },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00000020 },
  { 0x00000000, 0xfffffff0, 0xfffffff0, 0xffff8003 },
  { 0x00000000, 0x1fffffff, 0x1fffffff, 0xffff8002 },
  { 0x00000000, 0x7ffffffe, 0x7ffffffe, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffe0 },
  { 0x00000000, 0xffffe000, 0xffffe000, 0xffff8002 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x7ffffffd },
  { 0x00000000, 0xcccccccc, 0xcccccccc, 0x80000000 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x33333333 },
  { 0x00000000, 0x00000000, 0x00000000, 0x00000002 },
  { 0x00000000, 0x00000000, 0x00000000, 0x0000007f },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xfffffffd },
  { 0x00000000, 0xffffff80, 0xffffff80, 0x80000000 },
  { 0x00000000, 0x00000000, 0x00000000, 0x00000020 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffff8003 },
  { 0x00000000, 0xffff8001, 0xffff8001, 0xffff8000 },
  { 0x00000000, 0x00000000, 0x00000000, 0x55555555 },
  { 0x00000000, 0x00007fff, 0x00007fff, 0xffff8000 },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffffe0 },
  { 0x00000000, 0x00000000, 0x00000000, 0x55555555 },
  { 0x00000000, 0x00000000, 0x00000000, 0x7ffffffe },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffe0 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x0000007d },
  { 0x00000000, 0xffffe000, 0xffffe000, 0x00000002 },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffff81 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffff80 },
  { 0x00000000, 0x00001fff, 0x00001fff, 0xffff8002 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xfffffffe },
  { 0x00000000, 0x00000000, 0x00000000, 0xfffffffd },
  { 0x00000000, 0x00000000, 0x00000000, 0xfffffffe },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffff83 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00007ffe },
  { 0x00000000, 0x7fffffff, 0x7fffffff, 0x80000000 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x7fffffff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffff83 },
  { 0x00000000, 0xffff8000, 0xffff8000, 0xffff8000 },
  { 0x00000000, 0x00000000, 0x00000000, 0x7fffffff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xfffffffe },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x0000007d },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xfffffffe },
  { 0x00000000, 0x00000000, 0x00000000, 0x0000007d },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xfffffffe },
  { 0x00000000, 0x00000000, 0x00000000, 0x00007ffd },
  { 0x00000000, 0xeaaaaaaa, 0xeaaaaaaa, 0xffff8002 },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffff82 },
  { 0x00000000, 0x00000000, 0x00000000, 0x33333333 },
  { 0x00000000, 0xfffffffd, 0xfffffffd, 0x80000000 },
  { 0x00000000, 0x00000000, 0x00000000, 0xfffffffd },
  { 0x00000000, 0x00000000, 0x00000000, 0x0000007f },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x0000007e },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x55555555 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x80000000 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x0000007e },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00007ffd },
  { 0x00000000, 0x00000010, 0x00000010, 0xffff8001 },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffff83 },
  { 0x00000000, 0x33333333, 0x33333333, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffff82 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x0000007e },
  { 0x00000000, 0xffffffc0, 0xffffffc0, 0x00000001 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xcccccccc },
  { 0x00000000, 0x00000000, 0x00000000, 0x00007ffd },
  { 0x00000000, 0x3fffffff, 0x3fffffff, 0x80000001 },
  { 0x00000000, 0x00000000, 0x00000000, 0x00007ffe },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xfffffffd },
  { 0x00000000, 0x3fffffff, 0x3fffffff, 0xffff8001 },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffff83 },
  { 0x00000000, 0x00000000, 0x00000000, 0x00000020 },
  { 0x00000000, 0xf0000000, 0xf0000000, 0xffff8003 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x0000007f },
  { 0x00000000, 0x0000003f, 0x0000003f, 0x80000001 },
  { 0x00000000, 0x00000000, 0x00000000, 0x7ffffffe },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffff83 },
  { 0x00000000, 0x00000000, 0x00000000, 0x7fffffff },
  { 0x00000000, 0x00000000, 0x00000000, 0xfffffffe },
  { 0x00000000, 0xffffff82, 0xffffff82, 0xffff8000 },
  { 0x00000000, 0xfffffffe, 0xfffffffe, 0xffff8000 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffff81 },
  { 0x00000000, 0x00000000, 0x00000000, 0x7fffffff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00007fff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xcccccccc },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00000002 },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffff81 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffff80 },
  { 0x00000000, 0x00000000, 0x00000000, 0xaaaaaaaa },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffff82 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xaaaaaaaa },
  { 0x00000000, 0x00000000, 0x00000000, 0x00000020 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00007ffd },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xaaaaaaaa },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xfffffffe },
  { 0x00000000, 0xaaaaaaaa, 0xaaaaaaaa, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x0000007f },
  { 0x00000000, 0x00000000, 0x00000000, 0x0000007d },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x55555555 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00000020 },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffff83 },
  { 0x00000000, 0x00000000, 0x00000000, 0x55555555 },
  { 0x00000000, 0x00000000, 0x00000000, 0xcccccccc },
  { 0x00000000, 0xfffffffc, 0xfffffffc, 0xffff8003 },
  { 0x00000000, 0x00000000, 0x00000000, 0x00007ffe },
  { 0x00000000, 0x00001fff, 0x00001fff, 0xffff8002 },
  { 0x00000000, 0x00003ffe, 0x00003ffe, 0x00000001 },
  { 0x00000000, 0x00000000, 0x00000000, 0x00007ffe },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00000020 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x0000007d },
  { 0x00000000, 0xffff8003, 0xffff8003, 0x00000000 },
  { 0x00000000, 0x0000007e, 0x0000007e, 0x80000000 },
  { 0x00000000, 0xfffffffd, 0xfffffffd, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x0000007f },
  { 0x00000000, 0x7ffffffd, 0x7ffffffd, 0x00000000 },
  { 0x00000000, 0x00007fff, 0x00007fff, 0x00000000 },
  { 0x00000000, 0x0000003f, 0x0000003f, 0x00000001 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffff82 },
  { 0x00000000, 0x00000000, 0x00000000, 0x00007ffd },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x33333333 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x55555555 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x0000007e },
  { 0x00000000, 0xffffffe0, 0xffffffe0, 0x00000002 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x33333333 },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffffff },
  { 0x00000000, 0xd5555555, 0xd5555555, 0x80000001 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffe0 },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffffe0 },
  { 0x00000000, 0x00000000, 0x00000000, 0x33333333 },
  { 0x00000000, 0x2aaaaaaa, 0x2aaaaaaa, 0x00000001 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00007fff },
  { 0x00000000, 0x00000000, 0x00000000, 0xfffffffd },
  { 0x00000000, 0xfffffff8, 0xfffffff8, 0xffff8002 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00007ffd },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xfffffffe },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00000020 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xcccccccc },
  { 0x00000000, 0x00000000, 0x00000000, 0x7fffffff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x55555555 },
  { 0x00000000, 0x00000000, 0x00000000, 0x00000020 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00007fff },
  { 0x00000000, 0x00000000, 0x00000000, 0xaaaaaaaa },
  { 0x00000000, 0x00000000, 0x00000000, 0x7fffffff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x7fffffff },
  { 0x00000000, 0x00000000, 0x00000000, 0x55555555 },
  { 0x00000000, 0x00000000, 0x00000000, 0x0000007d },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x7ffffffe },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00007ffe },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffff81 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x0000007d },
  { 0x00000000, 0x00000000, 0x00000000, 0x0000007e },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00007ffe },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x0000007e },
};
const Inputs kOutputs_Asr_RdIsRn_al_r2_r2_r12[] = {
  { 0x00000000, 0xffffffe0, 0xffffffe0, 0xffff8002 },
  { 0x00000000, 0x00000000, 0x00000000, 0x7fffffff },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffffe0 },
  { 0x00000000, 0x1fffffff, 0x1fffffff, 0x00000002 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xfffffffd },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00007fff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffff83 },
  { 0x00000000, 0xffffc001, 0xffffc001, 0x80000001 },
  { 0x00000000, 0x00000fff, 0x00000fff, 0xffff8003 },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffffff },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffff80 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x33333333 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x0000007e },
  { 0x00000000, 0x00000000, 0x00000000, 0x7ffffffd },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xfffffffd },
  { 0x00000000, 0x00000008, 0x00000008, 0xffff8002 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xfffffffe },
  { 0x00000000, 0x00000002, 0x00000002, 0x00000000 },
  { 0x00000000, 0x0000003f, 0x0000003f, 0x00000001 },
  { 0x00000000, 0x00000000, 0x00000000, 0x0000007f },
  { 0x00000000, 0x80000000, 0x80000000, 0x80000000 },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffff80 },
  { 0x00000000, 0x00000000, 0x00000000, 0xfffffffe },
  { 0x00000000, 0x00000000, 0x00000000, 0x0000007d },
  { 0x00000000, 0x00000000, 0x00000000, 0x7ffffffe },
  { 0x00000000, 0x00000000, 0x00000000, 0x7fffffff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffff83 },
  { 0x00000000, 0x00000000, 0x00000000, 0x7ffffffe },
  { 0x00000000, 0x00000000, 0x00000000, 0x0000007f },
  { 0x00000000, 0x00000000, 0x00000000, 0xcccccccc },
  { 0x00000000, 0xffffffe0, 0xffffffe0, 0x00000002 },
  { 0x00000000, 0x00000000, 0x00000000, 0xaaaaaaaa },
  { 0x00000000, 0xe6666666, 0xe6666666, 0xffff8001 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffff8001 },
  { 0x00000000, 0x00000000, 0x00000000, 0x00000020 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00007ffe },
  { 0x00000000, 0x80000001, 0x80000001, 0xffff8000 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x0000007d },
  { 0x00000000, 0x00000000, 0x00000000, 0x7ffffffe },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffff80 },
  { 0x00000000, 0x00000000, 0x00000000, 0x0000007e },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x7fffffff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x0000007f },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffff81 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x0000007e },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xaaaaaaaa },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00000020 },
  { 0x00000000, 0xfffffff0, 0xfffffff0, 0xffff8003 },
  { 0x00000000, 0x1fffffff, 0x1fffffff, 0xffff8002 },
  { 0x00000000, 0x7ffffffe, 0x7ffffffe, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffe0 },
  { 0x00000000, 0xffffe000, 0xffffe000, 0xffff8002 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x7ffffffd },
  { 0x00000000, 0xcccccccc, 0xcccccccc, 0x80000000 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x33333333 },
  { 0x00000000, 0x00000000, 0x00000000, 0x00000002 },
  { 0x00000000, 0x00000000, 0x00000000, 0x0000007f },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xfffffffd },
  { 0x00000000, 0xffffff80, 0xffffff80, 0x80000000 },
  { 0x00000000, 0x00000000, 0x00000000, 0x00000020 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffff8003 },
  { 0x00000000, 0xffff8001, 0xffff8001, 0xffff8000 },
  { 0x00000000, 0x00000000, 0x00000000, 0x55555555 },
  { 0x00000000, 0x00007fff, 0x00007fff, 0xffff8000 },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffffe0 },
  { 0x00000000, 0x00000000, 0x00000000, 0x55555555 },
  { 0x00000000, 0x00000000, 0x00000000, 0x7ffffffe },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffe0 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x0000007d },
  { 0x00000000, 0xffffe000, 0xffffe000, 0x00000002 },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffff81 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffff80 },
  { 0x00000000, 0x00001fff, 0x00001fff, 0xffff8002 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xfffffffe },
  { 0x00000000, 0x00000000, 0x00000000, 0xfffffffd },
  { 0x00000000, 0x00000000, 0x00000000, 0xfffffffe },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffff83 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00007ffe },
  { 0x00000000, 0x7fffffff, 0x7fffffff, 0x80000000 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x7fffffff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffff83 },
  { 0x00000000, 0xffff8000, 0xffff8000, 0xffff8000 },
  { 0x00000000, 0x00000000, 0x00000000, 0x7fffffff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xfffffffe },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x0000007d },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xfffffffe },
  { 0x00000000, 0x00000000, 0x00000000, 0x0000007d },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xfffffffe },
  { 0x00000000, 0x00000000, 0x00000000, 0x00007ffd },
  { 0x00000000, 0xeaaaaaaa, 0xeaaaaaaa, 0xffff8002 },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffff82 },
  { 0x00000000, 0x00000000, 0x00000000, 0x33333333 },
  { 0x00000000, 0xfffffffd, 0xfffffffd, 0x80000000 },
  { 0x00000000, 0x00000000, 0x00000000, 0xfffffffd },
  { 0x00000000, 0x00000000, 0x00000000, 0x0000007f },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x0000007e },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x55555555 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x80000000 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x0000007e },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00007ffd },
  { 0x00000000, 0x00000010, 0x00000010, 0xffff8001 },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffff83 },
  { 0x00000000, 0x33333333, 0x33333333, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffff82 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x0000007e },
  { 0x00000000, 0xffffffc0, 0xffffffc0, 0x00000001 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xcccccccc },
  { 0x00000000, 0x00000000, 0x00000000, 0x00007ffd },
  { 0x00000000, 0x3fffffff, 0x3fffffff, 0x80000001 },
  { 0x00000000, 0x00000000, 0x00000000, 0x00007ffe },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xfffffffd },
  { 0x00000000, 0x3fffffff, 0x3fffffff, 0xffff8001 },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffff83 },
  { 0x00000000, 0x00000000, 0x00000000, 0x00000020 },
  { 0x00000000, 0xf0000000, 0xf0000000, 0xffff8003 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x0000007f },
  { 0x00000000, 0x0000003f, 0x0000003f, 0x80000001 },
  { 0x00000000, 0x00000000, 0x00000000, 0x7ffffffe },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffff83 },
  { 0x00000000, 0x00000000, 0x00000000, 0x7fffffff },
  { 0x00000000, 0x00000000, 0x00000000, 0xfffffffe },
  { 0x00000000, 0xffffff82, 0xffffff82, 0xffff8000 },
  { 0x00000000, 0xfffffffe, 0xfffffffe, 0xffff8000 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffff81 },
  { 0x00000000, 0x00000000, 0x00000000, 0x7fffffff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00007fff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xcccccccc },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00000002 },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffff81 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffff80 },
  { 0x00000000, 0x00000000, 0x00000000, 0xaaaaaaaa },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffff82 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xaaaaaaaa },
  { 0x00000000, 0x00000000, 0x00000000, 0x00000020 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00007ffd },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xaaaaaaaa },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xfffffffe },
  { 0x00000000, 0xaaaaaaaa, 0xaaaaaaaa, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x0000007f },
  { 0x00000000, 0x00000000, 0x00000000, 0x0000007d },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x55555555 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00000020 },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffff83 },
  { 0x00000000, 0x00000000, 0x00000000, 0x55555555 },
  { 0x00000000, 0x00000000, 0x00000000, 0xcccccccc },
  { 0x00000000, 0xfffffffc, 0xfffffffc, 0xffff8003 },
  { 0x00000000, 0x00000000, 0x00000000, 0x00007ffe },
  { 0x00000000, 0x00001fff, 0x00001fff, 0xffff8002 },
  { 0x00000000, 0x00003ffe, 0x00003ffe, 0x00000001 },
  { 0x00000000, 0x00000000, 0x00000000, 0x00007ffe },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00000020 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x0000007d },
  { 0x00000000, 0xffff8003, 0xffff8003, 0x00000000 },
  { 0x00000000, 0x0000007e, 0x0000007e, 0x80000000 },
  { 0x00000000, 0xfffffffd, 0xfffffffd, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x0000007f },
  { 0x00000000, 0x7ffffffd, 0x7ffffffd, 0x00000000 },
  { 0x00000000, 0x00007fff, 0x00007fff, 0x00000000 },
  { 0x00000000, 0x0000003f, 0x0000003f, 0x00000001 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffff82 },
  { 0x00000000, 0x00000000, 0x00000000, 0x00007ffd },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x33333333 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x55555555 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x0000007e },
  { 0x00000000, 0xffffffe0, 0xffffffe0, 0x00000002 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x33333333 },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffffff },
  { 0x00000000, 0xd5555555, 0xd5555555, 0x80000001 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffe0 },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffffe0 },
  { 0x00000000, 0x00000000, 0x00000000, 0x33333333 },
  { 0x00000000, 0x2aaaaaaa, 0x2aaaaaaa, 0x00000001 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00007fff },
  { 0x00000000, 0x00000000, 0x00000000, 0xfffffffd },
  { 0x00000000, 0xfffffff8, 0xfffffff8, 0xffff8002 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00007ffd },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xfffffffe },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00000020 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xcccccccc },
  { 0x00000000, 0x00000000, 0x00000000, 0x7fffffff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x55555555 },
  { 0x00000000, 0x00000000, 0x00000000, 0x00000020 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00007fff },
  { 0x00000000, 0x00000000, 0x00000000, 0xaaaaaaaa },
  { 0x00000000, 0x00000000, 0x00000000, 0x7fffffff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x7fffffff },
  { 0x00000000, 0x00000000, 0x00000000, 0x55555555 },
  { 0x00000000, 0x00000000, 0x00000000, 0x0000007d },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x7ffffffe },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00007ffe },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffff81 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x0000007d },
  { 0x00000000, 0x00000000, 0x00000000, 0x0000007e },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00007ffe },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x0000007e },
};
const Inputs kOutputs_Asr_RdIsRn_al_r8_r8_r5[] = {
  { 0x00000000, 0xffffffe0, 0xffffffe0, 0xffff8002 },
  { 0x00000000, 0x00000000, 0x00000000, 0x7fffffff },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffffe0 },
  { 0x00000000, 0x1fffffff, 0x1fffffff, 0x00000002 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xfffffffd },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00007fff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffff83 },
  { 0x00000000, 0xffffc001, 0xffffc001, 0x80000001 },
  { 0x00000000, 0x00000fff, 0x00000fff, 0xffff8003 },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffffff },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffff80 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x33333333 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x0000007e },
  { 0x00000000, 0x00000000, 0x00000000, 0x7ffffffd },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xfffffffd },
  { 0x00000000, 0x00000008, 0x00000008, 0xffff8002 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xfffffffe },
  { 0x00000000, 0x00000002, 0x00000002, 0x00000000 },
  { 0x00000000, 0x0000003f, 0x0000003f, 0x00000001 },
  { 0x00000000, 0x00000000, 0x00000000, 0x0000007f },
  { 0x00000000, 0x80000000, 0x80000000, 0x80000000 },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffff80 },
  { 0x00000000, 0x00000000, 0x00000000, 0xfffffffe },
  { 0x00000000, 0x00000000, 0x00000000, 0x0000007d },
  { 0x00000000, 0x00000000, 0x00000000, 0x7ffffffe },
  { 0x00000000, 0x00000000, 0x00000000, 0x7fffffff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffff83 },
  { 0x00000000, 0x00000000, 0x00000000, 0x7ffffffe },
  { 0x00000000, 0x00000000, 0x00000000, 0x0000007f },
  { 0x00000000, 0x00000000, 0x00000000, 0xcccccccc },
  { 0x00000000, 0xffffffe0, 0xffffffe0, 0x00000002 },
  { 0x00000000, 0x00000000, 0x00000000, 0xaaaaaaaa },
  { 0x00000000, 0xe6666666, 0xe6666666, 0xffff8001 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffff8001 },
  { 0x00000000, 0x00000000, 0x00000000, 0x00000020 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00007ffe },
  { 0x00000000, 0x80000001, 0x80000001, 0xffff8000 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x0000007d },
  { 0x00000000, 0x00000000, 0x00000000, 0x7ffffffe },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffff80 },
  { 0x00000000, 0x00000000, 0x00000000, 0x0000007e },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x7fffffff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x0000007f },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffff81 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x0000007e },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xaaaaaaaa },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00000020 },
  { 0x00000000, 0xfffffff0, 0xfffffff0, 0xffff8003 },
  { 0x00000000, 0x1fffffff, 0x1fffffff, 0xffff8002 },
  { 0x00000000, 0x7ffffffe, 0x7ffffffe, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffe0 },
  { 0x00000000, 0xffffe000, 0xffffe000, 0xffff8002 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x7ffffffd },
  { 0x00000000, 0xcccccccc, 0xcccccccc, 0x80000000 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x33333333 },
  { 0x00000000, 0x00000000, 0x00000000, 0x00000002 },
  { 0x00000000, 0x00000000, 0x00000000, 0x0000007f },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xfffffffd },
  { 0x00000000, 0xffffff80, 0xffffff80, 0x80000000 },
  { 0x00000000, 0x00000000, 0x00000000, 0x00000020 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffff8003 },
  { 0x00000000, 0xffff8001, 0xffff8001, 0xffff8000 },
  { 0x00000000, 0x00000000, 0x00000000, 0x55555555 },
  { 0x00000000, 0x00007fff, 0x00007fff, 0xffff8000 },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffffe0 },
  { 0x00000000, 0x00000000, 0x00000000, 0x55555555 },
  { 0x00000000, 0x00000000, 0x00000000, 0x7ffffffe },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffe0 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x0000007d },
  { 0x00000000, 0xffffe000, 0xffffe000, 0x00000002 },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffff81 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffff80 },
  { 0x00000000, 0x00001fff, 0x00001fff, 0xffff8002 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xfffffffe },
  { 0x00000000, 0x00000000, 0x00000000, 0xfffffffd },
  { 0x00000000, 0x00000000, 0x00000000, 0xfffffffe },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffff83 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00007ffe },
  { 0x00000000, 0x7fffffff, 0x7fffffff, 0x80000000 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x7fffffff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffff83 },
  { 0x00000000, 0xffff8000, 0xffff8000, 0xffff8000 },
  { 0x00000000, 0x00000000, 0x00000000, 0x7fffffff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xfffffffe },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x0000007d },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xfffffffe },
  { 0x00000000, 0x00000000, 0x00000000, 0x0000007d },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xfffffffe },
  { 0x00000000, 0x00000000, 0x00000000, 0x00007ffd },
  { 0x00000000, 0xeaaaaaaa, 0xeaaaaaaa, 0xffff8002 },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffff82 },
  { 0x00000000, 0x00000000, 0x00000000, 0x33333333 },
  { 0x00000000, 0xfffffffd, 0xfffffffd, 0x80000000 },
  { 0x00000000, 0x00000000, 0x00000000, 0xfffffffd },
  { 0x00000000, 0x00000000, 0x00000000, 0x0000007f },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x0000007e },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x55555555 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x80000000 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x0000007e },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00007ffd },
  { 0x00000000, 0x00000010, 0x00000010, 0xffff8001 },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffff83 },
  { 0x00000000, 0x33333333, 0x33333333, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffff82 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x0000007e },
  { 0x00000000, 0xffffffc0, 0xffffffc0, 0x00000001 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xcccccccc },
  { 0x00000000, 0x00000000, 0x00000000, 0x00007ffd },
  { 0x00000000, 0x3fffffff, 0x3fffffff, 0x80000001 },
  { 0x00000000, 0x00000000, 0x00000000, 0x00007ffe },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xfffffffd },
  { 0x00000000, 0x3fffffff, 0x3fffffff, 0xffff8001 },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffff83 },
  { 0x00000000, 0x00000000, 0x00000000, 0x00000020 },
  { 0x00000000, 0xf0000000, 0xf0000000, 0xffff8003 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x0000007f },
  { 0x00000000, 0x0000003f, 0x0000003f, 0x80000001 },
  { 0x00000000, 0x00000000, 0x00000000, 0x7ffffffe },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffff83 },
  { 0x00000000, 0x00000000, 0x00000000, 0x7fffffff },
  { 0x00000000, 0x00000000, 0x00000000, 0xfffffffe },
  { 0x00000000, 0xffffff82, 0xffffff82, 0xffff8000 },
  { 0x00000000, 0xfffffffe, 0xfffffffe, 0xffff8000 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffff81 },
  { 0x00000000, 0x00000000, 0x00000000, 0x7fffffff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00007fff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xcccccccc },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00000002 },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffff81 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffff80 },
  { 0x00000000, 0x00000000, 0x00000000, 0xaaaaaaaa },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffff82 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xaaaaaaaa },
  { 0x00000000, 0x00000000, 0x00000000, 0x00000020 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00007ffd },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xaaaaaaaa },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xfffffffe },
  { 0x00000000, 0xaaaaaaaa, 0xaaaaaaaa, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x0000007f },
  { 0x00000000, 0x00000000, 0x00000000, 0x0000007d },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x55555555 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00000020 },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffff83 },
  { 0x00000000, 0x00000000, 0x00000000, 0x55555555 },
  { 0x00000000, 0x00000000, 0x00000000, 0xcccccccc },
  { 0x00000000, 0xfffffffc, 0xfffffffc, 0xffff8003 },
  { 0x00000000, 0x00000000, 0x00000000, 0x00007ffe },
  { 0x00000000, 0x00001fff, 0x00001fff, 0xffff8002 },
  { 0x00000000, 0x00003ffe, 0x00003ffe, 0x00000001 },
  { 0x00000000, 0x00000000, 0x00000000, 0x00007ffe },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00000020 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x0000007d },
  { 0x00000000, 0xffff8003, 0xffff8003, 0x00000000 },
  { 0x00000000, 0x0000007e, 0x0000007e, 0x80000000 },
  { 0x00000000, 0xfffffffd, 0xfffffffd, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x0000007f },
  { 0x00000000, 0x7ffffffd, 0x7ffffffd, 0x00000000 },
  { 0x00000000, 0x00007fff, 0x00007fff, 0x00000000 },
  { 0x00000000, 0x0000003f, 0x0000003f, 0x00000001 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffff82 },
  { 0x00000000, 0x00000000, 0x00000000, 0x00007ffd },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x33333333 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x55555555 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x0000007e },
  { 0x00000000, 0xffffffe0, 0xffffffe0, 0x00000002 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x33333333 },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffffff },
  { 0x00000000, 0xd5555555, 0xd5555555, 0x80000001 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffe0 },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffffe0 },
  { 0x00000000, 0x00000000, 0x00000000, 0x33333333 },
  { 0x00000000, 0x2aaaaaaa, 0x2aaaaaaa, 0x00000001 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00007fff },
  { 0x00000000, 0x00000000, 0x00000000, 0xfffffffd },
  { 0x00000000, 0xfffffff8, 0xfffffff8, 0xffff8002 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00007ffd },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xfffffffe },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00000020 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xcccccccc },
  { 0x00000000, 0x00000000, 0x00000000, 0x7fffffff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x55555555 },
  { 0x00000000, 0x00000000, 0x00000000, 0x00000020 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00007fff },
  { 0x00000000, 0x00000000, 0x00000000, 0xaaaaaaaa },
  { 0x00000000, 0x00000000, 0x00000000, 0x7fffffff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x7fffffff },
  { 0x00000000, 0x00000000, 0x00000000, 0x55555555 },
  { 0x00000000, 0x00000000, 0x00000000, 0x0000007d },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x7ffffffe },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00007ffe },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffff81 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x0000007d },
  { 0x00000000, 0x00000000, 0x00000000, 0x0000007e },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00007ffe },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x0000007e },
};
const Inputs kOutputs_Asr_RdIsRn_al_r14_r14_r0[] = {
  { 0x00000000, 0xffffffe0, 0xffffffe0, 0xffff8002 },
  { 0x00000000, 0x00000000, 0x00000000, 0x7fffffff },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffffe0 },
  { 0x00000000, 0x1fffffff, 0x1fffffff, 0x00000002 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xfffffffd },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00007fff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffff83 },
  { 0x00000000, 0xffffc001, 0xffffc001, 0x80000001 },
  { 0x00000000, 0x00000fff, 0x00000fff, 0xffff8003 },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffffff },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffff80 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x33333333 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x0000007e },
  { 0x00000000, 0x00000000, 0x00000000, 0x7ffffffd },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xfffffffd },
  { 0x00000000, 0x00000008, 0x00000008, 0xffff8002 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xfffffffe },
  { 0x00000000, 0x00000002, 0x00000002, 0x00000000 },
  { 0x00000000, 0x0000003f, 0x0000003f, 0x00000001 },
  { 0x00000000, 0x00000000, 0x00000000, 0x0000007f },
  { 0x00000000, 0x80000000, 0x80000000, 0x80000000 },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffff80 },
  { 0x00000000, 0x00000000, 0x00000000, 0xfffffffe },
  { 0x00000000, 0x00000000, 0x00000000, 0x0000007d },
  { 0x00000000, 0x00000000, 0x00000000, 0x7ffffffe },
  { 0x00000000, 0x00000000, 0x00000000, 0x7fffffff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffff83 },
  { 0x00000000, 0x00000000, 0x00000000, 0x7ffffffe },
  { 0x00000000, 0x00000000, 0x00000000, 0x0000007f },
  { 0x00000000, 0x00000000, 0x00000000, 0xcccccccc },
  { 0x00000000, 0xffffffe0, 0xffffffe0, 0x00000002 },
  { 0x00000000, 0x00000000, 0x00000000, 0xaaaaaaaa },
  { 0x00000000, 0xe6666666, 0xe6666666, 0xffff8001 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffff8001 },
  { 0x00000000, 0x00000000, 0x00000000, 0x00000020 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00007ffe },
  { 0x00000000, 0x80000001, 0x80000001, 0xffff8000 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x0000007d },
  { 0x00000000, 0x00000000, 0x00000000, 0x7ffffffe },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffff80 },
  { 0x00000000, 0x00000000, 0x00000000, 0x0000007e },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x7fffffff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x0000007f },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffff81 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x0000007e },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xaaaaaaaa },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00000020 },
  { 0x00000000, 0xfffffff0, 0xfffffff0, 0xffff8003 },
  { 0x00000000, 0x1fffffff, 0x1fffffff, 0xffff8002 },
  { 0x00000000, 0x7ffffffe, 0x7ffffffe, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffe0 },
  { 0x00000000, 0xffffe000, 0xffffe000, 0xffff8002 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x7ffffffd },
  { 0x00000000, 0xcccccccc, 0xcccccccc, 0x80000000 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x33333333 },
  { 0x00000000, 0x00000000, 0x00000000, 0x00000002 },
  { 0x00000000, 0x00000000, 0x00000000, 0x0000007f },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xfffffffd },
  { 0x00000000, 0xffffff80, 0xffffff80, 0x80000000 },
  { 0x00000000, 0x00000000, 0x00000000, 0x00000020 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffff8003 },
  { 0x00000000, 0xffff8001, 0xffff8001, 0xffff8000 },
  { 0x00000000, 0x00000000, 0x00000000, 0x55555555 },
  { 0x00000000, 0x00007fff, 0x00007fff, 0xffff8000 },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffffe0 },
  { 0x00000000, 0x00000000, 0x00000000, 0x55555555 },
  { 0x00000000, 0x00000000, 0x00000000, 0x7ffffffe },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffe0 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x0000007d },
  { 0x00000000, 0xffffe000, 0xffffe000, 0x00000002 },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffff81 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffff80 },
  { 0x00000000, 0x00001fff, 0x00001fff, 0xffff8002 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xfffffffe },
  { 0x00000000, 0x00000000, 0x00000000, 0xfffffffd },
  { 0x00000000, 0x00000000, 0x00000000, 0xfffffffe },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffff83 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00007ffe },
  { 0x00000000, 0x7fffffff, 0x7fffffff, 0x80000000 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x7fffffff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffff83 },
  { 0x00000000, 0xffff8000, 0xffff8000, 0xffff8000 },
  { 0x00000000, 0x00000000, 0x00000000, 0x7fffffff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xfffffffe },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x0000007d },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xfffffffe },
  { 0x00000000, 0x00000000, 0x00000000, 0x0000007d },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xfffffffe },
  { 0x00000000, 0x00000000, 0x00000000, 0x00007ffd },
  { 0x00000000, 0xeaaaaaaa, 0xeaaaaaaa, 0xffff8002 },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffff82 },
  { 0x00000000, 0x00000000, 0x00000000, 0x33333333 },
  { 0x00000000, 0xfffffffd, 0xfffffffd, 0x80000000 },
  { 0x00000000, 0x00000000, 0x00000000, 0xfffffffd },
  { 0x00000000, 0x00000000, 0x00000000, 0x0000007f },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x0000007e },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x55555555 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x80000000 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x0000007e },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00007ffd },
  { 0x00000000, 0x00000010, 0x00000010, 0xffff8001 },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffff83 },
  { 0x00000000, 0x33333333, 0x33333333, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffff82 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x0000007e },
  { 0x00000000, 0xffffffc0, 0xffffffc0, 0x00000001 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xcccccccc },
  { 0x00000000, 0x00000000, 0x00000000, 0x00007ffd },
  { 0x00000000, 0x3fffffff, 0x3fffffff, 0x80000001 },
  { 0x00000000, 0x00000000, 0x00000000, 0x00007ffe },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xfffffffd },
  { 0x00000000, 0x3fffffff, 0x3fffffff, 0xffff8001 },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffff83 },
  { 0x00000000, 0x00000000, 0x00000000, 0x00000020 },
  { 0x00000000, 0xf0000000, 0xf0000000, 0xffff8003 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x0000007f },
  { 0x00000000, 0x0000003f, 0x0000003f, 0x80000001 },
  { 0x00000000, 0x00000000, 0x00000000, 0x7ffffffe },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffff83 },
  { 0x00000000, 0x00000000, 0x00000000, 0x7fffffff },
  { 0x00000000, 0x00000000, 0x00000000, 0xfffffffe },
  { 0x00000000, 0xffffff82, 0xffffff82, 0xffff8000 },
  { 0x00000000, 0xfffffffe, 0xfffffffe, 0xffff8000 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffff81 },
  { 0x00000000, 0x00000000, 0x00000000, 0x7fffffff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00007fff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xcccccccc },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00000002 },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffff81 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffff80 },
  { 0x00000000, 0x00000000, 0x00000000, 0xaaaaaaaa },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffff82 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xaaaaaaaa },
  { 0x00000000, 0x00000000, 0x00000000, 0x00000020 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00007ffd },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xaaaaaaaa },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xfffffffe },
  { 0x00000000, 0xaaaaaaaa, 0xaaaaaaaa, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x0000007f },
  { 0x00000000, 0x00000000, 0x00000000, 0x0000007d },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x55555555 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00000020 },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffff83 },
  { 0x00000000, 0x00000000, 0x00000000, 0x55555555 },
  { 0x00000000, 0x00000000, 0x00000000, 0xcccccccc },
  { 0x00000000, 0xfffffffc, 0xfffffffc, 0xffff8003 },
  { 0x00000000, 0x00000000, 0x00000000, 0x00007ffe },
  { 0x00000000, 0x00001fff, 0x00001fff, 0xffff8002 },
  { 0x00000000, 0x00003ffe, 0x00003ffe, 0x00000001 },
  { 0x00000000, 0x00000000, 0x00000000, 0x00007ffe },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00000020 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x0000007d },
  { 0x00000000, 0xffff8003, 0xffff8003, 0x00000000 },
  { 0x00000000, 0x0000007e, 0x0000007e, 0x80000000 },
  { 0x00000000, 0xfffffffd, 0xfffffffd, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x0000007f },
  { 0x00000000, 0x7ffffffd, 0x7ffffffd, 0x00000000 },
  { 0x00000000, 0x00007fff, 0x00007fff, 0x00000000 },
  { 0x00000000, 0x0000003f, 0x0000003f, 0x00000001 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffff82 },
  { 0x00000000, 0x00000000, 0x00000000, 0x00007ffd },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x33333333 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x55555555 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x0000007e },
  { 0x00000000, 0xffffffe0, 0xffffffe0, 0x00000002 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x33333333 },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffffff },
  { 0x00000000, 0xd5555555, 0xd5555555, 0x80000001 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffe0 },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffffe0 },
  { 0x00000000, 0x00000000, 0x00000000, 0x33333333 },
  { 0x00000000, 0x2aaaaaaa, 0x2aaaaaaa, 0x00000001 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00007fff },
  { 0x00000000, 0x00000000, 0x00000000, 0xfffffffd },
  { 0x00000000, 0xfffffff8, 0xfffffff8, 0xffff8002 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00007ffd },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xfffffffe },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00000020 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xcccccccc },
  { 0x00000000, 0x00000000, 0x00000000, 0x7fffffff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x55555555 },
  { 0x00000000, 0x00000000, 0x00000000, 0x00000020 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00007fff },
  { 0x00000000, 0x00000000, 0x00000000, 0xaaaaaaaa },
  { 0x00000000, 0x00000000, 0x00000000, 0x7fffffff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x7fffffff },
  { 0x00000000, 0x00000000, 0x00000000, 0x55555555 },
  { 0x00000000, 0x00000000, 0x00000000, 0x0000007d },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x7ffffffe },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00007ffe },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffff81 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x0000007d },
  { 0x00000000, 0x00000000, 0x00000000, 0x0000007e },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00007ffe },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x0000007e },
};
const Inputs kOutputs_Asr_RdIsRn_al_r11_r11_r10[] = {
  { 0x00000000, 0xffffffe0, 0xffffffe0, 0xffff8002 },
  { 0x00000000, 0x00000000, 0x00000000, 0x7fffffff },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffffe0 },
  { 0x00000000, 0x1fffffff, 0x1fffffff, 0x00000002 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xfffffffd },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00007fff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffff83 },
  { 0x00000000, 0xffffc001, 0xffffc001, 0x80000001 },
  { 0x00000000, 0x00000fff, 0x00000fff, 0xffff8003 },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffffff },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffff80 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x33333333 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x0000007e },
  { 0x00000000, 0x00000000, 0x00000000, 0x7ffffffd },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xfffffffd },
  { 0x00000000, 0x00000008, 0x00000008, 0xffff8002 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xfffffffe },
  { 0x00000000, 0x00000002, 0x00000002, 0x00000000 },
  { 0x00000000, 0x0000003f, 0x0000003f, 0x00000001 },
  { 0x00000000, 0x00000000, 0x00000000, 0x0000007f },
  { 0x00000000, 0x80000000, 0x80000000, 0x80000000 },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffff80 },
  { 0x00000000, 0x00000000, 0x00000000, 0xfffffffe },
  { 0x00000000, 0x00000000, 0x00000000, 0x0000007d },
  { 0x00000000, 0x00000000, 0x00000000, 0x7ffffffe },
  { 0x00000000, 0x00000000, 0x00000000, 0x7fffffff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffff83 },
  { 0x00000000, 0x00000000, 0x00000000, 0x7ffffffe },
  { 0x00000000, 0x00000000, 0x00000000, 0x0000007f },
  { 0x00000000, 0x00000000, 0x00000000, 0xcccccccc },
  { 0x00000000, 0xffffffe0, 0xffffffe0, 0x00000002 },
  { 0x00000000, 0x00000000, 0x00000000, 0xaaaaaaaa },
  { 0x00000000, 0xe6666666, 0xe6666666, 0xffff8001 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffff8001 },
  { 0x00000000, 0x00000000, 0x00000000, 0x00000020 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00007ffe },
  { 0x00000000, 0x80000001, 0x80000001, 0xffff8000 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x0000007d },
  { 0x00000000, 0x00000000, 0x00000000, 0x7ffffffe },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffff80 },
  { 0x00000000, 0x00000000, 0x00000000, 0x0000007e },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x7fffffff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x0000007f },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffff81 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x0000007e },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xaaaaaaaa },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00000020 },
  { 0x00000000, 0xfffffff0, 0xfffffff0, 0xffff8003 },
  { 0x00000000, 0x1fffffff, 0x1fffffff, 0xffff8002 },
  { 0x00000000, 0x7ffffffe, 0x7ffffffe, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffe0 },
  { 0x00000000, 0xffffe000, 0xffffe000, 0xffff8002 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x7ffffffd },
  { 0x00000000, 0xcccccccc, 0xcccccccc, 0x80000000 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x33333333 },
  { 0x00000000, 0x00000000, 0x00000000, 0x00000002 },
  { 0x00000000, 0x00000000, 0x00000000, 0x0000007f },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xfffffffd },
  { 0x00000000, 0xffffff80, 0xffffff80, 0x80000000 },
  { 0x00000000, 0x00000000, 0x00000000, 0x00000020 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffff8003 },
  { 0x00000000, 0xffff8001, 0xffff8001, 0xffff8000 },
  { 0x00000000, 0x00000000, 0x00000000, 0x55555555 },
  { 0x00000000, 0x00007fff, 0x00007fff, 0xffff8000 },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffffe0 },
  { 0x00000000, 0x00000000, 0x00000000, 0x55555555 },
  { 0x00000000, 0x00000000, 0x00000000, 0x7ffffffe },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffe0 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x0000007d },
  { 0x00000000, 0xffffe000, 0xffffe000, 0x00000002 },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffff81 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffff80 },
  { 0x00000000, 0x00001fff, 0x00001fff, 0xffff8002 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xfffffffe },
  { 0x00000000, 0x00000000, 0x00000000, 0xfffffffd },
  { 0x00000000, 0x00000000, 0x00000000, 0xfffffffe },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffff83 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00007ffe },
  { 0x00000000, 0x7fffffff, 0x7fffffff, 0x80000000 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x7fffffff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffff83 },
  { 0x00000000, 0xffff8000, 0xffff8000, 0xffff8000 },
  { 0x00000000, 0x00000000, 0x00000000, 0x7fffffff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xfffffffe },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x0000007d },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xfffffffe },
  { 0x00000000, 0x00000000, 0x00000000, 0x0000007d },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xfffffffe },
  { 0x00000000, 0x00000000, 0x00000000, 0x00007ffd },
  { 0x00000000, 0xeaaaaaaa, 0xeaaaaaaa, 0xffff8002 },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffff82 },
  { 0x00000000, 0x00000000, 0x00000000, 0x33333333 },
  { 0x00000000, 0xfffffffd, 0xfffffffd, 0x80000000 },
  { 0x00000000, 0x00000000, 0x00000000, 0xfffffffd },
  { 0x00000000, 0x00000000, 0x00000000, 0x0000007f },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x0000007e },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x55555555 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x80000000 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x0000007e },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00007ffd },
  { 0x00000000, 0x00000010, 0x00000010, 0xffff8001 },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffff83 },
  { 0x00000000, 0x33333333, 0x33333333, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffff82 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x0000007e },
  { 0x00000000, 0xffffffc0, 0xffffffc0, 0x00000001 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xcccccccc },
  { 0x00000000, 0x00000000, 0x00000000, 0x00007ffd },
  { 0x00000000, 0x3fffffff, 0x3fffffff, 0x80000001 },
  { 0x00000000, 0x00000000, 0x00000000, 0x00007ffe },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xfffffffd },
  { 0x00000000, 0x3fffffff, 0x3fffffff, 0xffff8001 },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffff83 },
  { 0x00000000, 0x00000000, 0x00000000, 0x00000020 },
  { 0x00000000, 0xf0000000, 0xf0000000, 0xffff8003 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x0000007f },
  { 0x00000000, 0x0000003f, 0x0000003f, 0x80000001 },
  { 0x00000000, 0x00000000, 0x00000000, 0x7ffffffe },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffff83 },
  { 0x00000000, 0x00000000, 0x00000000, 0x7fffffff },
  { 0x00000000, 0x00000000, 0x00000000, 0xfffffffe },
  { 0x00000000, 0xffffff82, 0xffffff82, 0xffff8000 },
  { 0x00000000, 0xfffffffe, 0xfffffffe, 0xffff8000 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffff81 },
  { 0x00000000, 0x00000000, 0x00000000, 0x7fffffff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00007fff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xcccccccc },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00000002 },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffff81 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffff80 },
  { 0x00000000, 0x00000000, 0x00000000, 0xaaaaaaaa },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffff82 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xaaaaaaaa },
  { 0x00000000, 0x00000000, 0x00000000, 0x00000020 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00007ffd },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xaaaaaaaa },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xfffffffe },
  { 0x00000000, 0xaaaaaaaa, 0xaaaaaaaa, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x0000007f },
  { 0x00000000, 0x00000000, 0x00000000, 0x0000007d },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x55555555 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00000020 },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffff83 },
  { 0x00000000, 0x00000000, 0x00000000, 0x55555555 },
  { 0x00000000, 0x00000000, 0x00000000, 0xcccccccc },
  { 0x00000000, 0xfffffffc, 0xfffffffc, 0xffff8003 },
  { 0x00000000, 0x00000000, 0x00000000, 0x00007ffe },
  { 0x00000000, 0x00001fff, 0x00001fff, 0xffff8002 },
  { 0x00000000, 0x00003ffe, 0x00003ffe, 0x00000001 },
  { 0x00000000, 0x00000000, 0x00000000, 0x00007ffe },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00000020 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x0000007d },
  { 0x00000000, 0xffff8003, 0xffff8003, 0x00000000 },
  { 0x00000000, 0x0000007e, 0x0000007e, 0x80000000 },
  { 0x00000000, 0xfffffffd, 0xfffffffd, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x0000007f },
  { 0x00000000, 0x7ffffffd, 0x7ffffffd, 0x00000000 },
  { 0x00000000, 0x00007fff, 0x00007fff, 0x00000000 },
  { 0x00000000, 0x0000003f, 0x0000003f, 0x00000001 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffff82 },
  { 0x00000000, 0x00000000, 0x00000000, 0x00007ffd },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x33333333 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x55555555 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x0000007e },
  { 0x00000000, 0xffffffe0, 0xffffffe0, 0x00000002 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x33333333 },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffffff },
  { 0x00000000, 0xd5555555, 0xd5555555, 0x80000001 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffe0 },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffffe0 },
  { 0x00000000, 0x00000000, 0x00000000, 0x33333333 },
  { 0x00000000, 0x2aaaaaaa, 0x2aaaaaaa, 0x00000001 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00007fff },
  { 0x00000000, 0x00000000, 0x00000000, 0xfffffffd },
  { 0x00000000, 0xfffffff8, 0xfffffff8, 0xffff8002 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00007ffd },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xfffffffe },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00000020 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xcccccccc },
  { 0x00000000, 0x00000000, 0x00000000, 0x7fffffff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x55555555 },
  { 0x00000000, 0x00000000, 0x00000000, 0x00000020 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00007fff },
  { 0x00000000, 0x00000000, 0x00000000, 0xaaaaaaaa },
  { 0x00000000, 0x00000000, 0x00000000, 0x7fffffff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x7fffffff },
  { 0x00000000, 0x00000000, 0x00000000, 0x55555555 },
  { 0x00000000, 0x00000000, 0x00000000, 0x0000007d },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x7ffffffe },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00007ffe },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffff81 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x0000007d },
  { 0x00000000, 0x00000000, 0x00000000, 0x0000007e },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00007ffe },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x0000007e },
};
const Inputs kOutputs_Asr_RdIsRn_al_r12_r12_r10[] = {
  { 0x00000000, 0xffffffe0, 0xffffffe0, 0xffff8002 },
  { 0x00000000, 0x00000000, 0x00000000, 0x7fffffff },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffffe0 },
  { 0x00000000, 0x1fffffff, 0x1fffffff, 0x00000002 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xfffffffd },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00007fff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffff83 },
  { 0x00000000, 0xffffc001, 0xffffc001, 0x80000001 },
  { 0x00000000, 0x00000fff, 0x00000fff, 0xffff8003 },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffffff },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffff80 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x33333333 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x0000007e },
  { 0x00000000, 0x00000000, 0x00000000, 0x7ffffffd },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xfffffffd },
  { 0x00000000, 0x00000008, 0x00000008, 0xffff8002 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xfffffffe },
  { 0x00000000, 0x00000002, 0x00000002, 0x00000000 },
  { 0x00000000, 0x0000003f, 0x0000003f, 0x00000001 },
  { 0x00000000, 0x00000000, 0x00000000, 0x0000007f },
  { 0x00000000, 0x80000000, 0x80000000, 0x80000000 },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffff80 },
  { 0x00000000, 0x00000000, 0x00000000, 0xfffffffe },
  { 0x00000000, 0x00000000, 0x00000000, 0x0000007d },
  { 0x00000000, 0x00000000, 0x00000000, 0x7ffffffe },
  { 0x00000000, 0x00000000, 0x00000000, 0x7fffffff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffff83 },
  { 0x00000000, 0x00000000, 0x00000000, 0x7ffffffe },
  { 0x00000000, 0x00000000, 0x00000000, 0x0000007f },
  { 0x00000000, 0x00000000, 0x00000000, 0xcccccccc },
  { 0x00000000, 0xffffffe0, 0xffffffe0, 0x00000002 },
  { 0x00000000, 0x00000000, 0x00000000, 0xaaaaaaaa },
  { 0x00000000, 0xe6666666, 0xe6666666, 0xffff8001 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffff8001 },
  { 0x00000000, 0x00000000, 0x00000000, 0x00000020 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00007ffe },
  { 0x00000000, 0x80000001, 0x80000001, 0xffff8000 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x0000007d },
  { 0x00000000, 0x00000000, 0x00000000, 0x7ffffffe },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffff80 },
  { 0x00000000, 0x00000000, 0x00000000, 0x0000007e },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x7fffffff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x0000007f },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffff81 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x0000007e },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xaaaaaaaa },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00000020 },
  { 0x00000000, 0xfffffff0, 0xfffffff0, 0xffff8003 },
  { 0x00000000, 0x1fffffff, 0x1fffffff, 0xffff8002 },
  { 0x00000000, 0x7ffffffe, 0x7ffffffe, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffe0 },
  { 0x00000000, 0xffffe000, 0xffffe000, 0xffff8002 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x7ffffffd },
  { 0x00000000, 0xcccccccc, 0xcccccccc, 0x80000000 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x33333333 },
  { 0x00000000, 0x00000000, 0x00000000, 0x00000002 },
  { 0x00000000, 0x00000000, 0x00000000, 0x0000007f },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xfffffffd },
  { 0x00000000, 0xffffff80, 0xffffff80, 0x80000000 },
  { 0x00000000, 0x00000000, 0x00000000, 0x00000020 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffff8003 },
  { 0x00000000, 0xffff8001, 0xffff8001, 0xffff8000 },
  { 0x00000000, 0x00000000, 0x00000000, 0x55555555 },
  { 0x00000000, 0x00007fff, 0x00007fff, 0xffff8000 },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffffe0 },
  { 0x00000000, 0x00000000, 0x00000000, 0x55555555 },
  { 0x00000000, 0x00000000, 0x00000000, 0x7ffffffe },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffe0 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x0000007d },
  { 0x00000000, 0xffffe000, 0xffffe000, 0x00000002 },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffff81 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffff80 },
  { 0x00000000, 0x00001fff, 0x00001fff, 0xffff8002 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xfffffffe },
  { 0x00000000, 0x00000000, 0x00000000, 0xfffffffd },
  { 0x00000000, 0x00000000, 0x00000000, 0xfffffffe },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffff83 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00007ffe },
  { 0x00000000, 0x7fffffff, 0x7fffffff, 0x80000000 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x7fffffff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffff83 },
  { 0x00000000, 0xffff8000, 0xffff8000, 0xffff8000 },
  { 0x00000000, 0x00000000, 0x00000000, 0x7fffffff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xfffffffe },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x0000007d },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xfffffffe },
  { 0x00000000, 0x00000000, 0x00000000, 0x0000007d },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xfffffffe },
  { 0x00000000, 0x00000000, 0x00000000, 0x00007ffd },
  { 0x00000000, 0xeaaaaaaa, 0xeaaaaaaa, 0xffff8002 },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffff82 },
  { 0x00000000, 0x00000000, 0x00000000, 0x33333333 },
  { 0x00000000, 0xfffffffd, 0xfffffffd, 0x80000000 },
  { 0x00000000, 0x00000000, 0x00000000, 0xfffffffd },
  { 0x00000000, 0x00000000, 0x00000000, 0x0000007f },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x0000007e },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x55555555 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x80000000 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x0000007e },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00007ffd },
  { 0x00000000, 0x00000010, 0x00000010, 0xffff8001 },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffff83 },
  { 0x00000000, 0x33333333, 0x33333333, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffff82 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x0000007e },
  { 0x00000000, 0xffffffc0, 0xffffffc0, 0x00000001 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xcccccccc },
  { 0x00000000, 0x00000000, 0x00000000, 0x00007ffd },
  { 0x00000000, 0x3fffffff, 0x3fffffff, 0x80000001 },
  { 0x00000000, 0x00000000, 0x00000000, 0x00007ffe },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xfffffffd },
  { 0x00000000, 0x3fffffff, 0x3fffffff, 0xffff8001 },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffff83 },
  { 0x00000000, 0x00000000, 0x00000000, 0x00000020 },
  { 0x00000000, 0xf0000000, 0xf0000000, 0xffff8003 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x0000007f },
  { 0x00000000, 0x0000003f, 0x0000003f, 0x80000001 },
  { 0x00000000, 0x00000000, 0x00000000, 0x7ffffffe },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffff83 },
  { 0x00000000, 0x00000000, 0x00000000, 0x7fffffff },
  { 0x00000000, 0x00000000, 0x00000000, 0xfffffffe },
  { 0x00000000, 0xffffff82, 0xffffff82, 0xffff8000 },
  { 0x00000000, 0xfffffffe, 0xfffffffe, 0xffff8000 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffff81 },
  { 0x00000000, 0x00000000, 0x00000000, 0x7fffffff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00007fff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xcccccccc },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00000002 },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffff81 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffff80 },
  { 0x00000000, 0x00000000, 0x00000000, 0xaaaaaaaa },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffff82 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xaaaaaaaa },
  { 0x00000000, 0x00000000, 0x00000000, 0x00000020 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00007ffd },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xaaaaaaaa },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xfffffffe },
  { 0x00000000, 0xaaaaaaaa, 0xaaaaaaaa, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x0000007f },
  { 0x00000000, 0x00000000, 0x00000000, 0x0000007d },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x55555555 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00000020 },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffff83 },
  { 0x00000000, 0x00000000, 0x00000000, 0x55555555 },
  { 0x00000000, 0x00000000, 0x00000000, 0xcccccccc },
  { 0x00000000, 0xfffffffc, 0xfffffffc, 0xffff8003 },
  { 0x00000000, 0x00000000, 0x00000000, 0x00007ffe },
  { 0x00000000, 0x00001fff, 0x00001fff, 0xffff8002 },
  { 0x00000000, 0x00003ffe, 0x00003ffe, 0x00000001 },
  { 0x00000000, 0x00000000, 0x00000000, 0x00007ffe },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00000020 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x0000007d },
  { 0x00000000, 0xffff8003, 0xffff8003, 0x00000000 },
  { 0x00000000, 0x0000007e, 0x0000007e, 0x80000000 },
  { 0x00000000, 0xfffffffd, 0xfffffffd, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x0000007f },
  { 0x00000000, 0x7ffffffd, 0x7ffffffd, 0x00000000 },
  { 0x00000000, 0x00007fff, 0x00007fff, 0x00000000 },
  { 0x00000000, 0x0000003f, 0x0000003f, 0x00000001 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffff82 },
  { 0x00000000, 0x00000000, 0x00000000, 0x00007ffd },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x33333333 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x55555555 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x0000007e },
  { 0x00000000, 0xffffffe0, 0xffffffe0, 0x00000002 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x33333333 },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffffff },
  { 0x00000000, 0xd5555555, 0xd5555555, 0x80000001 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffe0 },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffffe0 },
  { 0x00000000, 0x00000000, 0x00000000, 0x33333333 },
  { 0x00000000, 0x2aaaaaaa, 0x2aaaaaaa, 0x00000001 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00007fff },
  { 0x00000000, 0x00000000, 0x00000000, 0xfffffffd },
  { 0x00000000, 0xfffffff8, 0xfffffff8, 0xffff8002 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00007ffd },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xfffffffe },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00000020 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xcccccccc },
  { 0x00000000, 0x00000000, 0x00000000, 0x7fffffff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x55555555 },
  { 0x00000000, 0x00000000, 0x00000000, 0x00000020 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00007fff },
  { 0x00000000, 0x00000000, 0x00000000, 0xaaaaaaaa },
  { 0x00000000, 0x00000000, 0x00000000, 0x7fffffff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x7fffffff },
  { 0x00000000, 0x00000000, 0x00000000, 0x55555555 },
  { 0x00000000, 0x00000000, 0x00000000, 0x0000007d },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x7ffffffe },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00007ffe },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffff81 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x0000007d },
  { 0x00000000, 0x00000000, 0x00000000, 0x0000007e },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00007ffe },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x0000007e },
};
const Inputs kOutputs_Asr_RdIsRn_al_r4_r4_r8[] = {
  { 0x00000000, 0xffffffe0, 0xffffffe0, 0xffff8002 },
  { 0x00000000, 0x00000000, 0x00000000, 0x7fffffff },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffffe0 },
  { 0x00000000, 0x1fffffff, 0x1fffffff, 0x00000002 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xfffffffd },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00007fff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffff83 },
  { 0x00000000, 0xffffc001, 0xffffc001, 0x80000001 },
  { 0x00000000, 0x00000fff, 0x00000fff, 0xffff8003 },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffffff },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffff80 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x33333333 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x0000007e },
  { 0x00000000, 0x00000000, 0x00000000, 0x7ffffffd },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xfffffffd },
  { 0x00000000, 0x00000008, 0x00000008, 0xffff8002 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xfffffffe },
  { 0x00000000, 0x00000002, 0x00000002, 0x00000000 },
  { 0x00000000, 0x0000003f, 0x0000003f, 0x00000001 },
  { 0x00000000, 0x00000000, 0x00000000, 0x0000007f },
  { 0x00000000, 0x80000000, 0x80000000, 0x80000000 },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffff80 },
  { 0x00000000, 0x00000000, 0x00000000, 0xfffffffe },
  { 0x00000000, 0x00000000, 0x00000000, 0x0000007d },
  { 0x00000000, 0x00000000, 0x00000000, 0x7ffffffe },
  { 0x00000000, 0x00000000, 0x00000000, 0x7fffffff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffff83 },
  { 0x00000000, 0x00000000, 0x00000000, 0x7ffffffe },
  { 0x00000000, 0x00000000, 0x00000000, 0x0000007f },
  { 0x00000000, 0x00000000, 0x00000000, 0xcccccccc },
  { 0x00000000, 0xffffffe0, 0xffffffe0, 0x00000002 },
  { 0x00000000, 0x00000000, 0x00000000, 0xaaaaaaaa },
  { 0x00000000, 0xe6666666, 0xe6666666, 0xffff8001 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffff8001 },
  { 0x00000000, 0x00000000, 0x00000000, 0x00000020 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00007ffe },
  { 0x00000000, 0x80000001, 0x80000001, 0xffff8000 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x0000007d },
  { 0x00000000, 0x00000000, 0x00000000, 0x7ffffffe },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffff80 },
  { 0x00000000, 0x00000000, 0x00000000, 0x0000007e },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x7fffffff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x0000007f },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffff81 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x0000007e },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xaaaaaaaa },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00000020 },
  { 0x00000000, 0xfffffff0, 0xfffffff0, 0xffff8003 },
  { 0x00000000, 0x1fffffff, 0x1fffffff, 0xffff8002 },
  { 0x00000000, 0x7ffffffe, 0x7ffffffe, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffe0 },
  { 0x00000000, 0xffffe000, 0xffffe000, 0xffff8002 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x7ffffffd },
  { 0x00000000, 0xcccccccc, 0xcccccccc, 0x80000000 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x33333333 },
  { 0x00000000, 0x00000000, 0x00000000, 0x00000002 },
  { 0x00000000, 0x00000000, 0x00000000, 0x0000007f },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xfffffffd },
  { 0x00000000, 0xffffff80, 0xffffff80, 0x80000000 },
  { 0x00000000, 0x00000000, 0x00000000, 0x00000020 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffff8003 },
  { 0x00000000, 0xffff8001, 0xffff8001, 0xffff8000 },
  { 0x00000000, 0x00000000, 0x00000000, 0x55555555 },
  { 0x00000000, 0x00007fff, 0x00007fff, 0xffff8000 },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffffe0 },
  { 0x00000000, 0x00000000, 0x00000000, 0x55555555 },
  { 0x00000000, 0x00000000, 0x00000000, 0x7ffffffe },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffe0 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x0000007d },
  { 0x00000000, 0xffffe000, 0xffffe000, 0x00000002 },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffff81 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffff80 },
  { 0x00000000, 0x00001fff, 0x00001fff, 0xffff8002 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xfffffffe },
  { 0x00000000, 0x00000000, 0x00000000, 0xfffffffd },
  { 0x00000000, 0x00000000, 0x00000000, 0xfffffffe },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffff83 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00007ffe },
  { 0x00000000, 0x7fffffff, 0x7fffffff, 0x80000000 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x7fffffff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffff83 },
  { 0x00000000, 0xffff8000, 0xffff8000, 0xffff8000 },
  { 0x00000000, 0x00000000, 0x00000000, 0x7fffffff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xfffffffe },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x0000007d },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xfffffffe },
  { 0x00000000, 0x00000000, 0x00000000, 0x0000007d },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xfffffffe },
  { 0x00000000, 0x00000000, 0x00000000, 0x00007ffd },
  { 0x00000000, 0xeaaaaaaa, 0xeaaaaaaa, 0xffff8002 },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffff82 },
  { 0x00000000, 0x00000000, 0x00000000, 0x33333333 },
  { 0x00000000, 0xfffffffd, 0xfffffffd, 0x80000000 },
  { 0x00000000, 0x00000000, 0x00000000, 0xfffffffd },
  { 0x00000000, 0x00000000, 0x00000000, 0x0000007f },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x0000007e },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x55555555 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x80000000 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x0000007e },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00007ffd },
  { 0x00000000, 0x00000010, 0x00000010, 0xffff8001 },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffff83 },
  { 0x00000000, 0x33333333, 0x33333333, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffff82 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x0000007e },
  { 0x00000000, 0xffffffc0, 0xffffffc0, 0x00000001 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xcccccccc },
  { 0x00000000, 0x00000000, 0x00000000, 0x00007ffd },
  { 0x00000000, 0x3fffffff, 0x3fffffff, 0x80000001 },
  { 0x00000000, 0x00000000, 0x00000000, 0x00007ffe },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xfffffffd },
  { 0x00000000, 0x3fffffff, 0x3fffffff, 0xffff8001 },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffff83 },
  { 0x00000000, 0x00000000, 0x00000000, 0x00000020 },
  { 0x00000000, 0xf0000000, 0xf0000000, 0xffff8003 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x0000007f },
  { 0x00000000, 0x0000003f, 0x0000003f, 0x80000001 },
  { 0x00000000, 0x00000000, 0x00000000, 0x7ffffffe },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffff83 },
  { 0x00000000, 0x00000000, 0x00000000, 0x7fffffff },
  { 0x00000000, 0x00000000, 0x00000000, 0xfffffffe },
  { 0x00000000, 0xffffff82, 0xffffff82, 0xffff8000 },
  { 0x00000000, 0xfffffffe, 0xfffffffe, 0xffff8000 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffff81 },
  { 0x00000000, 0x00000000, 0x00000000, 0x7fffffff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00007fff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xcccccccc },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00000002 },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffff81 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffff80 },
  { 0x00000000, 0x00000000, 0x00000000, 0xaaaaaaaa },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffff82 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xaaaaaaaa },
  { 0x00000000, 0x00000000, 0x00000000, 0x00000020 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00007ffd },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xaaaaaaaa },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xfffffffe },
  { 0x00000000, 0xaaaaaaaa, 0xaaaaaaaa, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x0000007f },
  { 0x00000000, 0x00000000, 0x00000000, 0x0000007d },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x55555555 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00000020 },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffff83 },
  { 0x00000000, 0x00000000, 0x00000000, 0x55555555 },
  { 0x00000000, 0x00000000, 0x00000000, 0xcccccccc },
  { 0x00000000, 0xfffffffc, 0xfffffffc, 0xffff8003 },
  { 0x00000000, 0x00000000, 0x00000000, 0x00007ffe },
  { 0x00000000, 0x00001fff, 0x00001fff, 0xffff8002 },
  { 0x00000000, 0x00003ffe, 0x00003ffe, 0x00000001 },
  { 0x00000000, 0x00000000, 0x00000000, 0x00007ffe },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00000020 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x0000007d },
  { 0x00000000, 0xffff8003, 0xffff8003, 0x00000000 },
  { 0x00000000, 0x0000007e, 0x0000007e, 0x80000000 },
  { 0x00000000, 0xfffffffd, 0xfffffffd, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x0000007f },
  { 0x00000000, 0x7ffffffd, 0x7ffffffd, 0x00000000 },
  { 0x00000000, 0x00007fff, 0x00007fff, 0x00000000 },
  { 0x00000000, 0x0000003f, 0x0000003f, 0x00000001 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffff82 },
  { 0x00000000, 0x00000000, 0x00000000, 0x00007ffd },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x33333333 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x55555555 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x0000007e },
  { 0x00000000, 0xffffffe0, 0xffffffe0, 0x00000002 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x33333333 },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffffff },
  { 0x00000000, 0xd5555555, 0xd5555555, 0x80000001 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffe0 },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffffe0 },
  { 0x00000000, 0x00000000, 0x00000000, 0x33333333 },
  { 0x00000000, 0x2aaaaaaa, 0x2aaaaaaa, 0x00000001 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00007fff },
  { 0x00000000, 0x00000000, 0x00000000, 0xfffffffd },
  { 0x00000000, 0xfffffff8, 0xfffffff8, 0xffff8002 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00007ffd },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xfffffffe },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00000020 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xcccccccc },
  { 0x00000000, 0x00000000, 0x00000000, 0x7fffffff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x55555555 },
  { 0x00000000, 0x00000000, 0x00000000, 0x00000020 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00007fff },
  { 0x00000000, 0x00000000, 0x00000000, 0xaaaaaaaa },
  { 0x00000000, 0x00000000, 0x00000000, 0x7fffffff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x7fffffff },
  { 0x00000000, 0x00000000, 0x00000000, 0x55555555 },
  { 0x00000000, 0x00000000, 0x00000000, 0x0000007d },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x7ffffffe },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00007ffe },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffff81 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x0000007d },
  { 0x00000000, 0x00000000, 0x00000000, 0x0000007e },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00007ffe },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x0000007e },
};
const Inputs kOutputs_Asr_RdIsRn_al_r5_r5_r14[] = {
  { 0x00000000, 0xffffffe0, 0xffffffe0, 0xffff8002 },
  { 0x00000000, 0x00000000, 0x00000000, 0x7fffffff },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffffe0 },
  { 0x00000000, 0x1fffffff, 0x1fffffff, 0x00000002 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xfffffffd },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00007fff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffff83 },
  { 0x00000000, 0xffffc001, 0xffffc001, 0x80000001 },
  { 0x00000000, 0x00000fff, 0x00000fff, 0xffff8003 },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffffff },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffff80 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x33333333 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x0000007e },
  { 0x00000000, 0x00000000, 0x00000000, 0x7ffffffd },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xfffffffd },
  { 0x00000000, 0x00000008, 0x00000008, 0xffff8002 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xfffffffe },
  { 0x00000000, 0x00000002, 0x00000002, 0x00000000 },
  { 0x00000000, 0x0000003f, 0x0000003f, 0x00000001 },
  { 0x00000000, 0x00000000, 0x00000000, 0x0000007f },
  { 0x00000000, 0x80000000, 0x80000000, 0x80000000 },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffff80 },
  { 0x00000000, 0x00000000, 0x00000000, 0xfffffffe },
  { 0x00000000, 0x00000000, 0x00000000, 0x0000007d },
  { 0x00000000, 0x00000000, 0x00000000, 0x7ffffffe },
  { 0x00000000, 0x00000000, 0x00000000, 0x7fffffff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffff83 },
  { 0x00000000, 0x00000000, 0x00000000, 0x7ffffffe },
  { 0x00000000, 0x00000000, 0x00000000, 0x0000007f },
  { 0x00000000, 0x00000000, 0x00000000, 0xcccccccc },
  { 0x00000000, 0xffffffe0, 0xffffffe0, 0x00000002 },
  { 0x00000000, 0x00000000, 0x00000000, 0xaaaaaaaa },
  { 0x00000000, 0xe6666666, 0xe6666666, 0xffff8001 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffff8001 },
  { 0x00000000, 0x00000000, 0x00000000, 0x00000020 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00007ffe },
  { 0x00000000, 0x80000001, 0x80000001, 0xffff8000 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x0000007d },
  { 0x00000000, 0x00000000, 0x00000000, 0x7ffffffe },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffff80 },
  { 0x00000000, 0x00000000, 0x00000000, 0x0000007e },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x7fffffff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x0000007f },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffff81 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x0000007e },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xaaaaaaaa },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00000020 },
  { 0x00000000, 0xfffffff0, 0xfffffff0, 0xffff8003 },
  { 0x00000000, 0x1fffffff, 0x1fffffff, 0xffff8002 },
  { 0x00000000, 0x7ffffffe, 0x7ffffffe, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffe0 },
  { 0x00000000, 0xffffe000, 0xffffe000, 0xffff8002 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x7ffffffd },
  { 0x00000000, 0xcccccccc, 0xcccccccc, 0x80000000 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x33333333 },
  { 0x00000000, 0x00000000, 0x00000000, 0x00000002 },
  { 0x00000000, 0x00000000, 0x00000000, 0x0000007f },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xfffffffd },
  { 0x00000000, 0xffffff80, 0xffffff80, 0x80000000 },
  { 0x00000000, 0x00000000, 0x00000000, 0x00000020 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffff8003 },
  { 0x00000000, 0xffff8001, 0xffff8001, 0xffff8000 },
  { 0x00000000, 0x00000000, 0x00000000, 0x55555555 },
  { 0x00000000, 0x00007fff, 0x00007fff, 0xffff8000 },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffffe0 },
  { 0x00000000, 0x00000000, 0x00000000, 0x55555555 },
  { 0x00000000, 0x00000000, 0x00000000, 0x7ffffffe },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffe0 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x0000007d },
  { 0x00000000, 0xffffe000, 0xffffe000, 0x00000002 },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffff81 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffff80 },
  { 0x00000000, 0x00001fff, 0x00001fff, 0xffff8002 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xfffffffe },
  { 0x00000000, 0x00000000, 0x00000000, 0xfffffffd },
  { 0x00000000, 0x00000000, 0x00000000, 0xfffffffe },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffff83 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00007ffe },
  { 0x00000000, 0x7fffffff, 0x7fffffff, 0x80000000 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x7fffffff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffff83 },
  { 0x00000000, 0xffff8000, 0xffff8000, 0xffff8000 },
  { 0x00000000, 0x00000000, 0x00000000, 0x7fffffff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xfffffffe },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x0000007d },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xfffffffe },
  { 0x00000000, 0x00000000, 0x00000000, 0x0000007d },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xfffffffe },
  { 0x00000000, 0x00000000, 0x00000000, 0x00007ffd },
  { 0x00000000, 0xeaaaaaaa, 0xeaaaaaaa, 0xffff8002 },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffff82 },
  { 0x00000000, 0x00000000, 0x00000000, 0x33333333 },
  { 0x00000000, 0xfffffffd, 0xfffffffd, 0x80000000 },
  { 0x00000000, 0x00000000, 0x00000000, 0xfffffffd },
  { 0x00000000, 0x00000000, 0x00000000, 0x0000007f },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x0000007e },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x55555555 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x80000000 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x0000007e },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00007ffd },
  { 0x00000000, 0x00000010, 0x00000010, 0xffff8001 },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffff83 },
  { 0x00000000, 0x33333333, 0x33333333, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffff82 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x0000007e },
  { 0x00000000, 0xffffffc0, 0xffffffc0, 0x00000001 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xcccccccc },
  { 0x00000000, 0x00000000, 0x00000000, 0x00007ffd },
  { 0x00000000, 0x3fffffff, 0x3fffffff, 0x80000001 },
  { 0x00000000, 0x00000000, 0x00000000, 0x00007ffe },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xfffffffd },
  { 0x00000000, 0x3fffffff, 0x3fffffff, 0xffff8001 },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffff83 },
  { 0x00000000, 0x00000000, 0x00000000, 0x00000020 },
  { 0x00000000, 0xf0000000, 0xf0000000, 0xffff8003 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x0000007f },
  { 0x00000000, 0x0000003f, 0x0000003f, 0x80000001 },
  { 0x00000000, 0x00000000, 0x00000000, 0x7ffffffe },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffff83 },
  { 0x00000000, 0x00000000, 0x00000000, 0x7fffffff },
  { 0x00000000, 0x00000000, 0x00000000, 0xfffffffe },
  { 0x00000000, 0xffffff82, 0xffffff82, 0xffff8000 },
  { 0x00000000, 0xfffffffe, 0xfffffffe, 0xffff8000 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffff81 },
  { 0x00000000, 0x00000000, 0x00000000, 0x7fffffff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00007fff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xcccccccc },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00000002 },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffff81 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffff80 },
  { 0x00000000, 0x00000000, 0x00000000, 0xaaaaaaaa },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffff82 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xaaaaaaaa },
  { 0x00000000, 0x00000000, 0x00000000, 0x00000020 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00007ffd },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xaaaaaaaa },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xfffffffe },
  { 0x00000000, 0xaaaaaaaa, 0xaaaaaaaa, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x0000007f },
  { 0x00000000, 0x00000000, 0x00000000, 0x0000007d },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x55555555 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00000020 },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffff83 },
  { 0x00000000, 0x00000000, 0x00000000, 0x55555555 },
  { 0x00000000, 0x00000000, 0x00000000, 0xcccccccc },
  { 0x00000000, 0xfffffffc, 0xfffffffc, 0xffff8003 },
  { 0x00000000, 0x00000000, 0x00000000, 0x00007ffe },
  { 0x00000000, 0x00001fff, 0x00001fff, 0xffff8002 },
  { 0x00000000, 0x00003ffe, 0x00003ffe, 0x00000001 },
  { 0x00000000, 0x00000000, 0x00000000, 0x00007ffe },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00000020 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x0000007d },
  { 0x00000000, 0xffff8003, 0xffff8003, 0x00000000 },
  { 0x00000000, 0x0000007e, 0x0000007e, 0x80000000 },
  { 0x00000000, 0xfffffffd, 0xfffffffd, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x0000007f },
  { 0x00000000, 0x7ffffffd, 0x7ffffffd, 0x00000000 },
  { 0x00000000, 0x00007fff, 0x00007fff, 0x00000000 },
  { 0x00000000, 0x0000003f, 0x0000003f, 0x00000001 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffff82 },
  { 0x00000000, 0x00000000, 0x00000000, 0x00007ffd },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x33333333 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x55555555 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x0000007e },
  { 0x00000000, 0xffffffe0, 0xffffffe0, 0x00000002 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x33333333 },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffffff },
  { 0x00000000, 0xd5555555, 0xd5555555, 0x80000001 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffe0 },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffffe0 },
  { 0x00000000, 0x00000000, 0x00000000, 0x33333333 },
  { 0x00000000, 0x2aaaaaaa, 0x2aaaaaaa, 0x00000001 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00007fff },
  { 0x00000000, 0x00000000, 0x00000000, 0xfffffffd },
  { 0x00000000, 0xfffffff8, 0xfffffff8, 0xffff8002 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00007ffd },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xfffffffe },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00000020 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xcccccccc },
  { 0x00000000, 0x00000000, 0x00000000, 0x7fffffff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x55555555 },
  { 0x00000000, 0x00000000, 0x00000000, 0x00000020 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00007fff },
  { 0x00000000, 0x00000000, 0x00000000, 0xaaaaaaaa },
  { 0x00000000, 0x00000000, 0x00000000, 0x7fffffff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x7fffffff },
  { 0x00000000, 0x00000000, 0x00000000, 0x55555555 },
  { 0x00000000, 0x00000000, 0x00000000, 0x0000007d },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x7ffffffe },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00007ffe },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffff81 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x0000007d },
  { 0x00000000, 0x00000000, 0x00000000, 0x0000007e },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00007ffe },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x0000007e },
};
const Inputs kOutputs_Asr_RdIsRn_al_r0_r0_r6[] = {
  { 0x00000000, 0xffffffe0, 0xffffffe0, 0xffff8002 },
  { 0x00000000, 0x00000000, 0x00000000, 0x7fffffff },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffffe0 },
  { 0x00000000, 0x1fffffff, 0x1fffffff, 0x00000002 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xfffffffd },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00007fff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffff83 },
  { 0x00000000, 0xffffc001, 0xffffc001, 0x80000001 },
  { 0x00000000, 0x00000fff, 0x00000fff, 0xffff8003 },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffffff },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffff80 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x33333333 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x0000007e },
  { 0x00000000, 0x00000000, 0x00000000, 0x7ffffffd },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xfffffffd },
  { 0x00000000, 0x00000008, 0x00000008, 0xffff8002 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xfffffffe },
  { 0x00000000, 0x00000002, 0x00000002, 0x00000000 },
  { 0x00000000, 0x0000003f, 0x0000003f, 0x00000001 },
  { 0x00000000, 0x00000000, 0x00000000, 0x0000007f },
  { 0x00000000, 0x80000000, 0x80000000, 0x80000000 },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffff80 },
  { 0x00000000, 0x00000000, 0x00000000, 0xfffffffe },
  { 0x00000000, 0x00000000, 0x00000000, 0x0000007d },
  { 0x00000000, 0x00000000, 0x00000000, 0x7ffffffe },
  { 0x00000000, 0x00000000, 0x00000000, 0x7fffffff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffff83 },
  { 0x00000000, 0x00000000, 0x00000000, 0x7ffffffe },
  { 0x00000000, 0x00000000, 0x00000000, 0x0000007f },
  { 0x00000000, 0x00000000, 0x00000000, 0xcccccccc },
  { 0x00000000, 0xffffffe0, 0xffffffe0, 0x00000002 },
  { 0x00000000, 0x00000000, 0x00000000, 0xaaaaaaaa },
  { 0x00000000, 0xe6666666, 0xe6666666, 0xffff8001 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffff8001 },
  { 0x00000000, 0x00000000, 0x00000000, 0x00000020 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00007ffe },
  { 0x00000000, 0x80000001, 0x80000001, 0xffff8000 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x0000007d },
  { 0x00000000, 0x00000000, 0x00000000, 0x7ffffffe },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffff80 },
  { 0x00000000, 0x00000000, 0x00000000, 0x0000007e },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x7fffffff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x0000007f },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffff81 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x0000007e },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xaaaaaaaa },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00000020 },
  { 0x00000000, 0xfffffff0, 0xfffffff0, 0xffff8003 },
  { 0x00000000, 0x1fffffff, 0x1fffffff, 0xffff8002 },
  { 0x00000000, 0x7ffffffe, 0x7ffffffe, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffe0 },
  { 0x00000000, 0xffffe000, 0xffffe000, 0xffff8002 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x7ffffffd },
  { 0x00000000, 0xcccccccc, 0xcccccccc, 0x80000000 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x33333333 },
  { 0x00000000, 0x00000000, 0x00000000, 0x00000002 },
  { 0x00000000, 0x00000000, 0x00000000, 0x0000007f },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xfffffffd },
  { 0x00000000, 0xffffff80, 0xffffff80, 0x80000000 },
  { 0x00000000, 0x00000000, 0x00000000, 0x00000020 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffff8003 },
  { 0x00000000, 0xffff8001, 0xffff8001, 0xffff8000 },
  { 0x00000000, 0x00000000, 0x00000000, 0x55555555 },
  { 0x00000000, 0x00007fff, 0x00007fff, 0xffff8000 },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffffe0 },
  { 0x00000000, 0x00000000, 0x00000000, 0x55555555 },
  { 0x00000000, 0x00000000, 0x00000000, 0x7ffffffe },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffe0 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x0000007d },
  { 0x00000000, 0xffffe000, 0xffffe000, 0x00000002 },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffff81 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffff80 },
  { 0x00000000, 0x00001fff, 0x00001fff, 0xffff8002 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xfffffffe },
  { 0x00000000, 0x00000000, 0x00000000, 0xfffffffd },
  { 0x00000000, 0x00000000, 0x00000000, 0xfffffffe },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffff83 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00007ffe },
  { 0x00000000, 0x7fffffff, 0x7fffffff, 0x80000000 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x7fffffff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffff83 },
  { 0x00000000, 0xffff8000, 0xffff8000, 0xffff8000 },
  { 0x00000000, 0x00000000, 0x00000000, 0x7fffffff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xfffffffe },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x0000007d },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xfffffffe },
  { 0x00000000, 0x00000000, 0x00000000, 0x0000007d },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xfffffffe },
  { 0x00000000, 0x00000000, 0x00000000, 0x00007ffd },
  { 0x00000000, 0xeaaaaaaa, 0xeaaaaaaa, 0xffff8002 },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffff82 },
  { 0x00000000, 0x00000000, 0x00000000, 0x33333333 },
  { 0x00000000, 0xfffffffd, 0xfffffffd, 0x80000000 },
  { 0x00000000, 0x00000000, 0x00000000, 0xfffffffd },
  { 0x00000000, 0x00000000, 0x00000000, 0x0000007f },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x0000007e },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x55555555 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x80000000 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x0000007e },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00007ffd },
  { 0x00000000, 0x00000010, 0x00000010, 0xffff8001 },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffff83 },
  { 0x00000000, 0x33333333, 0x33333333, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffff82 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x0000007e },
  { 0x00000000, 0xffffffc0, 0xffffffc0, 0x00000001 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xcccccccc },
  { 0x00000000, 0x00000000, 0x00000000, 0x00007ffd },
  { 0x00000000, 0x3fffffff, 0x3fffffff, 0x80000001 },
  { 0x00000000, 0x00000000, 0x00000000, 0x00007ffe },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xfffffffd },
  { 0x00000000, 0x3fffffff, 0x3fffffff, 0xffff8001 },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffff83 },
  { 0x00000000, 0x00000000, 0x00000000, 0x00000020 },
  { 0x00000000, 0xf0000000, 0xf0000000, 0xffff8003 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x0000007f },
  { 0x00000000, 0x0000003f, 0x0000003f, 0x80000001 },
  { 0x00000000, 0x00000000, 0x00000000, 0x7ffffffe },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffff83 },
  { 0x00000000, 0x00000000, 0x00000000, 0x7fffffff },
  { 0x00000000, 0x00000000, 0x00000000, 0xfffffffe },
  { 0x00000000, 0xffffff82, 0xffffff82, 0xffff8000 },
  { 0x00000000, 0xfffffffe, 0xfffffffe, 0xffff8000 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffff81 },
  { 0x00000000, 0x00000000, 0x00000000, 0x7fffffff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00007fff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xcccccccc },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00000002 },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffff81 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffff80 },
  { 0x00000000, 0x00000000, 0x00000000, 0xaaaaaaaa },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffff82 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xaaaaaaaa },
  { 0x00000000, 0x00000000, 0x00000000, 0x00000020 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00007ffd },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xaaaaaaaa },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xfffffffe },
  { 0x00000000, 0xaaaaaaaa, 0xaaaaaaaa, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x0000007f },
  { 0x00000000, 0x00000000, 0x00000000, 0x0000007d },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x55555555 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00000020 },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffff83 },
  { 0x00000000, 0x00000000, 0x00000000, 0x55555555 },
  { 0x00000000, 0x00000000, 0x00000000, 0xcccccccc },
  { 0x00000000, 0xfffffffc, 0xfffffffc, 0xffff8003 },
  { 0x00000000, 0x00000000, 0x00000000, 0x00007ffe },
  { 0x00000000, 0x00001fff, 0x00001fff, 0xffff8002 },
  { 0x00000000, 0x00003ffe, 0x00003ffe, 0x00000001 },
  { 0x00000000, 0x00000000, 0x00000000, 0x00007ffe },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00000020 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x0000007d },
  { 0x00000000, 0xffff8003, 0xffff8003, 0x00000000 },
  { 0x00000000, 0x0000007e, 0x0000007e, 0x80000000 },
  { 0x00000000, 0xfffffffd, 0xfffffffd, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x0000007f },
  { 0x00000000, 0x7ffffffd, 0x7ffffffd, 0x00000000 },
  { 0x00000000, 0x00007fff, 0x00007fff, 0x00000000 },
  { 0x00000000, 0x0000003f, 0x0000003f, 0x00000001 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffff82 },
  { 0x00000000, 0x00000000, 0x00000000, 0x00007ffd },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x33333333 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x55555555 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x0000007e },
  { 0x00000000, 0xffffffe0, 0xffffffe0, 0x00000002 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x33333333 },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffffff },
  { 0x00000000, 0xd5555555, 0xd5555555, 0x80000001 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffe0 },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffffe0 },
  { 0x00000000, 0x00000000, 0x00000000, 0x33333333 },
  { 0x00000000, 0x2aaaaaaa, 0x2aaaaaaa, 0x00000001 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00007fff },
  { 0x00000000, 0x00000000, 0x00000000, 0xfffffffd },
  { 0x00000000, 0xfffffff8, 0xfffffff8, 0xffff8002 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00007ffd },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xfffffffe },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00000020 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xcccccccc },
  { 0x00000000, 0x00000000, 0x00000000, 0x7fffffff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x55555555 },
  { 0x00000000, 0x00000000, 0x00000000, 0x00000020 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00007fff },
  { 0x00000000, 0x00000000, 0x00000000, 0xaaaaaaaa },
  { 0x00000000, 0x00000000, 0x00000000, 0x7fffffff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x7fffffff },
  { 0x00000000, 0x00000000, 0x00000000, 0x55555555 },
  { 0x00000000, 0x00000000, 0x00000000, 0x0000007d },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x7ffffffe },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00007ffe },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffff81 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x0000007d },
  { 0x00000000, 0x00000000, 0x00000000, 0x0000007e },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00007ffe },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x0000007e },
};
const Inputs kOutputs_Asr_RdIsRn_al_r12_r12_r1[] = {
  { 0x00000000, 0xffffffe0, 0xffffffe0, 0xffff8002 },
  { 0x00000000, 0x00000000, 0x00000000, 0x7fffffff },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffffe0 },
  { 0x00000000, 0x1fffffff, 0x1fffffff, 0x00000002 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xfffffffd },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00007fff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffff83 },
  { 0x00000000, 0xffffc001, 0xffffc001, 0x80000001 },
  { 0x00000000, 0x00000fff, 0x00000fff, 0xffff8003 },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffffff },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffff80 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x33333333 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x0000007e },
  { 0x00000000, 0x00000000, 0x00000000, 0x7ffffffd },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xfffffffd },
  { 0x00000000, 0x00000008, 0x00000008, 0xffff8002 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xfffffffe },
  { 0x00000000, 0x00000002, 0x00000002, 0x00000000 },
  { 0x00000000, 0x0000003f, 0x0000003f, 0x00000001 },
  { 0x00000000, 0x00000000, 0x00000000, 0x0000007f },
  { 0x00000000, 0x80000000, 0x80000000, 0x80000000 },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffff80 },
  { 0x00000000, 0x00000000, 0x00000000, 0xfffffffe },
  { 0x00000000, 0x00000000, 0x00000000, 0x0000007d },
  { 0x00000000, 0x00000000, 0x00000000, 0x7ffffffe },
  { 0x00000000, 0x00000000, 0x00000000, 0x7fffffff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffff83 },
  { 0x00000000, 0x00000000, 0x00000000, 0x7ffffffe },
  { 0x00000000, 0x00000000, 0x00000000, 0x0000007f },
  { 0x00000000, 0x00000000, 0x00000000, 0xcccccccc },
  { 0x00000000, 0xffffffe0, 0xffffffe0, 0x00000002 },
  { 0x00000000, 0x00000000, 0x00000000, 0xaaaaaaaa },
  { 0x00000000, 0xe6666666, 0xe6666666, 0xffff8001 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffff8001 },
  { 0x00000000, 0x00000000, 0x00000000, 0x00000020 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00007ffe },
  { 0x00000000, 0x80000001, 0x80000001, 0xffff8000 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x0000007d },
  { 0x00000000, 0x00000000, 0x00000000, 0x7ffffffe },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffff80 },
  { 0x00000000, 0x00000000, 0x00000000, 0x0000007e },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x7fffffff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x0000007f },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffff81 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x0000007e },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xaaaaaaaa },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00000020 },
  { 0x00000000, 0xfffffff0, 0xfffffff0, 0xffff8003 },
  { 0x00000000, 0x1fffffff, 0x1fffffff, 0xffff8002 },
  { 0x00000000, 0x7ffffffe, 0x7ffffffe, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffe0 },
  { 0x00000000, 0xffffe000, 0xffffe000, 0xffff8002 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x7ffffffd },
  { 0x00000000, 0xcccccccc, 0xcccccccc, 0x80000000 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x33333333 },
  { 0x00000000, 0x00000000, 0x00000000, 0x00000002 },
  { 0x00000000, 0x00000000, 0x00000000, 0x0000007f },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xfffffffd },
  { 0x00000000, 0xffffff80, 0xffffff80, 0x80000000 },
  { 0x00000000, 0x00000000, 0x00000000, 0x00000020 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffff8003 },
  { 0x00000000, 0xffff8001, 0xffff8001, 0xffff8000 },
  { 0x00000000, 0x00000000, 0x00000000, 0x55555555 },
  { 0x00000000, 0x00007fff, 0x00007fff, 0xffff8000 },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffffe0 },
  { 0x00000000, 0x00000000, 0x00000000, 0x55555555 },
  { 0x00000000, 0x00000000, 0x00000000, 0x7ffffffe },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffe0 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x0000007d },
  { 0x00000000, 0xffffe000, 0xffffe000, 0x00000002 },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffff81 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffff80 },
  { 0x00000000, 0x00001fff, 0x00001fff, 0xffff8002 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xfffffffe },
  { 0x00000000, 0x00000000, 0x00000000, 0xfffffffd },
  { 0x00000000, 0x00000000, 0x00000000, 0xfffffffe },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffff83 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00007ffe },
  { 0x00000000, 0x7fffffff, 0x7fffffff, 0x80000000 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x7fffffff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffff83 },
  { 0x00000000, 0xffff8000, 0xffff8000, 0xffff8000 },
  { 0x00000000, 0x00000000, 0x00000000, 0x7fffffff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xfffffffe },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x0000007d },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xfffffffe },
  { 0x00000000, 0x00000000, 0x00000000, 0x0000007d },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xfffffffe },
  { 0x00000000, 0x00000000, 0x00000000, 0x00007ffd },
  { 0x00000000, 0xeaaaaaaa, 0xeaaaaaaa, 0xffff8002 },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffff82 },
  { 0x00000000, 0x00000000, 0x00000000, 0x33333333 },
  { 0x00000000, 0xfffffffd, 0xfffffffd, 0x80000000 },
  { 0x00000000, 0x00000000, 0x00000000, 0xfffffffd },
  { 0x00000000, 0x00000000, 0x00000000, 0x0000007f },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x0000007e },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x55555555 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x80000000 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x0000007e },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00007ffd },
  { 0x00000000, 0x00000010, 0x00000010, 0xffff8001 },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffff83 },
  { 0x00000000, 0x33333333, 0x33333333, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffff82 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x0000007e },
  { 0x00000000, 0xffffffc0, 0xffffffc0, 0x00000001 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xcccccccc },
  { 0x00000000, 0x00000000, 0x00000000, 0x00007ffd },
  { 0x00000000, 0x3fffffff, 0x3fffffff, 0x80000001 },
  { 0x00000000, 0x00000000, 0x00000000, 0x00007ffe },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xfffffffd },
  { 0x00000000, 0x3fffffff, 0x3fffffff, 0xffff8001 },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffff83 },
  { 0x00000000, 0x00000000, 0x00000000, 0x00000020 },
  { 0x00000000, 0xf0000000, 0xf0000000, 0xffff8003 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x0000007f },
  { 0x00000000, 0x0000003f, 0x0000003f, 0x80000001 },
  { 0x00000000, 0x00000000, 0x00000000, 0x7ffffffe },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffff83 },
  { 0x00000000, 0x00000000, 0x00000000, 0x7fffffff },
  { 0x00000000, 0x00000000, 0x00000000, 0xfffffffe },
  { 0x00000000, 0xffffff82, 0xffffff82, 0xffff8000 },
  { 0x00000000, 0xfffffffe, 0xfffffffe, 0xffff8000 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffff81 },
  { 0x00000000, 0x00000000, 0x00000000, 0x7fffffff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00007fff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xcccccccc },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00000002 },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffff81 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffff80 },
  { 0x00000000, 0x00000000, 0x00000000, 0xaaaaaaaa },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffff82 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xaaaaaaaa },
  { 0x00000000, 0x00000000, 0x00000000, 0x00000020 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00007ffd },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xaaaaaaaa },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xfffffffe },
  { 0x00000000, 0xaaaaaaaa, 0xaaaaaaaa, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x0000007f },
  { 0x00000000, 0x00000000, 0x00000000, 0x0000007d },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x55555555 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00000020 },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffff83 },
  { 0x00000000, 0x00000000, 0x00000000, 0x55555555 },
  { 0x00000000, 0x00000000, 0x00000000, 0xcccccccc },
  { 0x00000000, 0xfffffffc, 0xfffffffc, 0xffff8003 },
  { 0x00000000, 0x00000000, 0x00000000, 0x00007ffe },
  { 0x00000000, 0x00001fff, 0x00001fff, 0xffff8002 },
  { 0x00000000, 0x00003ffe, 0x00003ffe, 0x00000001 },
  { 0x00000000, 0x00000000, 0x00000000, 0x00007ffe },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00000020 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x0000007d },
  { 0x00000000, 0xffff8003, 0xffff8003, 0x00000000 },
  { 0x00000000, 0x0000007e, 0x0000007e, 0x80000000 },
  { 0x00000000, 0xfffffffd, 0xfffffffd, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x0000007f },
  { 0x00000000, 0x7ffffffd, 0x7ffffffd, 0x00000000 },
  { 0x00000000, 0x00007fff, 0x00007fff, 0x00000000 },
  { 0x00000000, 0x0000003f, 0x0000003f, 0x00000001 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffff82 },
  { 0x00000000, 0x00000000, 0x00000000, 0x00007ffd },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x33333333 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x55555555 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x0000007e },
  { 0x00000000, 0xffffffe0, 0xffffffe0, 0x00000002 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x33333333 },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffffff },
  { 0x00000000, 0xd5555555, 0xd5555555, 0x80000001 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffe0 },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffffe0 },
  { 0x00000000, 0x00000000, 0x00000000, 0x33333333 },
  { 0x00000000, 0x2aaaaaaa, 0x2aaaaaaa, 0x00000001 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00007fff },
  { 0x00000000, 0x00000000, 0x00000000, 0xfffffffd },
  { 0x00000000, 0xfffffff8, 0xfffffff8, 0xffff8002 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00007ffd },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xfffffffe },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00000020 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xcccccccc },
  { 0x00000000, 0x00000000, 0x00000000, 0x7fffffff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x55555555 },
  { 0x00000000, 0x00000000, 0x00000000, 0x00000020 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00007fff },
  { 0x00000000, 0x00000000, 0x00000000, 0xaaaaaaaa },
  { 0x00000000, 0x00000000, 0x00000000, 0x7fffffff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x7fffffff },
  { 0x00000000, 0x00000000, 0x00000000, 0x55555555 },
  { 0x00000000, 0x00000000, 0x00000000, 0x0000007d },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x7ffffffe },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00007ffe },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffff81 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x0000007d },
  { 0x00000000, 0x00000000, 0x00000000, 0x0000007e },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00007ffe },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x0000007e },
};
const Inputs kOutputs_Asr_RdIsRm_al_r6_r11_r6[] = {
  { 0x00000000, 0x00000000, 0x7ffffffe, 0x00000000 },
  { 0x00000000, 0x00000000, 0x00000001, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffffff82, 0xffffffff },
  { 0x00000000, 0xffff8003, 0xffff8003, 0xffff8003 },
  { 0x00000000, 0x00000000, 0x00000000, 0x00000000 },
  { 0x00000000, 0x00000000, 0x00007fff, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffff8002, 0xffffffff },
  { 0x00000000, 0xffff8000, 0xffff8000, 0xffff8000 },
  { 0x00000000, 0x00000000, 0x00000020, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffffff81, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffff82, 0xffffffff },
  { 0x00000000, 0x00000000, 0x00007fff, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffff8000, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffff83, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x00000000, 0x0ccccccc, 0x33333333, 0x0ccccccc },
  { 0x00000000, 0xffffffff, 0xaaaaaaaa, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffff8000, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffff83, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffff82, 0xffffffff },
  { 0x00000000, 0x00000000, 0x0000007d, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x00000000, 0x00000000, 0x0000007f, 0x00000000 },
  { 0x00000000, 0xffffff83, 0xffffff83, 0xffffff83 },
  { 0x00000000, 0xffffffff, 0xffffffe0, 0xffffffff },
  { 0x00000000, 0xffffffff, 0x80000001, 0xffffffff },
  { 0x00000000, 0xffffffff, 0x80000000, 0xffffffff },
  { 0x00000000, 0x0000007d, 0x0000007d, 0x0000007d },
  { 0x00000000, 0xffffffff, 0xffff8003, 0xffffffff },
  { 0x00000000, 0x00003ffe, 0x00007ffd, 0x00003ffe },
  { 0x00000000, 0x00000000, 0x7ffffffe, 0x00000000 },
  { 0x00000000, 0x00000000, 0x00007ffd, 0x00000000 },
  { 0x00000000, 0x00000000, 0x7ffffffd, 0x00000000 },
  { 0x00000000, 0x00000000, 0x0000007f, 0x00000000 },
  { 0x00000000, 0x0000003f, 0x0000007e, 0x0000003f },
  { 0x00000000, 0xffffffff, 0xfffffffd, 0xffffffff },
  { 0x00000000, 0x0fffffff, 0x7ffffffe, 0x0fffffff },
  { 0x00000000, 0x00000000, 0x00000002, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffff8001, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xfffffffe, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffff81, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffff81, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffff81, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xcccccccc, 0xffffffff },
  { 0x00000000, 0x00000000, 0x55555555, 0x00000000 },
  { 0x00000000, 0x00000fff, 0x00007ffd, 0x00000fff },
  { 0x00000000, 0xc0000000, 0x80000001, 0xc0000000 },
  { 0x00000000, 0xffffffff, 0xfffffffd, 0xffffffff },
  { 0x00000000, 0xfffffffe, 0xfffffffe, 0xfffffffe },
  { 0x00000000, 0x00000000, 0x0000007f, 0x00000000 },
  { 0x00000000, 0x00000001, 0x00000002, 0x00000001 },
  { 0x00000000, 0xffffffff, 0xffffff81, 0xffffffff },
  { 0x00000000, 0x00000000, 0x00007ffd, 0x00000000 },
  { 0x00000000, 0x19999999, 0x33333333, 0x19999999 },
  { 0x00000000, 0xffffffff, 0xffff8002, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xfffffffd, 0xffffffff },
  { 0x00000000, 0x00000000, 0x00000020, 0x00000000 },
  { 0x00000000, 0xffffc001, 0xffff8003, 0xffffc001 },
  { 0x00000000, 0xc0000000, 0x80000001, 0xc0000000 },
  { 0x00000000, 0x00000000, 0x00000002, 0x00000000 },
  { 0x00000000, 0x0fffffff, 0x7ffffffd, 0x0fffffff },
  { 0x00000000, 0xffffffff, 0xaaaaaaaa, 0xffffffff },
  { 0x00000000, 0x00000000, 0x7fffffff, 0x00000000 },
  { 0x00000000, 0x00000000, 0x00007ffe, 0x00000000 },
  { 0x00000000, 0xffffffff, 0x80000001, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xfffffffe, 0xffffffff },
  { 0x00000000, 0xffffffc0, 0xffffff80, 0xffffffc0 },
  { 0x00000000, 0xffffffff, 0xcccccccc, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffffe0, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xfffffffe, 0xffffffff },
  { 0x00000000, 0x00000000, 0x00007ffe, 0x00000000 },
  { 0x00000000, 0xffffffff, 0x80000001, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffff8001, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffff83, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xcccccccc, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffff83, 0xffffffff },
  { 0x00000000, 0xffffffff, 0x80000000, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffff8000, 0xffffffff },
  { 0x00000000, 0x00000000, 0x33333333, 0x00000000 },
  { 0x00000000, 0x00000000, 0x7ffffffd, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffff8001, 0xffffffff },
  { 0x00000000, 0xeaaaaaaa, 0xaaaaaaaa, 0xeaaaaaaa },
  { 0x00000000, 0x00000000, 0x7fffffff, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xfffffffe, 0xffffffff },
  { 0x00000000, 0x00000000, 0x00000001, 0x00000000 },
  { 0x00000000, 0x00000000, 0x00000001, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffffff80, 0xffffffff },
  { 0x00000000, 0x00000000, 0x00007fff, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xaaaaaaaa, 0xffffffff },
  { 0x00000000, 0x00001fff, 0x00007ffe, 0x00001fff },
  { 0x00000000, 0xe6666666, 0xcccccccc, 0xe6666666 },
  { 0x00000000, 0x00000000, 0x00000000, 0x00000000 },
  { 0x00000000, 0xffffc000, 0xffff8000, 0xffffc000 },
  { 0x00000000, 0x00000000, 0x00007fff, 0x00000000 },
  { 0x00000000, 0x00000000, 0x00007fff, 0x00000000 },
  { 0x00000000, 0x00000000, 0x00000001, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffff8002, 0xffffffff },
  { 0x00000000, 0x00000000, 0x7ffffffe, 0x00000000 },
  { 0x00000000, 0xd5555555, 0xaaaaaaaa, 0xd5555555 },
  { 0x00000000, 0xe6666666, 0xcccccccc, 0xe6666666 },
  { 0x00000000, 0xffffffff, 0xffffffe0, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xfffffffd, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xaaaaaaaa, 0xffffffff },
  { 0x00000000, 0x00000000, 0x00000001, 0x00000000 },
  { 0x00000000, 0x00000000, 0x00007fff, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xfffffffd, 0xffffffff },
  { 0x00000000, 0x00000000, 0x0000007d, 0x00000000 },
  { 0x00000000, 0x00000000, 0x7fffffff, 0x00000000 },
  { 0x00000000, 0x00000000, 0x0000007d, 0x00000000 },
  { 0x00000000, 0xffffffc0, 0xffffff81, 0xffffffc0 },
  { 0x00000000, 0x00000002, 0x00000002, 0x00000002 },
  { 0x00000000, 0xffffffff, 0xffff8003, 0xffffffff },
  { 0x00000000, 0x00000000, 0x00007ffd, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xaaaaaaaa, 0xffffffff },
  { 0x00000000, 0xffff8000, 0xffff8000, 0xffff8000 },
  { 0x00000000, 0x00000000, 0x00000002, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffffff83, 0xffffffff },
  { 0x00000000, 0x00000000, 0x00007ffe, 0x00000000 },
  { 0x00000000, 0x0000007d, 0x0000007d, 0x0000007d },
  { 0x00000000, 0x00000000, 0x00000002, 0x00000000 },
  { 0x00000000, 0xffffffff, 0x80000001, 0xffffffff },
  { 0x00000000, 0x00000000, 0x00007ffd, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffffff83, 0xffffffff },
  { 0x00000000, 0xc0000000, 0x80000000, 0xc0000000 },
  { 0x00000000, 0x80000000, 0x80000000, 0x80000000 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x00000000, 0xffffff83, 0xffffff83, 0xffffff83 },
  { 0x00000000, 0xffffffff, 0xffffff80, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffff8001, 0xffffffff },
  { 0x00000000, 0xffffc001, 0xffff8003, 0xffffc001 },
  { 0x00000000, 0x00000000, 0x7fffffff, 0x00000000 },
  { 0x00000000, 0x00000000, 0x00000002, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffff8003, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xcccccccc, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffff80, 0xffffffff },
  { 0x00000000, 0x00003ffe, 0x00007ffd, 0x00003ffe },
  { 0x00000000, 0x80000001, 0x80000001, 0x80000001 },
  { 0x00000000, 0x00000000, 0x00007ffd, 0x00000000 },
  { 0x00000000, 0x00000000, 0x0000007f, 0x00000000 },
  { 0x00000000, 0x0000001f, 0x0000007d, 0x0000001f },
  { 0x00000000, 0x3fffffff, 0x7fffffff, 0x3fffffff },
  { 0x00000000, 0xffffffff, 0xffffff81, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffff8001, 0xffffffff },
  { 0x00000000, 0xffffffff, 0x80000001, 0xffffffff },
  { 0x00000000, 0x00000000, 0x0000007f, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffffff81, 0xffffffff },
  { 0x00000000, 0xfffffffe, 0xfffffffd, 0xfffffffe },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x00000000, 0x00000000, 0x55555555, 0x00000000 },
  { 0x00000000, 0x00000000, 0x0000007f, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffff8003, 0xffffffff },
  { 0x00000000, 0x00000000, 0x00007ffd, 0x00000000 },
  { 0x00000000, 0x00000000, 0x33333333, 0x00000000 },
  { 0x00000000, 0xffffffff, 0x80000001, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffff8000, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffff81, 0xffffffff },
  { 0x00000000, 0x00000000, 0x0000007f, 0x00000000 },
  { 0x00000000, 0x0000000f, 0x0000007f, 0x0000000f },
  { 0x00000000, 0x00000000, 0x00007ffd, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xcccccccc, 0xffffffff },
  { 0x00000000, 0x00000000, 0x7ffffffd, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xcccccccc, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xfffffffd, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xcccccccc, 0xffffffff },
  { 0x00000000, 0x00000000, 0x00007fff, 0x00000000 },
  { 0x00000000, 0x00000000, 0x33333333, 0x00000000 },
  { 0x00000000, 0x00000000, 0x0000007d, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffffffe0, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffff8000, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x00000000, 0x7ffffffd, 0x7ffffffd, 0x7ffffffd },
  { 0x00000000, 0x00000000, 0x0000007e, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffff8003, 0xffffffff },
  { 0x00000000, 0x00000000, 0x00000002, 0x00000000 },
  { 0x00000000, 0x00000000, 0x00000001, 0x00000000 },
  { 0x00000000, 0x00000000, 0x33333333, 0x00000000 },
  { 0x00000000, 0x00000000, 0x00000001, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffff8000, 0xffffffff },
  { 0x00000000, 0x00000000, 0x55555555, 0x00000000 },
  { 0x00000000, 0x7ffffffe, 0x7ffffffe, 0x7ffffffe },
  { 0x00000000, 0xffffffff, 0xffffffe0, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffff8003, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xaaaaaaaa, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffff80, 0xffffffff },
  { 0x00000000, 0xffffffff, 0x80000001, 0xffffffff },
  { 0x00000000, 0x00007ffd, 0x00007ffd, 0x00007ffd },
  { 0x00000000, 0xffffffff, 0xffffff80, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xcccccccc, 0xffffffff },
  { 0x00000000, 0x00000000, 0x55555555, 0x00000000 },
  { 0x00000000, 0xffff8000, 0xffff8000, 0xffff8000 },
  { 0x00000000, 0xffffffff, 0xffff8000, 0xffffffff },
  { 0x00000000, 0x0000003e, 0x0000007d, 0x0000003e },
  { 0x00000000, 0xffffffff, 0xffff8002, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffffe0, 0xffffffff },
  { 0x00000000, 0xffff8003, 0xffff8003, 0xffff8003 },
  { 0x00000000, 0xffffffc0, 0xffffff81, 0xffffffc0 },
  { 0x00000000, 0x00000000, 0x00007ffe, 0x00000000 },
};
const Inputs kOutputs_Asr_RdIsRm_al_r11_r9_r11[] = {
  { 0x00000000, 0x00000000, 0x7ffffffe, 0x00000000 },
  { 0x00000000, 0x00000000, 0x00000001, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffffff82, 0xffffffff },
  { 0x00000000, 0xffff8003, 0xffff8003, 0xffff8003 },
  { 0x00000000, 0x00000000, 0x00000000, 0x00000000 },
  { 0x00000000, 0x00000000, 0x00007fff, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffff8002, 0xffffffff },
  { 0x00000000, 0xffff8000, 0xffff8000, 0xffff8000 },
  { 0x00000000, 0x00000000, 0x00000020, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffffff81, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffff82, 0xffffffff },
  { 0x00000000, 0x00000000, 0x00007fff, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffff8000, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffff83, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x00000000, 0x0ccccccc, 0x33333333, 0x0ccccccc },
  { 0x00000000, 0xffffffff, 0xaaaaaaaa, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffff8000, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffff83, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffff82, 0xffffffff },
  { 0x00000000, 0x00000000, 0x0000007d, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x00000000, 0x00000000, 0x0000007f, 0x00000000 },
  { 0x00000000, 0xffffff83, 0xffffff83, 0xffffff83 },
  { 0x00000000, 0xffffffff, 0xffffffe0, 0xffffffff },
  { 0x00000000, 0xffffffff, 0x80000001, 0xffffffff },
  { 0x00000000, 0xffffffff, 0x80000000, 0xffffffff },
  { 0x00000000, 0x0000007d, 0x0000007d, 0x0000007d },
  { 0x00000000, 0xffffffff, 0xffff8003, 0xffffffff },
  { 0x00000000, 0x00003ffe, 0x00007ffd, 0x00003ffe },
  { 0x00000000, 0x00000000, 0x7ffffffe, 0x00000000 },
  { 0x00000000, 0x00000000, 0x00007ffd, 0x00000000 },
  { 0x00000000, 0x00000000, 0x7ffffffd, 0x00000000 },
  { 0x00000000, 0x00000000, 0x0000007f, 0x00000000 },
  { 0x00000000, 0x0000003f, 0x0000007e, 0x0000003f },
  { 0x00000000, 0xffffffff, 0xfffffffd, 0xffffffff },
  { 0x00000000, 0x0fffffff, 0x7ffffffe, 0x0fffffff },
  { 0x00000000, 0x00000000, 0x00000002, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffff8001, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xfffffffe, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffff81, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffff81, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffff81, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xcccccccc, 0xffffffff },
  { 0x00000000, 0x00000000, 0x55555555, 0x00000000 },
  { 0x00000000, 0x00000fff, 0x00007ffd, 0x00000fff },
  { 0x00000000, 0xc0000000, 0x80000001, 0xc0000000 },
  { 0x00000000, 0xffffffff, 0xfffffffd, 0xffffffff },
  { 0x00000000, 0xfffffffe, 0xfffffffe, 0xfffffffe },
  { 0x00000000, 0x00000000, 0x0000007f, 0x00000000 },
  { 0x00000000, 0x00000001, 0x00000002, 0x00000001 },
  { 0x00000000, 0xffffffff, 0xffffff81, 0xffffffff },
  { 0x00000000, 0x00000000, 0x00007ffd, 0x00000000 },
  { 0x00000000, 0x19999999, 0x33333333, 0x19999999 },
  { 0x00000000, 0xffffffff, 0xffff8002, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xfffffffd, 0xffffffff },
  { 0x00000000, 0x00000000, 0x00000020, 0x00000000 },
  { 0x00000000, 0xffffc001, 0xffff8003, 0xffffc001 },
  { 0x00000000, 0xc0000000, 0x80000001, 0xc0000000 },
  { 0x00000000, 0x00000000, 0x00000002, 0x00000000 },
  { 0x00000000, 0x0fffffff, 0x7ffffffd, 0x0fffffff },
  { 0x00000000, 0xffffffff, 0xaaaaaaaa, 0xffffffff },
  { 0x00000000, 0x00000000, 0x7fffffff, 0x00000000 },
  { 0x00000000, 0x00000000, 0x00007ffe, 0x00000000 },
  { 0x00000000, 0xffffffff, 0x80000001, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xfffffffe, 0xffffffff },
  { 0x00000000, 0xffffffc0, 0xffffff80, 0xffffffc0 },
  { 0x00000000, 0xffffffff, 0xcccccccc, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffffe0, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xfffffffe, 0xffffffff },
  { 0x00000000, 0x00000000, 0x00007ffe, 0x00000000 },
  { 0x00000000, 0xffffffff, 0x80000001, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffff8001, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffff83, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xcccccccc, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffff83, 0xffffffff },
  { 0x00000000, 0xffffffff, 0x80000000, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffff8000, 0xffffffff },
  { 0x00000000, 0x00000000, 0x33333333, 0x00000000 },
  { 0x00000000, 0x00000000, 0x7ffffffd, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffff8001, 0xffffffff },
  { 0x00000000, 0xeaaaaaaa, 0xaaaaaaaa, 0xeaaaaaaa },
  { 0x00000000, 0x00000000, 0x7fffffff, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xfffffffe, 0xffffffff },
  { 0x00000000, 0x00000000, 0x00000001, 0x00000000 },
  { 0x00000000, 0x00000000, 0x00000001, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffffff80, 0xffffffff },
  { 0x00000000, 0x00000000, 0x00007fff, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xaaaaaaaa, 0xffffffff },
  { 0x00000000, 0x00001fff, 0x00007ffe, 0x00001fff },
  { 0x00000000, 0xe6666666, 0xcccccccc, 0xe6666666 },
  { 0x00000000, 0x00000000, 0x00000000, 0x00000000 },
  { 0x00000000, 0xffffc000, 0xffff8000, 0xffffc000 },
  { 0x00000000, 0x00000000, 0x00007fff, 0x00000000 },
  { 0x00000000, 0x00000000, 0x00007fff, 0x00000000 },
  { 0x00000000, 0x00000000, 0x00000001, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffff8002, 0xffffffff },
  { 0x00000000, 0x00000000, 0x7ffffffe, 0x00000000 },
  { 0x00000000, 0xd5555555, 0xaaaaaaaa, 0xd5555555 },
  { 0x00000000, 0xe6666666, 0xcccccccc, 0xe6666666 },
  { 0x00000000, 0xffffffff, 0xffffffe0, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xfffffffd, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xaaaaaaaa, 0xffffffff },
  { 0x00000000, 0x00000000, 0x00000001, 0x00000000 },
  { 0x00000000, 0x00000000, 0x00007fff, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xfffffffd, 0xffffffff },
  { 0x00000000, 0x00000000, 0x0000007d, 0x00000000 },
  { 0x00000000, 0x00000000, 0x7fffffff, 0x00000000 },
  { 0x00000000, 0x00000000, 0x0000007d, 0x00000000 },
  { 0x00000000, 0xffffffc0, 0xffffff81, 0xffffffc0 },
  { 0x00000000, 0x00000002, 0x00000002, 0x00000002 },
  { 0x00000000, 0xffffffff, 0xffff8003, 0xffffffff },
  { 0x00000000, 0x00000000, 0x00007ffd, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xaaaaaaaa, 0xffffffff },
  { 0x00000000, 0xffff8000, 0xffff8000, 0xffff8000 },
  { 0x00000000, 0x00000000, 0x00000002, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffffff83, 0xffffffff },
  { 0x00000000, 0x00000000, 0x00007ffe, 0x00000000 },
  { 0x00000000, 0x0000007d, 0x0000007d, 0x0000007d },
  { 0x00000000, 0x00000000, 0x00000002, 0x00000000 },
  { 0x00000000, 0xffffffff, 0x80000001, 0xffffffff },
  { 0x00000000, 0x00000000, 0x00007ffd, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffffff83, 0xffffffff },
  { 0x00000000, 0xc0000000, 0x80000000, 0xc0000000 },
  { 0x00000000, 0x80000000, 0x80000000, 0x80000000 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x00000000, 0xffffff83, 0xffffff83, 0xffffff83 },
  { 0x00000000, 0xffffffff, 0xffffff80, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffff8001, 0xffffffff },
  { 0x00000000, 0xffffc001, 0xffff8003, 0xffffc001 },
  { 0x00000000, 0x00000000, 0x7fffffff, 0x00000000 },
  { 0x00000000, 0x00000000, 0x00000002, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffff8003, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xcccccccc, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffff80, 0xffffffff },
  { 0x00000000, 0x00003ffe, 0x00007ffd, 0x00003ffe },
  { 0x00000000, 0x80000001, 0x80000001, 0x80000001 },
  { 0x00000000, 0x00000000, 0x00007ffd, 0x00000000 },
  { 0x00000000, 0x00000000, 0x0000007f, 0x00000000 },
  { 0x00000000, 0x0000001f, 0x0000007d, 0x0000001f },
  { 0x00000000, 0x3fffffff, 0x7fffffff, 0x3fffffff },
  { 0x00000000, 0xffffffff, 0xffffff81, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffff8001, 0xffffffff },
  { 0x00000000, 0xffffffff, 0x80000001, 0xffffffff },
  { 0x00000000, 0x00000000, 0x0000007f, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffffff81, 0xffffffff },
  { 0x00000000, 0xfffffffe, 0xfffffffd, 0xfffffffe },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x00000000, 0x00000000, 0x55555555, 0x00000000 },
  { 0x00000000, 0x00000000, 0x0000007f, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffff8003, 0xffffffff },
  { 0x00000000, 0x00000000, 0x00007ffd, 0x00000000 },
  { 0x00000000, 0x00000000, 0x33333333, 0x00000000 },
  { 0x00000000, 0xffffffff, 0x80000001, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffff8000, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffff81, 0xffffffff },
  { 0x00000000, 0x00000000, 0x0000007f, 0x00000000 },
  { 0x00000000, 0x0000000f, 0x0000007f, 0x0000000f },
  { 0x00000000, 0x00000000, 0x00007ffd, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xcccccccc, 0xffffffff },
  { 0x00000000, 0x00000000, 0x7ffffffd, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xcccccccc, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xfffffffd, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xcccccccc, 0xffffffff },
  { 0x00000000, 0x00000000, 0x00007fff, 0x00000000 },
  { 0x00000000, 0x00000000, 0x33333333, 0x00000000 },
  { 0x00000000, 0x00000000, 0x0000007d, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffffffe0, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffff8000, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x00000000, 0x7ffffffd, 0x7ffffffd, 0x7ffffffd },
  { 0x00000000, 0x00000000, 0x0000007e, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffff8003, 0xffffffff },
  { 0x00000000, 0x00000000, 0x00000002, 0x00000000 },
  { 0x00000000, 0x00000000, 0x00000001, 0x00000000 },
  { 0x00000000, 0x00000000, 0x33333333, 0x00000000 },
  { 0x00000000, 0x00000000, 0x00000001, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffff8000, 0xffffffff },
  { 0x00000000, 0x00000000, 0x55555555, 0x00000000 },
  { 0x00000000, 0x7ffffffe, 0x7ffffffe, 0x7ffffffe },
  { 0x00000000, 0xffffffff, 0xffffffe0, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffff8003, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xaaaaaaaa, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffff80, 0xffffffff },
  { 0x00000000, 0xffffffff, 0x80000001, 0xffffffff },
  { 0x00000000, 0x00007ffd, 0x00007ffd, 0x00007ffd },
  { 0x00000000, 0xffffffff, 0xffffff80, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xcccccccc, 0xffffffff },
  { 0x00000000, 0x00000000, 0x55555555, 0x00000000 },
  { 0x00000000, 0xffff8000, 0xffff8000, 0xffff8000 },
  { 0x00000000, 0xffffffff, 0xffff8000, 0xffffffff },
  { 0x00000000, 0x0000003e, 0x0000007d, 0x0000003e },
  { 0x00000000, 0xffffffff, 0xffff8002, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffffe0, 0xffffffff },
  { 0x00000000, 0xffff8003, 0xffff8003, 0xffff8003 },
  { 0x00000000, 0xffffffc0, 0xffffff81, 0xffffffc0 },
  { 0x00000000, 0x00000000, 0x00007ffe, 0x00000000 },
};
const Inputs kOutputs_Asr_RdIsRm_al_r0_r8_r0[] = {
  { 0x00000000, 0x00000000, 0x7ffffffe, 0x00000000 },
  { 0x00000000, 0x00000000, 0x00000001, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffffff82, 0xffffffff },
  { 0x00000000, 0xffff8003, 0xffff8003, 0xffff8003 },
  { 0x00000000, 0x00000000, 0x00000000, 0x00000000 },
  { 0x00000000, 0x00000000, 0x00007fff, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffff8002, 0xffffffff },
  { 0x00000000, 0xffff8000, 0xffff8000, 0xffff8000 },
  { 0x00000000, 0x00000000, 0x00000020, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffffff81, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffff82, 0xffffffff },
  { 0x00000000, 0x00000000, 0x00007fff, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffff8000, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffff83, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x00000000, 0x0ccccccc, 0x33333333, 0x0ccccccc },
  { 0x00000000, 0xffffffff, 0xaaaaaaaa, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffff8000, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffff83, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffff82, 0xffffffff },
  { 0x00000000, 0x00000000, 0x0000007d, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x00000000, 0x00000000, 0x0000007f, 0x00000000 },
  { 0x00000000, 0xffffff83, 0xffffff83, 0xffffff83 },
  { 0x00000000, 0xffffffff, 0xffffffe0, 0xffffffff },
  { 0x00000000, 0xffffffff, 0x80000001, 0xffffffff },
  { 0x00000000, 0xffffffff, 0x80000000, 0xffffffff },
  { 0x00000000, 0x0000007d, 0x0000007d, 0x0000007d },
  { 0x00000000, 0xffffffff, 0xffff8003, 0xffffffff },
  { 0x00000000, 0x00003ffe, 0x00007ffd, 0x00003ffe },
  { 0x00000000, 0x00000000, 0x7ffffffe, 0x00000000 },
  { 0x00000000, 0x00000000, 0x00007ffd, 0x00000000 },
  { 0x00000000, 0x00000000, 0x7ffffffd, 0x00000000 },
  { 0x00000000, 0x00000000, 0x0000007f, 0x00000000 },
  { 0x00000000, 0x0000003f, 0x0000007e, 0x0000003f },
  { 0x00000000, 0xffffffff, 0xfffffffd, 0xffffffff },
  { 0x00000000, 0x0fffffff, 0x7ffffffe, 0x0fffffff },
  { 0x00000000, 0x00000000, 0x00000002, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffff8001, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xfffffffe, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffff81, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffff81, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffff81, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xcccccccc, 0xffffffff },
  { 0x00000000, 0x00000000, 0x55555555, 0x00000000 },
  { 0x00000000, 0x00000fff, 0x00007ffd, 0x00000fff },
  { 0x00000000, 0xc0000000, 0x80000001, 0xc0000000 },
  { 0x00000000, 0xffffffff, 0xfffffffd, 0xffffffff },
  { 0x00000000, 0xfffffffe, 0xfffffffe, 0xfffffffe },
  { 0x00000000, 0x00000000, 0x0000007f, 0x00000000 },
  { 0x00000000, 0x00000001, 0x00000002, 0x00000001 },
  { 0x00000000, 0xffffffff, 0xffffff81, 0xffffffff },
  { 0x00000000, 0x00000000, 0x00007ffd, 0x00000000 },
  { 0x00000000, 0x19999999, 0x33333333, 0x19999999 },
  { 0x00000000, 0xffffffff, 0xffff8002, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xfffffffd, 0xffffffff },
  { 0x00000000, 0x00000000, 0x00000020, 0x00000000 },
  { 0x00000000, 0xffffc001, 0xffff8003, 0xffffc001 },
  { 0x00000000, 0xc0000000, 0x80000001, 0xc0000000 },
  { 0x00000000, 0x00000000, 0x00000002, 0x00000000 },
  { 0x00000000, 0x0fffffff, 0x7ffffffd, 0x0fffffff },
  { 0x00000000, 0xffffffff, 0xaaaaaaaa, 0xffffffff },
  { 0x00000000, 0x00000000, 0x7fffffff, 0x00000000 },
  { 0x00000000, 0x00000000, 0x00007ffe, 0x00000000 },
  { 0x00000000, 0xffffffff, 0x80000001, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xfffffffe, 0xffffffff },
  { 0x00000000, 0xffffffc0, 0xffffff80, 0xffffffc0 },
  { 0x00000000, 0xffffffff, 0xcccccccc, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffffe0, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xfffffffe, 0xffffffff },
  { 0x00000000, 0x00000000, 0x00007ffe, 0x00000000 },
  { 0x00000000, 0xffffffff, 0x80000001, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffff8001, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffff83, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xcccccccc, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffff83, 0xffffffff },
  { 0x00000000, 0xffffffff, 0x80000000, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffff8000, 0xffffffff },
  { 0x00000000, 0x00000000, 0x33333333, 0x00000000 },
  { 0x00000000, 0x00000000, 0x7ffffffd, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffff8001, 0xffffffff },
  { 0x00000000, 0xeaaaaaaa, 0xaaaaaaaa, 0xeaaaaaaa },
  { 0x00000000, 0x00000000, 0x7fffffff, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xfffffffe, 0xffffffff },
  { 0x00000000, 0x00000000, 0x00000001, 0x00000000 },
  { 0x00000000, 0x00000000, 0x00000001, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffffff80, 0xffffffff },
  { 0x00000000, 0x00000000, 0x00007fff, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xaaaaaaaa, 0xffffffff },
  { 0x00000000, 0x00001fff, 0x00007ffe, 0x00001fff },
  { 0x00000000, 0xe6666666, 0xcccccccc, 0xe6666666 },
  { 0x00000000, 0x00000000, 0x00000000, 0x00000000 },
  { 0x00000000, 0xffffc000, 0xffff8000, 0xffffc000 },
  { 0x00000000, 0x00000000, 0x00007fff, 0x00000000 },
  { 0x00000000, 0x00000000, 0x00007fff, 0x00000000 },
  { 0x00000000, 0x00000000, 0x00000001, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffff8002, 0xffffffff },
  { 0x00000000, 0x00000000, 0x7ffffffe, 0x00000000 },
  { 0x00000000, 0xd5555555, 0xaaaaaaaa, 0xd5555555 },
  { 0x00000000, 0xe6666666, 0xcccccccc, 0xe6666666 },
  { 0x00000000, 0xffffffff, 0xffffffe0, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xfffffffd, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xaaaaaaaa, 0xffffffff },
  { 0x00000000, 0x00000000, 0x00000001, 0x00000000 },
  { 0x00000000, 0x00000000, 0x00007fff, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xfffffffd, 0xffffffff },
  { 0x00000000, 0x00000000, 0x0000007d, 0x00000000 },
  { 0x00000000, 0x00000000, 0x7fffffff, 0x00000000 },
  { 0x00000000, 0x00000000, 0x0000007d, 0x00000000 },
  { 0x00000000, 0xffffffc0, 0xffffff81, 0xffffffc0 },
  { 0x00000000, 0x00000002, 0x00000002, 0x00000002 },
  { 0x00000000, 0xffffffff, 0xffff8003, 0xffffffff },
  { 0x00000000, 0x00000000, 0x00007ffd, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xaaaaaaaa, 0xffffffff },
  { 0x00000000, 0xffff8000, 0xffff8000, 0xffff8000 },
  { 0x00000000, 0x00000000, 0x00000002, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffffff83, 0xffffffff },
  { 0x00000000, 0x00000000, 0x00007ffe, 0x00000000 },
  { 0x00000000, 0x0000007d, 0x0000007d, 0x0000007d },
  { 0x00000000, 0x00000000, 0x00000002, 0x00000000 },
  { 0x00000000, 0xffffffff, 0x80000001, 0xffffffff },
  { 0x00000000, 0x00000000, 0x00007ffd, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffffff83, 0xffffffff },
  { 0x00000000, 0xc0000000, 0x80000000, 0xc0000000 },
  { 0x00000000, 0x80000000, 0x80000000, 0x80000000 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x00000000, 0xffffff83, 0xffffff83, 0xffffff83 },
  { 0x00000000, 0xffffffff, 0xffffff80, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffff8001, 0xffffffff },
  { 0x00000000, 0xffffc001, 0xffff8003, 0xffffc001 },
  { 0x00000000, 0x00000000, 0x7fffffff, 0x00000000 },
  { 0x00000000, 0x00000000, 0x00000002, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffff8003, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xcccccccc, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffff80, 0xffffffff },
  { 0x00000000, 0x00003ffe, 0x00007ffd, 0x00003ffe },
  { 0x00000000, 0x80000001, 0x80000001, 0x80000001 },
  { 0x00000000, 0x00000000, 0x00007ffd, 0x00000000 },
  { 0x00000000, 0x00000000, 0x0000007f, 0x00000000 },
  { 0x00000000, 0x0000001f, 0x0000007d, 0x0000001f },
  { 0x00000000, 0x3fffffff, 0x7fffffff, 0x3fffffff },
  { 0x00000000, 0xffffffff, 0xffffff81, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffff8001, 0xffffffff },
  { 0x00000000, 0xffffffff, 0x80000001, 0xffffffff },
  { 0x00000000, 0x00000000, 0x0000007f, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffffff81, 0xffffffff },
  { 0x00000000, 0xfffffffe, 0xfffffffd, 0xfffffffe },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x00000000, 0x00000000, 0x55555555, 0x00000000 },
  { 0x00000000, 0x00000000, 0x0000007f, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffff8003, 0xffffffff },
  { 0x00000000, 0x00000000, 0x00007ffd, 0x00000000 },
  { 0x00000000, 0x00000000, 0x33333333, 0x00000000 },
  { 0x00000000, 0xffffffff, 0x80000001, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffff8000, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffff81, 0xffffffff },
  { 0x00000000, 0x00000000, 0x0000007f, 0x00000000 },
  { 0x00000000, 0x0000000f, 0x0000007f, 0x0000000f },
  { 0x00000000, 0x00000000, 0x00007ffd, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xcccccccc, 0xffffffff },
  { 0x00000000, 0x00000000, 0x7ffffffd, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xcccccccc, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xfffffffd, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xcccccccc, 0xffffffff },
  { 0x00000000, 0x00000000, 0x00007fff, 0x00000000 },
  { 0x00000000, 0x00000000, 0x33333333, 0x00000000 },
  { 0x00000000, 0x00000000, 0x0000007d, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffffffe0, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffff8000, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x00000000, 0x7ffffffd, 0x7ffffffd, 0x7ffffffd },
  { 0x00000000, 0x00000000, 0x0000007e, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffff8003, 0xffffffff },
  { 0x00000000, 0x00000000, 0x00000002, 0x00000000 },
  { 0x00000000, 0x00000000, 0x00000001, 0x00000000 },
  { 0x00000000, 0x00000000, 0x33333333, 0x00000000 },
  { 0x00000000, 0x00000000, 0x00000001, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffff8000, 0xffffffff },
  { 0x00000000, 0x00000000, 0x55555555, 0x00000000 },
  { 0x00000000, 0x7ffffffe, 0x7ffffffe, 0x7ffffffe },
  { 0x00000000, 0xffffffff, 0xffffffe0, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffff8003, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xaaaaaaaa, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffff80, 0xffffffff },
  { 0x00000000, 0xffffffff, 0x80000001, 0xffffffff },
  { 0x00000000, 0x00007ffd, 0x00007ffd, 0x00007ffd },
  { 0x00000000, 0xffffffff, 0xffffff80, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xcccccccc, 0xffffffff },
  { 0x00000000, 0x00000000, 0x55555555, 0x00000000 },
  { 0x00000000, 0xffff8000, 0xffff8000, 0xffff8000 },
  { 0x00000000, 0xffffffff, 0xffff8000, 0xffffffff },
  { 0x00000000, 0x0000003e, 0x0000007d, 0x0000003e },
  { 0x00000000, 0xffffffff, 0xffff8002, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffffe0, 0xffffffff },
  { 0x00000000, 0xffff8003, 0xffff8003, 0xffff8003 },
  { 0x00000000, 0xffffffc0, 0xffffff81, 0xffffffc0 },
  { 0x00000000, 0x00000000, 0x00007ffe, 0x00000000 },
};
const Inputs kOutputs_Asr_RdIsRm_al_r2_r11_r2[] = {
  { 0x00000000, 0x00000000, 0x7ffffffe, 0x00000000 },
  { 0x00000000, 0x00000000, 0x00000001, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffffff82, 0xffffffff },
  { 0x00000000, 0xffff8003, 0xffff8003, 0xffff8003 },
  { 0x00000000, 0x00000000, 0x00000000, 0x00000000 },
  { 0x00000000, 0x00000000, 0x00007fff, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffff8002, 0xffffffff },
  { 0x00000000, 0xffff8000, 0xffff8000, 0xffff8000 },
  { 0x00000000, 0x00000000, 0x00000020, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffffff81, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffff82, 0xffffffff },
  { 0x00000000, 0x00000000, 0x00007fff, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffff8000, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffff83, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x00000000, 0x0ccccccc, 0x33333333, 0x0ccccccc },
  { 0x00000000, 0xffffffff, 0xaaaaaaaa, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffff8000, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffff83, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffff82, 0xffffffff },
  { 0x00000000, 0x00000000, 0x0000007d, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x00000000, 0x00000000, 0x0000007f, 0x00000000 },
  { 0x00000000, 0xffffff83, 0xffffff83, 0xffffff83 },
  { 0x00000000, 0xffffffff, 0xffffffe0, 0xffffffff },
  { 0x00000000, 0xffffffff, 0x80000001, 0xffffffff },
  { 0x00000000, 0xffffffff, 0x80000000, 0xffffffff },
  { 0x00000000, 0x0000007d, 0x0000007d, 0x0000007d },
  { 0x00000000, 0xffffffff, 0xffff8003, 0xffffffff },
  { 0x00000000, 0x00003ffe, 0x00007ffd, 0x00003ffe },
  { 0x00000000, 0x00000000, 0x7ffffffe, 0x00000000 },
  { 0x00000000, 0x00000000, 0x00007ffd, 0x00000000 },
  { 0x00000000, 0x00000000, 0x7ffffffd, 0x00000000 },
  { 0x00000000, 0x00000000, 0x0000007f, 0x00000000 },
  { 0x00000000, 0x0000003f, 0x0000007e, 0x0000003f },
  { 0x00000000, 0xffffffff, 0xfffffffd, 0xffffffff },
  { 0x00000000, 0x0fffffff, 0x7ffffffe, 0x0fffffff },
  { 0x00000000, 0x00000000, 0x00000002, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffff8001, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xfffffffe, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffff81, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffff81, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffff81, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xcccccccc, 0xffffffff },
  { 0x00000000, 0x00000000, 0x55555555, 0x00000000 },
  { 0x00000000, 0x00000fff, 0x00007ffd, 0x00000fff },
  { 0x00000000, 0xc0000000, 0x80000001, 0xc0000000 },
  { 0x00000000, 0xffffffff, 0xfffffffd, 0xffffffff },
  { 0x00000000, 0xfffffffe, 0xfffffffe, 0xfffffffe },
  { 0x00000000, 0x00000000, 0x0000007f, 0x00000000 },
  { 0x00000000, 0x00000001, 0x00000002, 0x00000001 },
  { 0x00000000, 0xffffffff, 0xffffff81, 0xffffffff },
  { 0x00000000, 0x00000000, 0x00007ffd, 0x00000000 },
  { 0x00000000, 0x19999999, 0x33333333, 0x19999999 },
  { 0x00000000, 0xffffffff, 0xffff8002, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xfffffffd, 0xffffffff },
  { 0x00000000, 0x00000000, 0x00000020, 0x00000000 },
  { 0x00000000, 0xffffc001, 0xffff8003, 0xffffc001 },
  { 0x00000000, 0xc0000000, 0x80000001, 0xc0000000 },
  { 0x00000000, 0x00000000, 0x00000002, 0x00000000 },
  { 0x00000000, 0x0fffffff, 0x7ffffffd, 0x0fffffff },
  { 0x00000000, 0xffffffff, 0xaaaaaaaa, 0xffffffff },
  { 0x00000000, 0x00000000, 0x7fffffff, 0x00000000 },
  { 0x00000000, 0x00000000, 0x00007ffe, 0x00000000 },
  { 0x00000000, 0xffffffff, 0x80000001, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xfffffffe, 0xffffffff },
  { 0x00000000, 0xffffffc0, 0xffffff80, 0xffffffc0 },
  { 0x00000000, 0xffffffff, 0xcccccccc, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffffe0, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xfffffffe, 0xffffffff },
  { 0x00000000, 0x00000000, 0x00007ffe, 0x00000000 },
  { 0x00000000, 0xffffffff, 0x80000001, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffff8001, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffff83, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xcccccccc, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffff83, 0xffffffff },
  { 0x00000000, 0xffffffff, 0x80000000, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffff8000, 0xffffffff },
  { 0x00000000, 0x00000000, 0x33333333, 0x00000000 },
  { 0x00000000, 0x00000000, 0x7ffffffd, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffff8001, 0xffffffff },
  { 0x00000000, 0xeaaaaaaa, 0xaaaaaaaa, 0xeaaaaaaa },
  { 0x00000000, 0x00000000, 0x7fffffff, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xfffffffe, 0xffffffff },
  { 0x00000000, 0x00000000, 0x00000001, 0x00000000 },
  { 0x00000000, 0x00000000, 0x00000001, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffffff80, 0xffffffff },
  { 0x00000000, 0x00000000, 0x00007fff, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xaaaaaaaa, 0xffffffff },
  { 0x00000000, 0x00001fff, 0x00007ffe, 0x00001fff },
  { 0x00000000, 0xe6666666, 0xcccccccc, 0xe6666666 },
  { 0x00000000, 0x00000000, 0x00000000, 0x00000000 },
  { 0x00000000, 0xffffc000, 0xffff8000, 0xffffc000 },
  { 0x00000000, 0x00000000, 0x00007fff, 0x00000000 },
  { 0x00000000, 0x00000000, 0x00007fff, 0x00000000 },
  { 0x00000000, 0x00000000, 0x00000001, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffff8002, 0xffffffff },
  { 0x00000000, 0x00000000, 0x7ffffffe, 0x00000000 },
  { 0x00000000, 0xd5555555, 0xaaaaaaaa, 0xd5555555 },
  { 0x00000000, 0xe6666666, 0xcccccccc, 0xe6666666 },
  { 0x00000000, 0xffffffff, 0xffffffe0, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xfffffffd, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xaaaaaaaa, 0xffffffff },
  { 0x00000000, 0x00000000, 0x00000001, 0x00000000 },
  { 0x00000000, 0x00000000, 0x00007fff, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xfffffffd, 0xffffffff },
  { 0x00000000, 0x00000000, 0x0000007d, 0x00000000 },
  { 0x00000000, 0x00000000, 0x7fffffff, 0x00000000 },
  { 0x00000000, 0x00000000, 0x0000007d, 0x00000000 },
  { 0x00000000, 0xffffffc0, 0xffffff81, 0xffffffc0 },
  { 0x00000000, 0x00000002, 0x00000002, 0x00000002 },
  { 0x00000000, 0xffffffff, 0xffff8003, 0xffffffff },
  { 0x00000000, 0x00000000, 0x00007ffd, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xaaaaaaaa, 0xffffffff },
  { 0x00000000, 0xffff8000, 0xffff8000, 0xffff8000 },
  { 0x00000000, 0x00000000, 0x00000002, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffffff83, 0xffffffff },
  { 0x00000000, 0x00000000, 0x00007ffe, 0x00000000 },
  { 0x00000000, 0x0000007d, 0x0000007d, 0x0000007d },
  { 0x00000000, 0x00000000, 0x00000002, 0x00000000 },
  { 0x00000000, 0xffffffff, 0x80000001, 0xffffffff },
  { 0x00000000, 0x00000000, 0x00007ffd, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffffff83, 0xffffffff },
  { 0x00000000, 0xc0000000, 0x80000000, 0xc0000000 },
  { 0x00000000, 0x80000000, 0x80000000, 0x80000000 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x00000000, 0xffffff83, 0xffffff83, 0xffffff83 },
  { 0x00000000, 0xffffffff, 0xffffff80, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffff8001, 0xffffffff },
  { 0x00000000, 0xffffc001, 0xffff8003, 0xffffc001 },
  { 0x00000000, 0x00000000, 0x7fffffff, 0x00000000 },
  { 0x00000000, 0x00000000, 0x00000002, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffff8003, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xcccccccc, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffff80, 0xffffffff },
  { 0x00000000, 0x00003ffe, 0x00007ffd, 0x00003ffe },
  { 0x00000000, 0x80000001, 0x80000001, 0x80000001 },
  { 0x00000000, 0x00000000, 0x00007ffd, 0x00000000 },
  { 0x00000000, 0x00000000, 0x0000007f, 0x00000000 },
  { 0x00000000, 0x0000001f, 0x0000007d, 0x0000001f },
  { 0x00000000, 0x3fffffff, 0x7fffffff, 0x3fffffff },
  { 0x00000000, 0xffffffff, 0xffffff81, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffff8001, 0xffffffff },
  { 0x00000000, 0xffffffff, 0x80000001, 0xffffffff },
  { 0x00000000, 0x00000000, 0x0000007f, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffffff81, 0xffffffff },
  { 0x00000000, 0xfffffffe, 0xfffffffd, 0xfffffffe },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x00000000, 0x00000000, 0x55555555, 0x00000000 },
  { 0x00000000, 0x00000000, 0x0000007f, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffff8003, 0xffffffff },
  { 0x00000000, 0x00000000, 0x00007ffd, 0x00000000 },
  { 0x00000000, 0x00000000, 0x33333333, 0x00000000 },
  { 0x00000000, 0xffffffff, 0x80000001, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffff8000, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffff81, 0xffffffff },
  { 0x00000000, 0x00000000, 0x0000007f, 0x00000000 },
  { 0x00000000, 0x0000000f, 0x0000007f, 0x0000000f },
  { 0x00000000, 0x00000000, 0x00007ffd, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xcccccccc, 0xffffffff },
  { 0x00000000, 0x00000000, 0x7ffffffd, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xcccccccc, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xfffffffd, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xcccccccc, 0xffffffff },
  { 0x00000000, 0x00000000, 0x00007fff, 0x00000000 },
  { 0x00000000, 0x00000000, 0x33333333, 0x00000000 },
  { 0x00000000, 0x00000000, 0x0000007d, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffffffe0, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffff8000, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x00000000, 0x7ffffffd, 0x7ffffffd, 0x7ffffffd },
  { 0x00000000, 0x00000000, 0x0000007e, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffff8003, 0xffffffff },
  { 0x00000000, 0x00000000, 0x00000002, 0x00000000 },
  { 0x00000000, 0x00000000, 0x00000001, 0x00000000 },
  { 0x00000000, 0x00000000, 0x33333333, 0x00000000 },
  { 0x00000000, 0x00000000, 0x00000001, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffff8000, 0xffffffff },
  { 0x00000000, 0x00000000, 0x55555555, 0x00000000 },
  { 0x00000000, 0x7ffffffe, 0x7ffffffe, 0x7ffffffe },
  { 0x00000000, 0xffffffff, 0xffffffe0, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffff8003, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xaaaaaaaa, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffff80, 0xffffffff },
  { 0x00000000, 0xffffffff, 0x80000001, 0xffffffff },
  { 0x00000000, 0x00007ffd, 0x00007ffd, 0x00007ffd },
  { 0x00000000, 0xffffffff, 0xffffff80, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xcccccccc, 0xffffffff },
  { 0x00000000, 0x00000000, 0x55555555, 0x00000000 },
  { 0x00000000, 0xffff8000, 0xffff8000, 0xffff8000 },
  { 0x00000000, 0xffffffff, 0xffff8000, 0xffffffff },
  { 0x00000000, 0x0000003e, 0x0000007d, 0x0000003e },
  { 0x00000000, 0xffffffff, 0xffff8002, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffffe0, 0xffffffff },
  { 0x00000000, 0xffff8003, 0xffff8003, 0xffff8003 },
  { 0x00000000, 0xffffffc0, 0xffffff81, 0xffffffc0 },
  { 0x00000000, 0x00000000, 0x00007ffe, 0x00000000 },
};
const Inputs kOutputs_Asr_RdIsRm_al_r9_r4_r9[] = {
  { 0x00000000, 0x00000000, 0x7ffffffe, 0x00000000 },
  { 0x00000000, 0x00000000, 0x00000001, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffffff82, 0xffffffff },
  { 0x00000000, 0xffff8003, 0xffff8003, 0xffff8003 },
  { 0x00000000, 0x00000000, 0x00000000, 0x00000000 },
  { 0x00000000, 0x00000000, 0x00007fff, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffff8002, 0xffffffff },
  { 0x00000000, 0xffff8000, 0xffff8000, 0xffff8000 },
  { 0x00000000, 0x00000000, 0x00000020, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffffff81, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffff82, 0xffffffff },
  { 0x00000000, 0x00000000, 0x00007fff, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffff8000, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffff83, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x00000000, 0x0ccccccc, 0x33333333, 0x0ccccccc },
  { 0x00000000, 0xffffffff, 0xaaaaaaaa, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffff8000, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffff83, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffff82, 0xffffffff },
  { 0x00000000, 0x00000000, 0x0000007d, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x00000000, 0x00000000, 0x0000007f, 0x00000000 },
  { 0x00000000, 0xffffff83, 0xffffff83, 0xffffff83 },
  { 0x00000000, 0xffffffff, 0xffffffe0, 0xffffffff },
  { 0x00000000, 0xffffffff, 0x80000001, 0xffffffff },
  { 0x00000000, 0xffffffff, 0x80000000, 0xffffffff },
  { 0x00000000, 0x0000007d, 0x0000007d, 0x0000007d },
  { 0x00000000, 0xffffffff, 0xffff8003, 0xffffffff },
  { 0x00000000, 0x00003ffe, 0x00007ffd, 0x00003ffe },
  { 0x00000000, 0x00000000, 0x7ffffffe, 0x00000000 },
  { 0x00000000, 0x00000000, 0x00007ffd, 0x00000000 },
  { 0x00000000, 0x00000000, 0x7ffffffd, 0x00000000 },
  { 0x00000000, 0x00000000, 0x0000007f, 0x00000000 },
  { 0x00000000, 0x0000003f, 0x0000007e, 0x0000003f },
  { 0x00000000, 0xffffffff, 0xfffffffd, 0xffffffff },
  { 0x00000000, 0x0fffffff, 0x7ffffffe, 0x0fffffff },
  { 0x00000000, 0x00000000, 0x00000002, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffff8001, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xfffffffe, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffff81, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffff81, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffff81, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xcccccccc, 0xffffffff },
  { 0x00000000, 0x00000000, 0x55555555, 0x00000000 },
  { 0x00000000, 0x00000fff, 0x00007ffd, 0x00000fff },
  { 0x00000000, 0xc0000000, 0x80000001, 0xc0000000 },
  { 0x00000000, 0xffffffff, 0xfffffffd, 0xffffffff },
  { 0x00000000, 0xfffffffe, 0xfffffffe, 0xfffffffe },
  { 0x00000000, 0x00000000, 0x0000007f, 0x00000000 },
  { 0x00000000, 0x00000001, 0x00000002, 0x00000001 },
  { 0x00000000, 0xffffffff, 0xffffff81, 0xffffffff },
  { 0x00000000, 0x00000000, 0x00007ffd, 0x00000000 },
  { 0x00000000, 0x19999999, 0x33333333, 0x19999999 },
  { 0x00000000, 0xffffffff, 0xffff8002, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xfffffffd, 0xffffffff },
  { 0x00000000, 0x00000000, 0x00000020, 0x00000000 },
  { 0x00000000, 0xffffc001, 0xffff8003, 0xffffc001 },
  { 0x00000000, 0xc0000000, 0x80000001, 0xc0000000 },
  { 0x00000000, 0x00000000, 0x00000002, 0x00000000 },
  { 0x00000000, 0x0fffffff, 0x7ffffffd, 0x0fffffff },
  { 0x00000000, 0xffffffff, 0xaaaaaaaa, 0xffffffff },
  { 0x00000000, 0x00000000, 0x7fffffff, 0x00000000 },
  { 0x00000000, 0x00000000, 0x00007ffe, 0x00000000 },
  { 0x00000000, 0xffffffff, 0x80000001, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xfffffffe, 0xffffffff },
  { 0x00000000, 0xffffffc0, 0xffffff80, 0xffffffc0 },
  { 0x00000000, 0xffffffff, 0xcccccccc, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffffe0, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xfffffffe, 0xffffffff },
  { 0x00000000, 0x00000000, 0x00007ffe, 0x00000000 },
  { 0x00000000, 0xffffffff, 0x80000001, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffff8001, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffff83, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xcccccccc, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffff83, 0xffffffff },
  { 0x00000000, 0xffffffff, 0x80000000, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffff8000, 0xffffffff },
  { 0x00000000, 0x00000000, 0x33333333, 0x00000000 },
  { 0x00000000, 0x00000000, 0x7ffffffd, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffff8001, 0xffffffff },
  { 0x00000000, 0xeaaaaaaa, 0xaaaaaaaa, 0xeaaaaaaa },
  { 0x00000000, 0x00000000, 0x7fffffff, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xfffffffe, 0xffffffff },
  { 0x00000000, 0x00000000, 0x00000001, 0x00000000 },
  { 0x00000000, 0x00000000, 0x00000001, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffffff80, 0xffffffff },
  { 0x00000000, 0x00000000, 0x00007fff, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xaaaaaaaa, 0xffffffff },
  { 0x00000000, 0x00001fff, 0x00007ffe, 0x00001fff },
  { 0x00000000, 0xe6666666, 0xcccccccc, 0xe6666666 },
  { 0x00000000, 0x00000000, 0x00000000, 0x00000000 },
  { 0x00000000, 0xffffc000, 0xffff8000, 0xffffc000 },
  { 0x00000000, 0x00000000, 0x00007fff, 0x00000000 },
  { 0x00000000, 0x00000000, 0x00007fff, 0x00000000 },
  { 0x00000000, 0x00000000, 0x00000001, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffff8002, 0xffffffff },
  { 0x00000000, 0x00000000, 0x7ffffffe, 0x00000000 },
  { 0x00000000, 0xd5555555, 0xaaaaaaaa, 0xd5555555 },
  { 0x00000000, 0xe6666666, 0xcccccccc, 0xe6666666 },
  { 0x00000000, 0xffffffff, 0xffffffe0, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xfffffffd, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xaaaaaaaa, 0xffffffff },
  { 0x00000000, 0x00000000, 0x00000001, 0x00000000 },
  { 0x00000000, 0x00000000, 0x00007fff, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xfffffffd, 0xffffffff },
  { 0x00000000, 0x00000000, 0x0000007d, 0x00000000 },
  { 0x00000000, 0x00000000, 0x7fffffff, 0x00000000 },
  { 0x00000000, 0x00000000, 0x0000007d, 0x00000000 },
  { 0x00000000, 0xffffffc0, 0xffffff81, 0xffffffc0 },
  { 0x00000000, 0x00000002, 0x00000002, 0x00000002 },
  { 0x00000000, 0xffffffff, 0xffff8003, 0xffffffff },
  { 0x00000000, 0x00000000, 0x00007ffd, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xaaaaaaaa, 0xffffffff },
  { 0x00000000, 0xffff8000, 0xffff8000, 0xffff8000 },
  { 0x00000000, 0x00000000, 0x00000002, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffffff83, 0xffffffff },
  { 0x00000000, 0x00000000, 0x00007ffe, 0x00000000 },
  { 0x00000000, 0x0000007d, 0x0000007d, 0x0000007d },
  { 0x00000000, 0x00000000, 0x00000002, 0x00000000 },
  { 0x00000000, 0xffffffff, 0x80000001, 0xffffffff },
  { 0x00000000, 0x00000000, 0x00007ffd, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffffff83, 0xffffffff },
  { 0x00000000, 0xc0000000, 0x80000000, 0xc0000000 },
  { 0x00000000, 0x80000000, 0x80000000, 0x80000000 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x00000000, 0xffffff83, 0xffffff83, 0xffffff83 },
  { 0x00000000, 0xffffffff, 0xffffff80, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffff8001, 0xffffffff },
  { 0x00000000, 0xffffc001, 0xffff8003, 0xffffc001 },
  { 0x00000000, 0x00000000, 0x7fffffff, 0x00000000 },
  { 0x00000000, 0x00000000, 0x00000002, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffff8003, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xcccccccc, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffff80, 0xffffffff },
  { 0x00000000, 0x00003ffe, 0x00007ffd, 0x00003ffe },
  { 0x00000000, 0x80000001, 0x80000001, 0x80000001 },
  { 0x00000000, 0x00000000, 0x00007ffd, 0x00000000 },
  { 0x00000000, 0x00000000, 0x0000007f, 0x00000000 },
  { 0x00000000, 0x0000001f, 0x0000007d, 0x0000001f },
  { 0x00000000, 0x3fffffff, 0x7fffffff, 0x3fffffff },
  { 0x00000000, 0xffffffff, 0xffffff81, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffff8001, 0xffffffff },
  { 0x00000000, 0xffffffff, 0x80000001, 0xffffffff },
  { 0x00000000, 0x00000000, 0x0000007f, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffffff81, 0xffffffff },
  { 0x00000000, 0xfffffffe, 0xfffffffd, 0xfffffffe },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x00000000, 0x00000000, 0x55555555, 0x00000000 },
  { 0x00000000, 0x00000000, 0x0000007f, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffff8003, 0xffffffff },
  { 0x00000000, 0x00000000, 0x00007ffd, 0x00000000 },
  { 0x00000000, 0x00000000, 0x33333333, 0x00000000 },
  { 0x00000000, 0xffffffff, 0x80000001, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffff8000, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffff81, 0xffffffff },
  { 0x00000000, 0x00000000, 0x0000007f, 0x00000000 },
  { 0x00000000, 0x0000000f, 0x0000007f, 0x0000000f },
  { 0x00000000, 0x00000000, 0x00007ffd, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xcccccccc, 0xffffffff },
  { 0x00000000, 0x00000000, 0x7ffffffd, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xcccccccc, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xfffffffd, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xcccccccc, 0xffffffff },
  { 0x00000000, 0x00000000, 0x00007fff, 0x00000000 },
  { 0x00000000, 0x00000000, 0x33333333, 0x00000000 },
  { 0x00000000, 0x00000000, 0x0000007d, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffffffe0, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffff8000, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x00000000, 0x7ffffffd, 0x7ffffffd, 0x7ffffffd },
  { 0x00000000, 0x00000000, 0x0000007e, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffff8003, 0xffffffff },
  { 0x00000000, 0x00000000, 0x00000002, 0x00000000 },
  { 0x00000000, 0x00000000, 0x00000001, 0x00000000 },
  { 0x00000000, 0x00000000, 0x33333333, 0x00000000 },
  { 0x00000000, 0x00000000, 0x00000001, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffff8000, 0xffffffff },
  { 0x00000000, 0x00000000, 0x55555555, 0x00000000 },
  { 0x00000000, 0x7ffffffe, 0x7ffffffe, 0x7ffffffe },
  { 0x00000000, 0xffffffff, 0xffffffe0, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffff8003, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xaaaaaaaa, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffff80, 0xffffffff },
  { 0x00000000, 0xffffffff, 0x80000001, 0xffffffff },
  { 0x00000000, 0x00007ffd, 0x00007ffd, 0x00007ffd },
  { 0x00000000, 0xffffffff, 0xffffff80, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xcccccccc, 0xffffffff },
  { 0x00000000, 0x00000000, 0x55555555, 0x00000000 },
  { 0x00000000, 0xffff8000, 0xffff8000, 0xffff8000 },
  { 0x00000000, 0xffffffff, 0xffff8000, 0xffffffff },
  { 0x00000000, 0x0000003e, 0x0000007d, 0x0000003e },
  { 0x00000000, 0xffffffff, 0xffff8002, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffffe0, 0xffffffff },
  { 0x00000000, 0xffff8003, 0xffff8003, 0xffff8003 },
  { 0x00000000, 0xffffffc0, 0xffffff81, 0xffffffc0 },
  { 0x00000000, 0x00000000, 0x00007ffe, 0x00000000 },
};
const Inputs kOutputs_Asr_RdIsRm_al_r14_r10_r14[] = {
  { 0x00000000, 0x00000000, 0x7ffffffe, 0x00000000 },
  { 0x00000000, 0x00000000, 0x00000001, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffffff82, 0xffffffff },
  { 0x00000000, 0xffff8003, 0xffff8003, 0xffff8003 },
  { 0x00000000, 0x00000000, 0x00000000, 0x00000000 },
  { 0x00000000, 0x00000000, 0x00007fff, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffff8002, 0xffffffff },
  { 0x00000000, 0xffff8000, 0xffff8000, 0xffff8000 },
  { 0x00000000, 0x00000000, 0x00000020, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffffff81, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffff82, 0xffffffff },
  { 0x00000000, 0x00000000, 0x00007fff, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffff8000, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffff83, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x00000000, 0x0ccccccc, 0x33333333, 0x0ccccccc },
  { 0x00000000, 0xffffffff, 0xaaaaaaaa, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffff8000, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffff83, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffff82, 0xffffffff },
  { 0x00000000, 0x00000000, 0x0000007d, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x00000000, 0x00000000, 0x0000007f, 0x00000000 },
  { 0x00000000, 0xffffff83, 0xffffff83, 0xffffff83 },
  { 0x00000000, 0xffffffff, 0xffffffe0, 0xffffffff },
  { 0x00000000, 0xffffffff, 0x80000001, 0xffffffff },
  { 0x00000000, 0xffffffff, 0x80000000, 0xffffffff },
  { 0x00000000, 0x0000007d, 0x0000007d, 0x0000007d },
  { 0x00000000, 0xffffffff, 0xffff8003, 0xffffffff },
  { 0x00000000, 0x00003ffe, 0x00007ffd, 0x00003ffe },
  { 0x00000000, 0x00000000, 0x7ffffffe, 0x00000000 },
  { 0x00000000, 0x00000000, 0x00007ffd, 0x00000000 },
  { 0x00000000, 0x00000000, 0x7ffffffd, 0x00000000 },
  { 0x00000000, 0x00000000, 0x0000007f, 0x00000000 },
  { 0x00000000, 0x0000003f, 0x0000007e, 0x0000003f },
  { 0x00000000, 0xffffffff, 0xfffffffd, 0xffffffff },
  { 0x00000000, 0x0fffffff, 0x7ffffffe, 0x0fffffff },
  { 0x00000000, 0x00000000, 0x00000002, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffff8001, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xfffffffe, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffff81, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffff81, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffff81, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xcccccccc, 0xffffffff },
  { 0x00000000, 0x00000000, 0x55555555, 0x00000000 },
  { 0x00000000, 0x00000fff, 0x00007ffd, 0x00000fff },
  { 0x00000000, 0xc0000000, 0x80000001, 0xc0000000 },
  { 0x00000000, 0xffffffff, 0xfffffffd, 0xffffffff },
  { 0x00000000, 0xfffffffe, 0xfffffffe, 0xfffffffe },
  { 0x00000000, 0x00000000, 0x0000007f, 0x00000000 },
  { 0x00000000, 0x00000001, 0x00000002, 0x00000001 },
  { 0x00000000, 0xffffffff, 0xffffff81, 0xffffffff },
  { 0x00000000, 0x00000000, 0x00007ffd, 0x00000000 },
  { 0x00000000, 0x19999999, 0x33333333, 0x19999999 },
  { 0x00000000, 0xffffffff, 0xffff8002, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xfffffffd, 0xffffffff },
  { 0x00000000, 0x00000000, 0x00000020, 0x00000000 },
  { 0x00000000, 0xffffc001, 0xffff8003, 0xffffc001 },
  { 0x00000000, 0xc0000000, 0x80000001, 0xc0000000 },
  { 0x00000000, 0x00000000, 0x00000002, 0x00000000 },
  { 0x00000000, 0x0fffffff, 0x7ffffffd, 0x0fffffff },
  { 0x00000000, 0xffffffff, 0xaaaaaaaa, 0xffffffff },
  { 0x00000000, 0x00000000, 0x7fffffff, 0x00000000 },
  { 0x00000000, 0x00000000, 0x00007ffe, 0x00000000 },
  { 0x00000000, 0xffffffff, 0x80000001, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xfffffffe, 0xffffffff },
  { 0x00000000, 0xffffffc0, 0xffffff80, 0xffffffc0 },
  { 0x00000000, 0xffffffff, 0xcccccccc, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffffe0, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xfffffffe, 0xffffffff },
  { 0x00000000, 0x00000000, 0x00007ffe, 0x00000000 },
  { 0x00000000, 0xffffffff, 0x80000001, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffff8001, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffff83, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xcccccccc, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffff83, 0xffffffff },
  { 0x00000000, 0xffffffff, 0x80000000, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffff8000, 0xffffffff },
  { 0x00000000, 0x00000000, 0x33333333, 0x00000000 },
  { 0x00000000, 0x00000000, 0x7ffffffd, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffff8001, 0xffffffff },
  { 0x00000000, 0xeaaaaaaa, 0xaaaaaaaa, 0xeaaaaaaa },
  { 0x00000000, 0x00000000, 0x7fffffff, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xfffffffe, 0xffffffff },
  { 0x00000000, 0x00000000, 0x00000001, 0x00000000 },
  { 0x00000000, 0x00000000, 0x00000001, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffffff80, 0xffffffff },
  { 0x00000000, 0x00000000, 0x00007fff, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xaaaaaaaa, 0xffffffff },
  { 0x00000000, 0x00001fff, 0x00007ffe, 0x00001fff },
  { 0x00000000, 0xe6666666, 0xcccccccc, 0xe6666666 },
  { 0x00000000, 0x00000000, 0x00000000, 0x00000000 },
  { 0x00000000, 0xffffc000, 0xffff8000, 0xffffc000 },
  { 0x00000000, 0x00000000, 0x00007fff, 0x00000000 },
  { 0x00000000, 0x00000000, 0x00007fff, 0x00000000 },
  { 0x00000000, 0x00000000, 0x00000001, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffff8002, 0xffffffff },
  { 0x00000000, 0x00000000, 0x7ffffffe, 0x00000000 },
  { 0x00000000, 0xd5555555, 0xaaaaaaaa, 0xd5555555 },
  { 0x00000000, 0xe6666666, 0xcccccccc, 0xe6666666 },
  { 0x00000000, 0xffffffff, 0xffffffe0, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xfffffffd, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xaaaaaaaa, 0xffffffff },
  { 0x00000000, 0x00000000, 0x00000001, 0x00000000 },
  { 0x00000000, 0x00000000, 0x00007fff, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xfffffffd, 0xffffffff },
  { 0x00000000, 0x00000000, 0x0000007d, 0x00000000 },
  { 0x00000000, 0x00000000, 0x7fffffff, 0x00000000 },
  { 0x00000000, 0x00000000, 0x0000007d, 0x00000000 },
  { 0x00000000, 0xffffffc0, 0xffffff81, 0xffffffc0 },
  { 0x00000000, 0x00000002, 0x00000002, 0x00000002 },
  { 0x00000000, 0xffffffff, 0xffff8003, 0xffffffff },
  { 0x00000000, 0x00000000, 0x00007ffd, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xaaaaaaaa, 0xffffffff },
  { 0x00000000, 0xffff8000, 0xffff8000, 0xffff8000 },
  { 0x00000000, 0x00000000, 0x00000002, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffffff83, 0xffffffff },
  { 0x00000000, 0x00000000, 0x00007ffe, 0x00000000 },
  { 0x00000000, 0x0000007d, 0x0000007d, 0x0000007d },
  { 0x00000000, 0x00000000, 0x00000002, 0x00000000 },
  { 0x00000000, 0xffffffff, 0x80000001, 0xffffffff },
  { 0x00000000, 0x00000000, 0x00007ffd, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffffff83, 0xffffffff },
  { 0x00000000, 0xc0000000, 0x80000000, 0xc0000000 },
  { 0x00000000, 0x80000000, 0x80000000, 0x80000000 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x00000000, 0xffffff83, 0xffffff83, 0xffffff83 },
  { 0x00000000, 0xffffffff, 0xffffff80, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffff8001, 0xffffffff },
  { 0x00000000, 0xffffc001, 0xffff8003, 0xffffc001 },
  { 0x00000000, 0x00000000, 0x7fffffff, 0x00000000 },
  { 0x00000000, 0x00000000, 0x00000002, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffff8003, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xcccccccc, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffff80, 0xffffffff },
  { 0x00000000, 0x00003ffe, 0x00007ffd, 0x00003ffe },
  { 0x00000000, 0x80000001, 0x80000001, 0x80000001 },
  { 0x00000000, 0x00000000, 0x00007ffd, 0x00000000 },
  { 0x00000000, 0x00000000, 0x0000007f, 0x00000000 },
  { 0x00000000, 0x0000001f, 0x0000007d, 0x0000001f },
  { 0x00000000, 0x3fffffff, 0x7fffffff, 0x3fffffff },
  { 0x00000000, 0xffffffff, 0xffffff81, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffff8001, 0xffffffff },
  { 0x00000000, 0xffffffff, 0x80000001, 0xffffffff },
  { 0x00000000, 0x00000000, 0x0000007f, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffffff81, 0xffffffff },
  { 0x00000000, 0xfffffffe, 0xfffffffd, 0xfffffffe },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x00000000, 0x00000000, 0x55555555, 0x00000000 },
  { 0x00000000, 0x00000000, 0x0000007f, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffff8003, 0xffffffff },
  { 0x00000000, 0x00000000, 0x00007ffd, 0x00000000 },
  { 0x00000000, 0x00000000, 0x33333333, 0x00000000 },
  { 0x00000000, 0xffffffff, 0x80000001, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffff8000, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffff81, 0xffffffff },
  { 0x00000000, 0x00000000, 0x0000007f, 0x00000000 },
  { 0x00000000, 0x0000000f, 0x0000007f, 0x0000000f },
  { 0x00000000, 0x00000000, 0x00007ffd, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xcccccccc, 0xffffffff },
  { 0x00000000, 0x00000000, 0x7ffffffd, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xcccccccc, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xfffffffd, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xcccccccc, 0xffffffff },
  { 0x00000000, 0x00000000, 0x00007fff, 0x00000000 },
  { 0x00000000, 0x00000000, 0x33333333, 0x00000000 },
  { 0x00000000, 0x00000000, 0x0000007d, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffffffe0, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffff8000, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x00000000, 0x7ffffffd, 0x7ffffffd, 0x7ffffffd },
  { 0x00000000, 0x00000000, 0x0000007e, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffff8003, 0xffffffff },
  { 0x00000000, 0x00000000, 0x00000002, 0x00000000 },
  { 0x00000000, 0x00000000, 0x00000001, 0x00000000 },
  { 0x00000000, 0x00000000, 0x33333333, 0x00000000 },
  { 0x00000000, 0x00000000, 0x00000001, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffff8000, 0xffffffff },
  { 0x00000000, 0x00000000, 0x55555555, 0x00000000 },
  { 0x00000000, 0x7ffffffe, 0x7ffffffe, 0x7ffffffe },
  { 0x00000000, 0xffffffff, 0xffffffe0, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffff8003, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xaaaaaaaa, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffff80, 0xffffffff },
  { 0x00000000, 0xffffffff, 0x80000001, 0xffffffff },
  { 0x00000000, 0x00007ffd, 0x00007ffd, 0x00007ffd },
  { 0x00000000, 0xffffffff, 0xffffff80, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xcccccccc, 0xffffffff },
  { 0x00000000, 0x00000000, 0x55555555, 0x00000000 },
  { 0x00000000, 0xffff8000, 0xffff8000, 0xffff8000 },
  { 0x00000000, 0xffffffff, 0xffff8000, 0xffffffff },
  { 0x00000000, 0x0000003e, 0x0000007d, 0x0000003e },
  { 0x00000000, 0xffffffff, 0xffff8002, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffffe0, 0xffffffff },
  { 0x00000000, 0xffff8003, 0xffff8003, 0xffff8003 },
  { 0x00000000, 0xffffffc0, 0xffffff81, 0xffffffc0 },
  { 0x00000000, 0x00000000, 0x00007ffe, 0x00000000 },
};
const Inputs kOutputs_Asr_RdIsRm_al_r7_r0_r7[] = {
  { 0x00000000, 0x00000000, 0x7ffffffe, 0x00000000 },
  { 0x00000000, 0x00000000, 0x00000001, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffffff82, 0xffffffff },
  { 0x00000000, 0xffff8003, 0xffff8003, 0xffff8003 },
  { 0x00000000, 0x00000000, 0x00000000, 0x00000000 },
  { 0x00000000, 0x00000000, 0x00007fff, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffff8002, 0xffffffff },
  { 0x00000000, 0xffff8000, 0xffff8000, 0xffff8000 },
  { 0x00000000, 0x00000000, 0x00000020, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffffff81, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffff82, 0xffffffff },
  { 0x00000000, 0x00000000, 0x00007fff, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffff8000, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffff83, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x00000000, 0x0ccccccc, 0x33333333, 0x0ccccccc },
  { 0x00000000, 0xffffffff, 0xaaaaaaaa, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffff8000, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffff83, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffff82, 0xffffffff },
  { 0x00000000, 0x00000000, 0x0000007d, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x00000000, 0x00000000, 0x0000007f, 0x00000000 },
  { 0x00000000, 0xffffff83, 0xffffff83, 0xffffff83 },
  { 0x00000000, 0xffffffff, 0xffffffe0, 0xffffffff },
  { 0x00000000, 0xffffffff, 0x80000001, 0xffffffff },
  { 0x00000000, 0xffffffff, 0x80000000, 0xffffffff },
  { 0x00000000, 0x0000007d, 0x0000007d, 0x0000007d },
  { 0x00000000, 0xffffffff, 0xffff8003, 0xffffffff },
  { 0x00000000, 0x00003ffe, 0x00007ffd, 0x00003ffe },
  { 0x00000000, 0x00000000, 0x7ffffffe, 0x00000000 },
  { 0x00000000, 0x00000000, 0x00007ffd, 0x00000000 },
  { 0x00000000, 0x00000000, 0x7ffffffd, 0x00000000 },
  { 0x00000000, 0x00000000, 0x0000007f, 0x00000000 },
  { 0x00000000, 0x0000003f, 0x0000007e, 0x0000003f },
  { 0x00000000, 0xffffffff, 0xfffffffd, 0xffffffff },
  { 0x00000000, 0x0fffffff, 0x7ffffffe, 0x0fffffff },
  { 0x00000000, 0x00000000, 0x00000002, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffff8001, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xfffffffe, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffff81, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffff81, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffff81, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xcccccccc, 0xffffffff },
  { 0x00000000, 0x00000000, 0x55555555, 0x00000000 },
  { 0x00000000, 0x00000fff, 0x00007ffd, 0x00000fff },
  { 0x00000000, 0xc0000000, 0x80000001, 0xc0000000 },
  { 0x00000000, 0xffffffff, 0xfffffffd, 0xffffffff },
  { 0x00000000, 0xfffffffe, 0xfffffffe, 0xfffffffe },
  { 0x00000000, 0x00000000, 0x0000007f, 0x00000000 },
  { 0x00000000, 0x00000001, 0x00000002, 0x00000001 },
  { 0x00000000, 0xffffffff, 0xffffff81, 0xffffffff },
  { 0x00000000, 0x00000000, 0x00007ffd, 0x00000000 },
  { 0x00000000, 0x19999999, 0x33333333, 0x19999999 },
  { 0x00000000, 0xffffffff, 0xffff8002, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xfffffffd, 0xffffffff },
  { 0x00000000, 0x00000000, 0x00000020, 0x00000000 },
  { 0x00000000, 0xffffc001, 0xffff8003, 0xffffc001 },
  { 0x00000000, 0xc0000000, 0x80000001, 0xc0000000 },
  { 0x00000000, 0x00000000, 0x00000002, 0x00000000 },
  { 0x00000000, 0x0fffffff, 0x7ffffffd, 0x0fffffff },
  { 0x00000000, 0xffffffff, 0xaaaaaaaa, 0xffffffff },
  { 0x00000000, 0x00000000, 0x7fffffff, 0x00000000 },
  { 0x00000000, 0x00000000, 0x00007ffe, 0x00000000 },
  { 0x00000000, 0xffffffff, 0x80000001, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xfffffffe, 0xffffffff },
  { 0x00000000, 0xffffffc0, 0xffffff80, 0xffffffc0 },
  { 0x00000000, 0xffffffff, 0xcccccccc, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffffe0, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xfffffffe, 0xffffffff },
  { 0x00000000, 0x00000000, 0x00007ffe, 0x00000000 },
  { 0x00000000, 0xffffffff, 0x80000001, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffff8001, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffff83, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xcccccccc, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffff83, 0xffffffff },
  { 0x00000000, 0xffffffff, 0x80000000, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffff8000, 0xffffffff },
  { 0x00000000, 0x00000000, 0x33333333, 0x00000000 },
  { 0x00000000, 0x00000000, 0x7ffffffd, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffff8001, 0xffffffff },
  { 0x00000000, 0xeaaaaaaa, 0xaaaaaaaa, 0xeaaaaaaa },
  { 0x00000000, 0x00000000, 0x7fffffff, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xfffffffe, 0xffffffff },
  { 0x00000000, 0x00000000, 0x00000001, 0x00000000 },
  { 0x00000000, 0x00000000, 0x00000001, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffffff80, 0xffffffff },
  { 0x00000000, 0x00000000, 0x00007fff, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xaaaaaaaa, 0xffffffff },
  { 0x00000000, 0x00001fff, 0x00007ffe, 0x00001fff },
  { 0x00000000, 0xe6666666, 0xcccccccc, 0xe6666666 },
  { 0x00000000, 0x00000000, 0x00000000, 0x00000000 },
  { 0x00000000, 0xffffc000, 0xffff8000, 0xffffc000 },
  { 0x00000000, 0x00000000, 0x00007fff, 0x00000000 },
  { 0x00000000, 0x00000000, 0x00007fff, 0x00000000 },
  { 0x00000000, 0x00000000, 0x00000001, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffff8002, 0xffffffff },
  { 0x00000000, 0x00000000, 0x7ffffffe, 0x00000000 },
  { 0x00000000, 0xd5555555, 0xaaaaaaaa, 0xd5555555 },
  { 0x00000000, 0xe6666666, 0xcccccccc, 0xe6666666 },
  { 0x00000000, 0xffffffff, 0xffffffe0, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xfffffffd, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xaaaaaaaa, 0xffffffff },
  { 0x00000000, 0x00000000, 0x00000001, 0x00000000 },
  { 0x00000000, 0x00000000, 0x00007fff, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xfffffffd, 0xffffffff },
  { 0x00000000, 0x00000000, 0x0000007d, 0x00000000 },
  { 0x00000000, 0x00000000, 0x7fffffff, 0x00000000 },
  { 0x00000000, 0x00000000, 0x0000007d, 0x00000000 },
  { 0x00000000, 0xffffffc0, 0xffffff81, 0xffffffc0 },
  { 0x00000000, 0x00000002, 0x00000002, 0x00000002 },
  { 0x00000000, 0xffffffff, 0xffff8003, 0xffffffff },
  { 0x00000000, 0x00000000, 0x00007ffd, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xaaaaaaaa, 0xffffffff },
  { 0x00000000, 0xffff8000, 0xffff8000, 0xffff8000 },
  { 0x00000000, 0x00000000, 0x00000002, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffffff83, 0xffffffff },
  { 0x00000000, 0x00000000, 0x00007ffe, 0x00000000 },
  { 0x00000000, 0x0000007d, 0x0000007d, 0x0000007d },
  { 0x00000000, 0x00000000, 0x00000002, 0x00000000 },
  { 0x00000000, 0xffffffff, 0x80000001, 0xffffffff },
  { 0x00000000, 0x00000000, 0x00007ffd, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffffff83, 0xffffffff },
  { 0x00000000, 0xc0000000, 0x80000000, 0xc0000000 },
  { 0x00000000, 0x80000000, 0x80000000, 0x80000000 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x00000000, 0xffffff83, 0xffffff83, 0xffffff83 },
  { 0x00000000, 0xffffffff, 0xffffff80, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffff8001, 0xffffffff },
  { 0x00000000, 0xffffc001, 0xffff8003, 0xffffc001 },
  { 0x00000000, 0x00000000, 0x7fffffff, 0x00000000 },
  { 0x00000000, 0x00000000, 0x00000002, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffff8003, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xcccccccc, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffff80, 0xffffffff },
  { 0x00000000, 0x00003ffe, 0x00007ffd, 0x00003ffe },
  { 0x00000000, 0x80000001, 0x80000001, 0x80000001 },
  { 0x00000000, 0x00000000, 0x00007ffd, 0x00000000 },
  { 0x00000000, 0x00000000, 0x0000007f, 0x00000000 },
  { 0x00000000, 0x0000001f, 0x0000007d, 0x0000001f },
  { 0x00000000, 0x3fffffff, 0x7fffffff, 0x3fffffff },
  { 0x00000000, 0xffffffff, 0xffffff81, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffff8001, 0xffffffff },
  { 0x00000000, 0xffffffff, 0x80000001, 0xffffffff },
  { 0x00000000, 0x00000000, 0x0000007f, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffffff81, 0xffffffff },
  { 0x00000000, 0xfffffffe, 0xfffffffd, 0xfffffffe },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x00000000, 0x00000000, 0x55555555, 0x00000000 },
  { 0x00000000, 0x00000000, 0x0000007f, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffff8003, 0xffffffff },
  { 0x00000000, 0x00000000, 0x00007ffd, 0x00000000 },
  { 0x00000000, 0x00000000, 0x33333333, 0x00000000 },
  { 0x00000000, 0xffffffff, 0x80000001, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffff8000, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffff81, 0xffffffff },
  { 0x00000000, 0x00000000, 0x0000007f, 0x00000000 },
  { 0x00000000, 0x0000000f, 0x0000007f, 0x0000000f },
  { 0x00000000, 0x00000000, 0x00007ffd, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xcccccccc, 0xffffffff },
  { 0x00000000, 0x00000000, 0x7ffffffd, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xcccccccc, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xfffffffd, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xcccccccc, 0xffffffff },
  { 0x00000000, 0x00000000, 0x00007fff, 0x00000000 },
  { 0x00000000, 0x00000000, 0x33333333, 0x00000000 },
  { 0x00000000, 0x00000000, 0x0000007d, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffffffe0, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffff8000, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x00000000, 0x7ffffffd, 0x7ffffffd, 0x7ffffffd },
  { 0x00000000, 0x00000000, 0x0000007e, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffff8003, 0xffffffff },
  { 0x00000000, 0x00000000, 0x00000002, 0x00000000 },
  { 0x00000000, 0x00000000, 0x00000001, 0x00000000 },
  { 0x00000000, 0x00000000, 0x33333333, 0x00000000 },
  { 0x00000000, 0x00000000, 0x00000001, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffff8000, 0xffffffff },
  { 0x00000000, 0x00000000, 0x55555555, 0x00000000 },
  { 0x00000000, 0x7ffffffe, 0x7ffffffe, 0x7ffffffe },
  { 0x00000000, 0xffffffff, 0xffffffe0, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffff8003, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xaaaaaaaa, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffff80, 0xffffffff },
  { 0x00000000, 0xffffffff, 0x80000001, 0xffffffff },
  { 0x00000000, 0x00007ffd, 0x00007ffd, 0x00007ffd },
  { 0x00000000, 0xffffffff, 0xffffff80, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xcccccccc, 0xffffffff },
  { 0x00000000, 0x00000000, 0x55555555, 0x00000000 },
  { 0x00000000, 0xffff8000, 0xffff8000, 0xffff8000 },
  { 0x00000000, 0xffffffff, 0xffff8000, 0xffffffff },
  { 0x00000000, 0x0000003e, 0x0000007d, 0x0000003e },
  { 0x00000000, 0xffffffff, 0xffff8002, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffffe0, 0xffffffff },
  { 0x00000000, 0xffff8003, 0xffff8003, 0xffff8003 },
  { 0x00000000, 0xffffffc0, 0xffffff81, 0xffffffc0 },
  { 0x00000000, 0x00000000, 0x00007ffe, 0x00000000 },
};
const Inputs kOutputs_Asr_RdIsRm_al_r4_r9_r4[] = {
  { 0x00000000, 0x00000000, 0x7ffffffe, 0x00000000 },
  { 0x00000000, 0x00000000, 0x00000001, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffffff82, 0xffffffff },
  { 0x00000000, 0xffff8003, 0xffff8003, 0xffff8003 },
  { 0x00000000, 0x00000000, 0x00000000, 0x00000000 },
  { 0x00000000, 0x00000000, 0x00007fff, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffff8002, 0xffffffff },
  { 0x00000000, 0xffff8000, 0xffff8000, 0xffff8000 },
  { 0x00000000, 0x00000000, 0x00000020, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffffff81, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffff82, 0xffffffff },
  { 0x00000000, 0x00000000, 0x00007fff, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffff8000, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffff83, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x00000000, 0x0ccccccc, 0x33333333, 0x0ccccccc },
  { 0x00000000, 0xffffffff, 0xaaaaaaaa, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffff8000, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffff83, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffff82, 0xffffffff },
  { 0x00000000, 0x00000000, 0x0000007d, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x00000000, 0x00000000, 0x0000007f, 0x00000000 },
  { 0x00000000, 0xffffff83, 0xffffff83, 0xffffff83 },
  { 0x00000000, 0xffffffff, 0xffffffe0, 0xffffffff },
  { 0x00000000, 0xffffffff, 0x80000001, 0xffffffff },
  { 0x00000000, 0xffffffff, 0x80000000, 0xffffffff },
  { 0x00000000, 0x0000007d, 0x0000007d, 0x0000007d },
  { 0x00000000, 0xffffffff, 0xffff8003, 0xffffffff },
  { 0x00000000, 0x00003ffe, 0x00007ffd, 0x00003ffe },
  { 0x00000000, 0x00000000, 0x7ffffffe, 0x00000000 },
  { 0x00000000, 0x00000000, 0x00007ffd, 0x00000000 },
  { 0x00000000, 0x00000000, 0x7ffffffd, 0x00000000 },
  { 0x00000000, 0x00000000, 0x0000007f, 0x00000000 },
  { 0x00000000, 0x0000003f, 0x0000007e, 0x0000003f },
  { 0x00000000, 0xffffffff, 0xfffffffd, 0xffffffff },
  { 0x00000000, 0x0fffffff, 0x7ffffffe, 0x0fffffff },
  { 0x00000000, 0x00000000, 0x00000002, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffff8001, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xfffffffe, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffff81, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffff81, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffff81, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xcccccccc, 0xffffffff },
  { 0x00000000, 0x00000000, 0x55555555, 0x00000000 },
  { 0x00000000, 0x00000fff, 0x00007ffd, 0x00000fff },
  { 0x00000000, 0xc0000000, 0x80000001, 0xc0000000 },
  { 0x00000000, 0xffffffff, 0xfffffffd, 0xffffffff },
  { 0x00000000, 0xfffffffe, 0xfffffffe, 0xfffffffe },
  { 0x00000000, 0x00000000, 0x0000007f, 0x00000000 },
  { 0x00000000, 0x00000001, 0x00000002, 0x00000001 },
  { 0x00000000, 0xffffffff, 0xffffff81, 0xffffffff },
  { 0x00000000, 0x00000000, 0x00007ffd, 0x00000000 },
  { 0x00000000, 0x19999999, 0x33333333, 0x19999999 },
  { 0x00000000, 0xffffffff, 0xffff8002, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xfffffffd, 0xffffffff },
  { 0x00000000, 0x00000000, 0x00000020, 0x00000000 },
  { 0x00000000, 0xffffc001, 0xffff8003, 0xffffc001 },
  { 0x00000000, 0xc0000000, 0x80000001, 0xc0000000 },
  { 0x00000000, 0x00000000, 0x00000002, 0x00000000 },
  { 0x00000000, 0x0fffffff, 0x7ffffffd, 0x0fffffff },
  { 0x00000000, 0xffffffff, 0xaaaaaaaa, 0xffffffff },
  { 0x00000000, 0x00000000, 0x7fffffff, 0x00000000 },
  { 0x00000000, 0x00000000, 0x00007ffe, 0x00000000 },
  { 0x00000000, 0xffffffff, 0x80000001, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xfffffffe, 0xffffffff },
  { 0x00000000, 0xffffffc0, 0xffffff80, 0xffffffc0 },
  { 0x00000000, 0xffffffff, 0xcccccccc, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffffe0, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xfffffffe, 0xffffffff },
  { 0x00000000, 0x00000000, 0x00007ffe, 0x00000000 },
  { 0x00000000, 0xffffffff, 0x80000001, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffff8001, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffff83, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xcccccccc, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffff83, 0xffffffff },
  { 0x00000000, 0xffffffff, 0x80000000, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffff8000, 0xffffffff },
  { 0x00000000, 0x00000000, 0x33333333, 0x00000000 },
  { 0x00000000, 0x00000000, 0x7ffffffd, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffff8001, 0xffffffff },
  { 0x00000000, 0xeaaaaaaa, 0xaaaaaaaa, 0xeaaaaaaa },
  { 0x00000000, 0x00000000, 0x7fffffff, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xfffffffe, 0xffffffff },
  { 0x00000000, 0x00000000, 0x00000001, 0x00000000 },
  { 0x00000000, 0x00000000, 0x00000001, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffffff80, 0xffffffff },
  { 0x00000000, 0x00000000, 0x00007fff, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xaaaaaaaa, 0xffffffff },
  { 0x00000000, 0x00001fff, 0x00007ffe, 0x00001fff },
  { 0x00000000, 0xe6666666, 0xcccccccc, 0xe6666666 },
  { 0x00000000, 0x00000000, 0x00000000, 0x00000000 },
  { 0x00000000, 0xffffc000, 0xffff8000, 0xffffc000 },
  { 0x00000000, 0x00000000, 0x00007fff, 0x00000000 },
  { 0x00000000, 0x00000000, 0x00007fff, 0x00000000 },
  { 0x00000000, 0x00000000, 0x00000001, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffff8002, 0xffffffff },
  { 0x00000000, 0x00000000, 0x7ffffffe, 0x00000000 },
  { 0x00000000, 0xd5555555, 0xaaaaaaaa, 0xd5555555 },
  { 0x00000000, 0xe6666666, 0xcccccccc, 0xe6666666 },
  { 0x00000000, 0xffffffff, 0xffffffe0, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xfffffffd, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xaaaaaaaa, 0xffffffff },
  { 0x00000000, 0x00000000, 0x00000001, 0x00000000 },
  { 0x00000000, 0x00000000, 0x00007fff, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xfffffffd, 0xffffffff },
  { 0x00000000, 0x00000000, 0x0000007d, 0x00000000 },
  { 0x00000000, 0x00000000, 0x7fffffff, 0x00000000 },
  { 0x00000000, 0x00000000, 0x0000007d, 0x00000000 },
  { 0x00000000, 0xffffffc0, 0xffffff81, 0xffffffc0 },
  { 0x00000000, 0x00000002, 0x00000002, 0x00000002 },
  { 0x00000000, 0xffffffff, 0xffff8003, 0xffffffff },
  { 0x00000000, 0x00000000, 0x00007ffd, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xaaaaaaaa, 0xffffffff },
  { 0x00000000, 0xffff8000, 0xffff8000, 0xffff8000 },
  { 0x00000000, 0x00000000, 0x00000002, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffffff83, 0xffffffff },
  { 0x00000000, 0x00000000, 0x00007ffe, 0x00000000 },
  { 0x00000000, 0x0000007d, 0x0000007d, 0x0000007d },
  { 0x00000000, 0x00000000, 0x00000002, 0x00000000 },
  { 0x00000000, 0xffffffff, 0x80000001, 0xffffffff },
  { 0x00000000, 0x00000000, 0x00007ffd, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffffff83, 0xffffffff },
  { 0x00000000, 0xc0000000, 0x80000000, 0xc0000000 },
  { 0x00000000, 0x80000000, 0x80000000, 0x80000000 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x00000000, 0xffffff83, 0xffffff83, 0xffffff83 },
  { 0x00000000, 0xffffffff, 0xffffff80, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffff8001, 0xffffffff },
  { 0x00000000, 0xffffc001, 0xffff8003, 0xffffc001 },
  { 0x00000000, 0x00000000, 0x7fffffff, 0x00000000 },
  { 0x00000000, 0x00000000, 0x00000002, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffff8003, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xcccccccc, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffff80, 0xffffffff },
  { 0x00000000, 0x00003ffe, 0x00007ffd, 0x00003ffe },
  { 0x00000000, 0x80000001, 0x80000001, 0x80000001 },
  { 0x00000000, 0x00000000, 0x00007ffd, 0x00000000 },
  { 0x00000000, 0x00000000, 0x0000007f, 0x00000000 },
  { 0x00000000, 0x0000001f, 0x0000007d, 0x0000001f },
  { 0x00000000, 0x3fffffff, 0x7fffffff, 0x3fffffff },
  { 0x00000000, 0xffffffff, 0xffffff81, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffff8001, 0xffffffff },
  { 0x00000000, 0xffffffff, 0x80000001, 0xffffffff },
  { 0x00000000, 0x00000000, 0x0000007f, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffffff81, 0xffffffff },
  { 0x00000000, 0xfffffffe, 0xfffffffd, 0xfffffffe },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x00000000, 0x00000000, 0x55555555, 0x00000000 },
  { 0x00000000, 0x00000000, 0x0000007f, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffff8003, 0xffffffff },
  { 0x00000000, 0x00000000, 0x00007ffd, 0x00000000 },
  { 0x00000000, 0x00000000, 0x33333333, 0x00000000 },
  { 0x00000000, 0xffffffff, 0x80000001, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffff8000, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffff81, 0xffffffff },
  { 0x00000000, 0x00000000, 0x0000007f, 0x00000000 },
  { 0x00000000, 0x0000000f, 0x0000007f, 0x0000000f },
  { 0x00000000, 0x00000000, 0x00007ffd, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xcccccccc, 0xffffffff },
  { 0x00000000, 0x00000000, 0x7ffffffd, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xcccccccc, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xfffffffd, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xcccccccc, 0xffffffff },
  { 0x00000000, 0x00000000, 0x00007fff, 0x00000000 },
  { 0x00000000, 0x00000000, 0x33333333, 0x00000000 },
  { 0x00000000, 0x00000000, 0x0000007d, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffffffe0, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffff8000, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x00000000, 0x7ffffffd, 0x7ffffffd, 0x7ffffffd },
  { 0x00000000, 0x00000000, 0x0000007e, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffff8003, 0xffffffff },
  { 0x00000000, 0x00000000, 0x00000002, 0x00000000 },
  { 0x00000000, 0x00000000, 0x00000001, 0x00000000 },
  { 0x00000000, 0x00000000, 0x33333333, 0x00000000 },
  { 0x00000000, 0x00000000, 0x00000001, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffff8000, 0xffffffff },
  { 0x00000000, 0x00000000, 0x55555555, 0x00000000 },
  { 0x00000000, 0x7ffffffe, 0x7ffffffe, 0x7ffffffe },
  { 0x00000000, 0xffffffff, 0xffffffe0, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffff8003, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xaaaaaaaa, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffff80, 0xffffffff },
  { 0x00000000, 0xffffffff, 0x80000001, 0xffffffff },
  { 0x00000000, 0x00007ffd, 0x00007ffd, 0x00007ffd },
  { 0x00000000, 0xffffffff, 0xffffff80, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xcccccccc, 0xffffffff },
  { 0x00000000, 0x00000000, 0x55555555, 0x00000000 },
  { 0x00000000, 0xffff8000, 0xffff8000, 0xffff8000 },
  { 0x00000000, 0xffffffff, 0xffff8000, 0xffffffff },
  { 0x00000000, 0x0000003e, 0x0000007d, 0x0000003e },
  { 0x00000000, 0xffffffff, 0xffff8002, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffffe0, 0xffffffff },
  { 0x00000000, 0xffff8003, 0xffff8003, 0xffff8003 },
  { 0x00000000, 0xffffffc0, 0xffffff81, 0xffffffc0 },
  { 0x00000000, 0x00000000, 0x00007ffe, 0x00000000 },
};
const Inputs kOutputs_Asr_RdIsRm_al_r6_r10_r6[] = {
  { 0x00000000, 0x00000000, 0x7ffffffe, 0x00000000 },
  { 0x00000000, 0x00000000, 0x00000001, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffffff82, 0xffffffff },
  { 0x00000000, 0xffff8003, 0xffff8003, 0xffff8003 },
  { 0x00000000, 0x00000000, 0x00000000, 0x00000000 },
  { 0x00000000, 0x00000000, 0x00007fff, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffff8002, 0xffffffff },
  { 0x00000000, 0xffff8000, 0xffff8000, 0xffff8000 },
  { 0x00000000, 0x00000000, 0x00000020, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffffff81, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffff82, 0xffffffff },
  { 0x00000000, 0x00000000, 0x00007fff, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffff8000, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffff83, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x00000000, 0x0ccccccc, 0x33333333, 0x0ccccccc },
  { 0x00000000, 0xffffffff, 0xaaaaaaaa, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffff8000, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffff83, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffff82, 0xffffffff },
  { 0x00000000, 0x00000000, 0x0000007d, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x00000000, 0x00000000, 0x0000007f, 0x00000000 },
  { 0x00000000, 0xffffff83, 0xffffff83, 0xffffff83 },
  { 0x00000000, 0xffffffff, 0xffffffe0, 0xffffffff },
  { 0x00000000, 0xffffffff, 0x80000001, 0xffffffff },
  { 0x00000000, 0xffffffff, 0x80000000, 0xffffffff },
  { 0x00000000, 0x0000007d, 0x0000007d, 0x0000007d },
  { 0x00000000, 0xffffffff, 0xffff8003, 0xffffffff },
  { 0x00000000, 0x00003ffe, 0x00007ffd, 0x00003ffe },
  { 0x00000000, 0x00000000, 0x7ffffffe, 0x00000000 },
  { 0x00000000, 0x00000000, 0x00007ffd, 0x00000000 },
  { 0x00000000, 0x00000000, 0x7ffffffd, 0x00000000 },
  { 0x00000000, 0x00000000, 0x0000007f, 0x00000000 },
  { 0x00000000, 0x0000003f, 0x0000007e, 0x0000003f },
  { 0x00000000, 0xffffffff, 0xfffffffd, 0xffffffff },
  { 0x00000000, 0x0fffffff, 0x7ffffffe, 0x0fffffff },
  { 0x00000000, 0x00000000, 0x00000002, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffff8001, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xfffffffe, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffff81, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffff81, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffff81, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xcccccccc, 0xffffffff },
  { 0x00000000, 0x00000000, 0x55555555, 0x00000000 },
  { 0x00000000, 0x00000fff, 0x00007ffd, 0x00000fff },
  { 0x00000000, 0xc0000000, 0x80000001, 0xc0000000 },
  { 0x00000000, 0xffffffff, 0xfffffffd, 0xffffffff },
  { 0x00000000, 0xfffffffe, 0xfffffffe, 0xfffffffe },
  { 0x00000000, 0x00000000, 0x0000007f, 0x00000000 },
  { 0x00000000, 0x00000001, 0x00000002, 0x00000001 },
  { 0x00000000, 0xffffffff, 0xffffff81, 0xffffffff },
  { 0x00000000, 0x00000000, 0x00007ffd, 0x00000000 },
  { 0x00000000, 0x19999999, 0x33333333, 0x19999999 },
  { 0x00000000, 0xffffffff, 0xffff8002, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xfffffffd, 0xffffffff },
  { 0x00000000, 0x00000000, 0x00000020, 0x00000000 },
  { 0x00000000, 0xffffc001, 0xffff8003, 0xffffc001 },
  { 0x00000000, 0xc0000000, 0x80000001, 0xc0000000 },
  { 0x00000000, 0x00000000, 0x00000002, 0x00000000 },
  { 0x00000000, 0x0fffffff, 0x7ffffffd, 0x0fffffff },
  { 0x00000000, 0xffffffff, 0xaaaaaaaa, 0xffffffff },
  { 0x00000000, 0x00000000, 0x7fffffff, 0x00000000 },
  { 0x00000000, 0x00000000, 0x00007ffe, 0x00000000 },
  { 0x00000000, 0xffffffff, 0x80000001, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xfffffffe, 0xffffffff },
  { 0x00000000, 0xffffffc0, 0xffffff80, 0xffffffc0 },
  { 0x00000000, 0xffffffff, 0xcccccccc, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffffe0, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xfffffffe, 0xffffffff },
  { 0x00000000, 0x00000000, 0x00007ffe, 0x00000000 },
  { 0x00000000, 0xffffffff, 0x80000001, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffff8001, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffff83, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xcccccccc, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffff83, 0xffffffff },
  { 0x00000000, 0xffffffff, 0x80000000, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffff8000, 0xffffffff },
  { 0x00000000, 0x00000000, 0x33333333, 0x00000000 },
  { 0x00000000, 0x00000000, 0x7ffffffd, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffff8001, 0xffffffff },
  { 0x00000000, 0xeaaaaaaa, 0xaaaaaaaa, 0xeaaaaaaa },
  { 0x00000000, 0x00000000, 0x7fffffff, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xfffffffe, 0xffffffff },
  { 0x00000000, 0x00000000, 0x00000001, 0x00000000 },
  { 0x00000000, 0x00000000, 0x00000001, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffffff80, 0xffffffff },
  { 0x00000000, 0x00000000, 0x00007fff, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xaaaaaaaa, 0xffffffff },
  { 0x00000000, 0x00001fff, 0x00007ffe, 0x00001fff },
  { 0x00000000, 0xe6666666, 0xcccccccc, 0xe6666666 },
  { 0x00000000, 0x00000000, 0x00000000, 0x00000000 },
  { 0x00000000, 0xffffc000, 0xffff8000, 0xffffc000 },
  { 0x00000000, 0x00000000, 0x00007fff, 0x00000000 },
  { 0x00000000, 0x00000000, 0x00007fff, 0x00000000 },
  { 0x00000000, 0x00000000, 0x00000001, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffff8002, 0xffffffff },
  { 0x00000000, 0x00000000, 0x7ffffffe, 0x00000000 },
  { 0x00000000, 0xd5555555, 0xaaaaaaaa, 0xd5555555 },
  { 0x00000000, 0xe6666666, 0xcccccccc, 0xe6666666 },
  { 0x00000000, 0xffffffff, 0xffffffe0, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xfffffffd, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xaaaaaaaa, 0xffffffff },
  { 0x00000000, 0x00000000, 0x00000001, 0x00000000 },
  { 0x00000000, 0x00000000, 0x00007fff, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xfffffffd, 0xffffffff },
  { 0x00000000, 0x00000000, 0x0000007d, 0x00000000 },
  { 0x00000000, 0x00000000, 0x7fffffff, 0x00000000 },
  { 0x00000000, 0x00000000, 0x0000007d, 0x00000000 },
  { 0x00000000, 0xffffffc0, 0xffffff81, 0xffffffc0 },
  { 0x00000000, 0x00000002, 0x00000002, 0x00000002 },
  { 0x00000000, 0xffffffff, 0xffff8003, 0xffffffff },
  { 0x00000000, 0x00000000, 0x00007ffd, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xaaaaaaaa, 0xffffffff },
  { 0x00000000, 0xffff8000, 0xffff8000, 0xffff8000 },
  { 0x00000000, 0x00000000, 0x00000002, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffffff83, 0xffffffff },
  { 0x00000000, 0x00000000, 0x00007ffe, 0x00000000 },
  { 0x00000000, 0x0000007d, 0x0000007d, 0x0000007d },
  { 0x00000000, 0x00000000, 0x00000002, 0x00000000 },
  { 0x00000000, 0xffffffff, 0x80000001, 0xffffffff },
  { 0x00000000, 0x00000000, 0x00007ffd, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffffff83, 0xffffffff },
  { 0x00000000, 0xc0000000, 0x80000000, 0xc0000000 },
  { 0x00000000, 0x80000000, 0x80000000, 0x80000000 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x00000000, 0xffffff83, 0xffffff83, 0xffffff83 },
  { 0x00000000, 0xffffffff, 0xffffff80, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffff8001, 0xffffffff },
  { 0x00000000, 0xffffc001, 0xffff8003, 0xffffc001 },
  { 0x00000000, 0x00000000, 0x7fffffff, 0x00000000 },
  { 0x00000000, 0x00000000, 0x00000002, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffff8003, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xcccccccc, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffff80, 0xffffffff },
  { 0x00000000, 0x00003ffe, 0x00007ffd, 0x00003ffe },
  { 0x00000000, 0x80000001, 0x80000001, 0x80000001 },
  { 0x00000000, 0x00000000, 0x00007ffd, 0x00000000 },
  { 0x00000000, 0x00000000, 0x0000007f, 0x00000000 },
  { 0x00000000, 0x0000001f, 0x0000007d, 0x0000001f },
  { 0x00000000, 0x3fffffff, 0x7fffffff, 0x3fffffff },
  { 0x00000000, 0xffffffff, 0xffffff81, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffff8001, 0xffffffff },
  { 0x00000000, 0xffffffff, 0x80000001, 0xffffffff },
  { 0x00000000, 0x00000000, 0x0000007f, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffffff81, 0xffffffff },
  { 0x00000000, 0xfffffffe, 0xfffffffd, 0xfffffffe },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x00000000, 0x00000000, 0x55555555, 0x00000000 },
  { 0x00000000, 0x00000000, 0x0000007f, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffff8003, 0xffffffff },
  { 0x00000000, 0x00000000, 0x00007ffd, 0x00000000 },
  { 0x00000000, 0x00000000, 0x33333333, 0x00000000 },
  { 0x00000000, 0xffffffff, 0x80000001, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffff8000, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffff81, 0xffffffff },
  { 0x00000000, 0x00000000, 0x0000007f, 0x00000000 },
  { 0x00000000, 0x0000000f, 0x0000007f, 0x0000000f },
  { 0x00000000, 0x00000000, 0x00007ffd, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xcccccccc, 0xffffffff },
  { 0x00000000, 0x00000000, 0x7ffffffd, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xcccccccc, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xfffffffd, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xcccccccc, 0xffffffff },
  { 0x00000000, 0x00000000, 0x00007fff, 0x00000000 },
  { 0x00000000, 0x00000000, 0x33333333, 0x00000000 },
  { 0x00000000, 0x00000000, 0x0000007d, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffffffe0, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffff8000, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x00000000, 0x7ffffffd, 0x7ffffffd, 0x7ffffffd },
  { 0x00000000, 0x00000000, 0x0000007e, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffff8003, 0xffffffff },
  { 0x00000000, 0x00000000, 0x00000002, 0x00000000 },
  { 0x00000000, 0x00000000, 0x00000001, 0x00000000 },
  { 0x00000000, 0x00000000, 0x33333333, 0x00000000 },
  { 0x00000000, 0x00000000, 0x00000001, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffff8000, 0xffffffff },
  { 0x00000000, 0x00000000, 0x55555555, 0x00000000 },
  { 0x00000000, 0x7ffffffe, 0x7ffffffe, 0x7ffffffe },
  { 0x00000000, 0xffffffff, 0xffffffe0, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffff8003, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xaaaaaaaa, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffff80, 0xffffffff },
  { 0x00000000, 0xffffffff, 0x80000001, 0xffffffff },
  { 0x00000000, 0x00007ffd, 0x00007ffd, 0x00007ffd },
  { 0x00000000, 0xffffffff, 0xffffff80, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xcccccccc, 0xffffffff },
  { 0x00000000, 0x00000000, 0x55555555, 0x00000000 },
  { 0x00000000, 0xffff8000, 0xffff8000, 0xffff8000 },
  { 0x00000000, 0xffffffff, 0xffff8000, 0xffffffff },
  { 0x00000000, 0x0000003e, 0x0000007d, 0x0000003e },
  { 0x00000000, 0xffffffff, 0xffff8002, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffffe0, 0xffffffff },
  { 0x00000000, 0xffff8003, 0xffff8003, 0xffff8003 },
  { 0x00000000, 0xffffffc0, 0xffffff81, 0xffffffc0 },
  { 0x00000000, 0x00000000, 0x00007ffe, 0x00000000 },
};
const Inputs kOutputs_Asr_RdIsRm_al_r7_r6_r7[] = {
  { 0x00000000, 0x00000000, 0x7ffffffe, 0x00000000 },
  { 0x00000000, 0x00000000, 0x00000001, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffffff82, 0xffffffff },
  { 0x00000000, 0xffff8003, 0xffff8003, 0xffff8003 },
  { 0x00000000, 0x00000000, 0x00000000, 0x00000000 },
  { 0x00000000, 0x00000000, 0x00007fff, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffff8002, 0xffffffff },
  { 0x00000000, 0xffff8000, 0xffff8000, 0xffff8000 },
  { 0x00000000, 0x00000000, 0x00000020, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffffff81, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffff82, 0xffffffff },
  { 0x00000000, 0x00000000, 0x00007fff, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffff8000, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffff83, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x00000000, 0x0ccccccc, 0x33333333, 0x0ccccccc },
  { 0x00000000, 0xffffffff, 0xaaaaaaaa, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffff8000, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffff83, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffff82, 0xffffffff },
  { 0x00000000, 0x00000000, 0x0000007d, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x00000000, 0x00000000, 0x0000007f, 0x00000000 },
  { 0x00000000, 0xffffff83, 0xffffff83, 0xffffff83 },
  { 0x00000000, 0xffffffff, 0xffffffe0, 0xffffffff },
  { 0x00000000, 0xffffffff, 0x80000001, 0xffffffff },
  { 0x00000000, 0xffffffff, 0x80000000, 0xffffffff },
  { 0x00000000, 0x0000007d, 0x0000007d, 0x0000007d },
  { 0x00000000, 0xffffffff, 0xffff8003, 0xffffffff },
  { 0x00000000, 0x00003ffe, 0x00007ffd, 0x00003ffe },
  { 0x00000000, 0x00000000, 0x7ffffffe, 0x00000000 },
  { 0x00000000, 0x00000000, 0x00007ffd, 0x00000000 },
  { 0x00000000, 0x00000000, 0x7ffffffd, 0x00000000 },
  { 0x00000000, 0x00000000, 0x0000007f, 0x00000000 },
  { 0x00000000, 0x0000003f, 0x0000007e, 0x0000003f },
  { 0x00000000, 0xffffffff, 0xfffffffd, 0xffffffff },
  { 0x00000000, 0x0fffffff, 0x7ffffffe, 0x0fffffff },
  { 0x00000000, 0x00000000, 0x00000002, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffff8001, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xfffffffe, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffff81, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffff81, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffff81, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xcccccccc, 0xffffffff },
  { 0x00000000, 0x00000000, 0x55555555, 0x00000000 },
  { 0x00000000, 0x00000fff, 0x00007ffd, 0x00000fff },
  { 0x00000000, 0xc0000000, 0x80000001, 0xc0000000 },
  { 0x00000000, 0xffffffff, 0xfffffffd, 0xffffffff },
  { 0x00000000, 0xfffffffe, 0xfffffffe, 0xfffffffe },
  { 0x00000000, 0x00000000, 0x0000007f, 0x00000000 },
  { 0x00000000, 0x00000001, 0x00000002, 0x00000001 },
  { 0x00000000, 0xffffffff, 0xffffff81, 0xffffffff },
  { 0x00000000, 0x00000000, 0x00007ffd, 0x00000000 },
  { 0x00000000, 0x19999999, 0x33333333, 0x19999999 },
  { 0x00000000, 0xffffffff, 0xffff8002, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xfffffffd, 0xffffffff },
  { 0x00000000, 0x00000000, 0x00000020, 0x00000000 },
  { 0x00000000, 0xffffc001, 0xffff8003, 0xffffc001 },
  { 0x00000000, 0xc0000000, 0x80000001, 0xc0000000 },
  { 0x00000000, 0x00000000, 0x00000002, 0x00000000 },
  { 0x00000000, 0x0fffffff, 0x7ffffffd, 0x0fffffff },
  { 0x00000000, 0xffffffff, 0xaaaaaaaa, 0xffffffff },
  { 0x00000000, 0x00000000, 0x7fffffff, 0x00000000 },
  { 0x00000000, 0x00000000, 0x00007ffe, 0x00000000 },
  { 0x00000000, 0xffffffff, 0x80000001, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xfffffffe, 0xffffffff },
  { 0x00000000, 0xffffffc0, 0xffffff80, 0xffffffc0 },
  { 0x00000000, 0xffffffff, 0xcccccccc, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffffe0, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xfffffffe, 0xffffffff },
  { 0x00000000, 0x00000000, 0x00007ffe, 0x00000000 },
  { 0x00000000, 0xffffffff, 0x80000001, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffff8001, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffff83, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xcccccccc, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffff83, 0xffffffff },
  { 0x00000000, 0xffffffff, 0x80000000, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffff8000, 0xffffffff },
  { 0x00000000, 0x00000000, 0x33333333, 0x00000000 },
  { 0x00000000, 0x00000000, 0x7ffffffd, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffff8001, 0xffffffff },
  { 0x00000000, 0xeaaaaaaa, 0xaaaaaaaa, 0xeaaaaaaa },
  { 0x00000000, 0x00000000, 0x7fffffff, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xfffffffe, 0xffffffff },
  { 0x00000000, 0x00000000, 0x00000001, 0x00000000 },
  { 0x00000000, 0x00000000, 0x00000001, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffffff80, 0xffffffff },
  { 0x00000000, 0x00000000, 0x00007fff, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xaaaaaaaa, 0xffffffff },
  { 0x00000000, 0x00001fff, 0x00007ffe, 0x00001fff },
  { 0x00000000, 0xe6666666, 0xcccccccc, 0xe6666666 },
  { 0x00000000, 0x00000000, 0x00000000, 0x00000000 },
  { 0x00000000, 0xffffc000, 0xffff8000, 0xffffc000 },
  { 0x00000000, 0x00000000, 0x00007fff, 0x00000000 },
  { 0x00000000, 0x00000000, 0x00007fff, 0x00000000 },
  { 0x00000000, 0x00000000, 0x00000001, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffff8002, 0xffffffff },
  { 0x00000000, 0x00000000, 0x7ffffffe, 0x00000000 },
  { 0x00000000, 0xd5555555, 0xaaaaaaaa, 0xd5555555 },
  { 0x00000000, 0xe6666666, 0xcccccccc, 0xe6666666 },
  { 0x00000000, 0xffffffff, 0xffffffe0, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xfffffffd, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xaaaaaaaa, 0xffffffff },
  { 0x00000000, 0x00000000, 0x00000001, 0x00000000 },
  { 0x00000000, 0x00000000, 0x00007fff, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xfffffffd, 0xffffffff },
  { 0x00000000, 0x00000000, 0x0000007d, 0x00000000 },
  { 0x00000000, 0x00000000, 0x7fffffff, 0x00000000 },
  { 0x00000000, 0x00000000, 0x0000007d, 0x00000000 },
  { 0x00000000, 0xffffffc0, 0xffffff81, 0xffffffc0 },
  { 0x00000000, 0x00000002, 0x00000002, 0x00000002 },
  { 0x00000000, 0xffffffff, 0xffff8003, 0xffffffff },
  { 0x00000000, 0x00000000, 0x00007ffd, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xaaaaaaaa, 0xffffffff },
  { 0x00000000, 0xffff8000, 0xffff8000, 0xffff8000 },
  { 0x00000000, 0x00000000, 0x00000002, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffffff83, 0xffffffff },
  { 0x00000000, 0x00000000, 0x00007ffe, 0x00000000 },
  { 0x00000000, 0x0000007d, 0x0000007d, 0x0000007d },
  { 0x00000000, 0x00000000, 0x00000002, 0x00000000 },
  { 0x00000000, 0xffffffff, 0x80000001, 0xffffffff },
  { 0x00000000, 0x00000000, 0x00007ffd, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffffff83, 0xffffffff },
  { 0x00000000, 0xc0000000, 0x80000000, 0xc0000000 },
  { 0x00000000, 0x80000000, 0x80000000, 0x80000000 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x00000000, 0xffffff83, 0xffffff83, 0xffffff83 },
  { 0x00000000, 0xffffffff, 0xffffff80, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffff8001, 0xffffffff },
  { 0x00000000, 0xffffc001, 0xffff8003, 0xffffc001 },
  { 0x00000000, 0x00000000, 0x7fffffff, 0x00000000 },
  { 0x00000000, 0x00000000, 0x00000002, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffff8003, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xcccccccc, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffff80, 0xffffffff },
  { 0x00000000, 0x00003ffe, 0x00007ffd, 0x00003ffe },
  { 0x00000000, 0x80000001, 0x80000001, 0x80000001 },
  { 0x00000000, 0x00000000, 0x00007ffd, 0x00000000 },
  { 0x00000000, 0x00000000, 0x0000007f, 0x00000000 },
  { 0x00000000, 0x0000001f, 0x0000007d, 0x0000001f },
  { 0x00000000, 0x3fffffff, 0x7fffffff, 0x3fffffff },
  { 0x00000000, 0xffffffff, 0xffffff81, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffff8001, 0xffffffff },
  { 0x00000000, 0xffffffff, 0x80000001, 0xffffffff },
  { 0x00000000, 0x00000000, 0x0000007f, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffffff81, 0xffffffff },
  { 0x00000000, 0xfffffffe, 0xfffffffd, 0xfffffffe },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x00000000, 0x00000000, 0x55555555, 0x00000000 },
  { 0x00000000, 0x00000000, 0x0000007f, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffff8003, 0xffffffff },
  { 0x00000000, 0x00000000, 0x00007ffd, 0x00000000 },
  { 0x00000000, 0x00000000, 0x33333333, 0x00000000 },
  { 0x00000000, 0xffffffff, 0x80000001, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffff8000, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffff81, 0xffffffff },
  { 0x00000000, 0x00000000, 0x0000007f, 0x00000000 },
  { 0x00000000, 0x0000000f, 0x0000007f, 0x0000000f },
  { 0x00000000, 0x00000000, 0x00007ffd, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xcccccccc, 0xffffffff },
  { 0x00000000, 0x00000000, 0x7ffffffd, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xcccccccc, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xfffffffd, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xcccccccc, 0xffffffff },
  { 0x00000000, 0x00000000, 0x00007fff, 0x00000000 },
  { 0x00000000, 0x00000000, 0x33333333, 0x00000000 },
  { 0x00000000, 0x00000000, 0x0000007d, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffffffe0, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffff8000, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x00000000, 0x7ffffffd, 0x7ffffffd, 0x7ffffffd },
  { 0x00000000, 0x00000000, 0x0000007e, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffff8003, 0xffffffff },
  { 0x00000000, 0x00000000, 0x00000002, 0x00000000 },
  { 0x00000000, 0x00000000, 0x00000001, 0x00000000 },
  { 0x00000000, 0x00000000, 0x33333333, 0x00000000 },
  { 0x00000000, 0x00000000, 0x00000001, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffff8000, 0xffffffff },
  { 0x00000000, 0x00000000, 0x55555555, 0x00000000 },
  { 0x00000000, 0x7ffffffe, 0x7ffffffe, 0x7ffffffe },
  { 0x00000000, 0xffffffff, 0xffffffe0, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffff8003, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xaaaaaaaa, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffff80, 0xffffffff },
  { 0x00000000, 0xffffffff, 0x80000001, 0xffffffff },
  { 0x00000000, 0x00007ffd, 0x00007ffd, 0x00007ffd },
  { 0x00000000, 0xffffffff, 0xffffff80, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xcccccccc, 0xffffffff },
  { 0x00000000, 0x00000000, 0x55555555, 0x00000000 },
  { 0x00000000, 0xffff8000, 0xffff8000, 0xffff8000 },
  { 0x00000000, 0xffffffff, 0xffff8000, 0xffffffff },
  { 0x00000000, 0x0000003e, 0x0000007d, 0x0000003e },
  { 0x00000000, 0xffffffff, 0xffff8002, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffffe0, 0xffffffff },
  { 0x00000000, 0xffff8003, 0xffff8003, 0xffff8003 },
  { 0x00000000, 0xffffffc0, 0xffffff81, 0xffffffc0 },
  { 0x00000000, 0x00000000, 0x00007ffe, 0x00000000 },
};
const Inputs kOutputs_Asr_RdIsNotRnIsNotRm_al_r3_r9_r10[] = {
  { 0x00000000, 0x00000000, 0x0000007e, 0x0000007d },
  { 0x00000000, 0x00000000, 0x00000002, 0xffff8002 },
  { 0x00000000, 0x80000001, 0x80000001, 0x00000000 },
  { 0x00000000, 0xffffffe0, 0xffffff83, 0x00000002 },
  { 0x00000000, 0xfffffff8, 0xffffffe0, 0x00000002 },
  { 0x00000000, 0xffffffff, 0x80000001, 0xffffff82 },
  { 0x00000000, 0x00000000, 0x00007fff, 0x0000007f },
  { 0x00000000, 0x00000000, 0x0000007d, 0x7ffffffe },
  { 0x00000000, 0x00000008, 0x00000020, 0xffff8002 },
  { 0x00000000, 0x2aaaaaaa, 0x55555555, 0x00000001 },
  { 0x00000000, 0x33333333, 0x33333333, 0x00000000 },
  { 0x00000000, 0x00000000, 0x7ffffffd, 0x55555555 },
  { 0x00000000, 0xffffffff, 0xffff8001, 0x7ffffffe },
  { 0x00000000, 0xfffffff0, 0xffffff83, 0xffff8003 },
  { 0x00000000, 0xffffffff, 0xffffffe0, 0xffffff81 },
  { 0x00000000, 0xffffffff, 0xffff8001, 0x0000007e },
  { 0x00000000, 0x00000000, 0x0000007e, 0x00000020 },
  { 0x00000000, 0xffffffff, 0xfffffffd, 0xaaaaaaaa },
  { 0x00000000, 0xffffffff, 0xffffff82, 0x7ffffffd },
  { 0x00000000, 0xffffffff, 0xcccccccc, 0x7fffffff },
  { 0x00000000, 0xffffffff, 0x80000001, 0xffffffff },
  { 0x00000000, 0x00000000, 0x00000020, 0x7ffffffe },
  { 0x00000000, 0xffffffff, 0xffffff81, 0xffffffe0 },
  { 0x00000000, 0xffffffff, 0xffffff81, 0xfffffffd },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffff8000, 0xcccccccc },
  { 0x00000000, 0x00000000, 0x00007ffe, 0xffffff82 },
  { 0x00000000, 0x0000000f, 0x0000007d, 0xffff8003 },
  { 0x00000000, 0xffffffff, 0xffffff81, 0x0000007e },
  { 0x00000000, 0x00000000, 0x7ffffffd, 0xfffffffe },
  { 0x00000000, 0xffffffff, 0x80000001, 0xffffff81 },
  { 0x00000000, 0x00000000, 0x00007ffd, 0xfffffffd },
  { 0x00000000, 0x0fffffff, 0x7fffffff, 0xffff8003 },
  { 0x00000000, 0x00000000, 0x0000007d, 0x33333333 },
  { 0x00000000, 0xffffffff, 0xffff8000, 0x00007ffe },
  { 0x00000000, 0xffffffff, 0xffff8000, 0x00000020 },
  { 0x00000000, 0x00000000, 0x00007fff, 0xffffffe0 },
  { 0x00000000, 0x00000000, 0x00000000, 0x00007ffe },
  { 0x00000000, 0x19999999, 0x33333333, 0x00000001 },
  { 0x00000000, 0xffffffff, 0xffffff80, 0x00000020 },
  { 0x00000000, 0xffffffff, 0xffffff83, 0x00007ffd },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x80000001 },
  { 0x00000000, 0xffffffff, 0xffffff81, 0xcccccccc },
  { 0x00000000, 0x0000003f, 0x0000007f, 0xffff8001 },
  { 0x00000000, 0x00000020, 0x00000020, 0x80000000 },
  { 0x00000000, 0x00000000, 0x00007fff, 0xffffff80 },
  { 0x00000000, 0x00000000, 0x7ffffffe, 0x7ffffffd },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00000001 },
  { 0x00000000, 0x00000000, 0x7ffffffd, 0xffffff83 },
  { 0x00000000, 0xffffffff, 0xffff8001, 0xffffffe0 },
  { 0x00000000, 0xffffffff, 0xffffff80, 0x00007ffd },
  { 0x00000000, 0x00000000, 0x00007fff, 0x00007ffe },
  { 0x00000000, 0x00000000, 0x00000000, 0xffff8000 },
  { 0x00000000, 0xffffffff, 0xaaaaaaaa, 0x7ffffffe },
  { 0x00000000, 0x00000000, 0x00007ffd, 0xffffffe0 },
  { 0x00000000, 0xffffffff, 0xffffffe0, 0xffffff83 },
  { 0x00000000, 0xffffffff, 0xffffffe0, 0x7ffffffd },
  { 0x00000000, 0xffff8002, 0xffff8002, 0x80000000 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x80000000 },
  { 0x00000000, 0xf0000000, 0x80000001, 0xffff8003 },
  { 0x00000000, 0xffffffff, 0xaaaaaaaa, 0xffffff81 },
  { 0x00000000, 0xffffffff, 0xfffffffd, 0xffffffe0 },
  { 0x00000000, 0xffffffff, 0xffffff80, 0x00007ffe },
  { 0x00000000, 0xffffffff, 0xffff8003, 0xffffffff },
  { 0x00000000, 0xffffff82, 0xffffff82, 0xffff8000 },
  { 0x00000000, 0x00000002, 0x00000002, 0x80000000 },
  { 0x00000000, 0xffffffff, 0xffffff82, 0xffffff81 },
  { 0x00000000, 0xffffffff, 0xcccccccc, 0x00007ffd },
  { 0x00000000, 0x00000000, 0x00007ffe, 0x7fffffff },
  { 0x00000000, 0xffffffff, 0xffffff81, 0xaaaaaaaa },
  { 0x00000000, 0x0000001f, 0x0000007e, 0x00000002 },
  { 0x00000000, 0x00000000, 0x0000007e, 0xffffff80 },
  { 0x00000000, 0x00000000, 0x00007ffe, 0xaaaaaaaa },
  { 0x00000000, 0x0aaaaaaa, 0x55555555, 0xffff8003 },
  { 0x00000000, 0x00000000, 0x00000001, 0xffffff80 },
  { 0x00000000, 0x2aaaaaaa, 0x55555555, 0x80000001 },
  { 0x00000000, 0x00000000, 0x00000000, 0x0000007e },
  { 0x00000000, 0xaaaaaaaa, 0xaaaaaaaa, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffffff81, 0xcccccccc },
  { 0x00000000, 0xffffffff, 0xcccccccc, 0xfffffffd },
  { 0x00000000, 0xffffffff, 0xffff8000, 0x7ffffffd },
  { 0x00000000, 0xffffc000, 0xffff8000, 0x80000001 },
  { 0x00000000, 0xffffc001, 0xffff8003, 0xffff8001 },
  { 0x00000000, 0x00007ffd, 0x00007ffd, 0x80000000 },
  { 0x00000000, 0x00000000, 0x00007fff, 0xcccccccc },
  { 0x00000000, 0xffffffff, 0xffffff80, 0x00007ffe },
  { 0x00000000, 0x00000000, 0x7ffffffd, 0xaaaaaaaa },
  { 0x00000000, 0xffffffff, 0xffff8003, 0x0000007f },
  { 0x00000000, 0xffffffff, 0xfffffffe, 0xfffffffd },
  { 0x00000000, 0xffffffff, 0xfffffffe, 0x55555555 },
  { 0x00000000, 0xffffffff, 0xfffffffe, 0xfffffffe },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00007fff },
  { 0x00000000, 0x00000000, 0x0000007e, 0x00007ffd },
  { 0x00000000, 0xfffffff8, 0xffffffe0, 0x00000002 },
  { 0x00000000, 0x00000000, 0x00007ffd, 0xffffff81 },
  { 0x00000000, 0x00000000, 0x00000020, 0xfffffffd },
  { 0x00000000, 0x00000000, 0x0000007d, 0xffffff83 },
  { 0x00000000, 0x00000000, 0x55555555, 0x7ffffffe },
  { 0x00000000, 0x00001fff, 0x00007ffe, 0x00000002 },
  { 0x00000000, 0x00000000, 0x7fffffff, 0x00007ffd },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00000001 },
  { 0x00000000, 0x00000000, 0x33333333, 0xffffff83 },
  { 0x00000000, 0xffffffff, 0xcccccccc, 0x33333333 },
  { 0x00000000, 0xffffffc0, 0xffffff80, 0x00000001 },
  { 0x00000000, 0xffffffff, 0xcccccccc, 0x00007ffd },
  { 0x00000000, 0xffffffff, 0xfffffffd, 0x7ffffffe },
  { 0x00000000, 0x00000000, 0x7ffffffe, 0xffffff83 },
  { 0x00000000, 0x0000003f, 0x0000007f, 0xffff8001 },
  { 0x00000000, 0x00000000, 0x00007fff, 0xffffff80 },
  { 0x00000000, 0x00000000, 0x00007fff, 0x7ffffffe },
  { 0x00000000, 0x2aaaaaaa, 0x55555555, 0xffff8001 },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffff80 },
  { 0x00000000, 0x00001fff, 0x00007fff, 0x00000002 },
  { 0x00000000, 0x0aaaaaaa, 0x55555555, 0xffff8003 },
  { 0x00000000, 0xffffffff, 0xffff8003, 0x00000020 },
  { 0x00000000, 0xffffffff, 0xffff8002, 0x7fffffff },
  { 0x00000000, 0x55555555, 0x55555555, 0x00000000 },
  { 0x00000000, 0x00000000, 0x00007ffe, 0xffffff81 },
  { 0x00000000, 0xffffffff, 0x80000001, 0x00007ffe },
  { 0x00000000, 0xffffffff, 0xaaaaaaaa, 0x00000020 },
  { 0x00000000, 0xffffffff, 0xfffffffe, 0x00000002 },
  { 0x00000000, 0xffffe000, 0xffff8000, 0xffff8002 },
  { 0x00000000, 0x00000000, 0x00007fff, 0xaaaaaaaa },
  { 0x00000000, 0xffffffff, 0xffffff80, 0x00007ffd },
  { 0x00000000, 0xffffffff, 0x80000000, 0xffffff80 },
  { 0x00000000, 0x00000000, 0x55555555, 0xfffffffd },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00007ffd },
  { 0x00000000, 0xffffffff, 0xfffffffe, 0xffffff80 },
  { 0x00000000, 0xffffffe0, 0xffffff82, 0xffff8002 },
  { 0x00000000, 0x7ffffffe, 0x7ffffffe, 0xffff8000 },
  { 0x00000000, 0xffffffff, 0xffff8003, 0xffffff80 },
  { 0x00000000, 0x00000000, 0x00000020, 0xffffffe0 },
  { 0x00000000, 0xffffffff, 0xffff8001, 0xffffffe0 },
  { 0x00000000, 0xffffe000, 0xffff8000, 0xffff8002 },
  { 0x00000000, 0x00000000, 0x00000002, 0x7ffffffe },
  { 0x00000000, 0x00000000, 0x0000007f, 0xffffff81 },
  { 0x00000000, 0x00000000, 0x00000001, 0x7fffffff },
  { 0x00000000, 0x00000000, 0x00000000, 0x33333333 },
  { 0x00000000, 0xffffffff, 0xffffff83, 0xcccccccc },
  { 0x00000000, 0x00000000, 0x00000020, 0x00007ffd },
  { 0x00000000, 0xcccccccc, 0xcccccccc, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffff8000, 0x00007fff },
  { 0x00000000, 0xffffffff, 0xcccccccc, 0x00007ffe },
  { 0x00000000, 0xffffffff, 0xfffffffd, 0x7ffffffe },
  { 0x00000000, 0xffffffff, 0xaaaaaaaa, 0x55555555 },
  { 0x00000000, 0xffffffff, 0xaaaaaaaa, 0xffffff81 },
  { 0x00000000, 0xfffffffe, 0xfffffffe, 0xffff8000 },
  { 0x00000000, 0xffffffff, 0xffffffe0, 0xfffffffd },
  { 0x00000000, 0x00000000, 0x33333333, 0xfffffffd },
  { 0x00000000, 0xffffc001, 0xffff8002, 0x80000001 },
  { 0x00000000, 0xffffffff, 0xffffff83, 0xffffff83 },
  { 0x00000000, 0xffffffff, 0xffff8002, 0x00000020 },
  { 0x00000000, 0x00000000, 0x7fffffff, 0x0000007f },
  { 0x00000000, 0xcccccccc, 0xcccccccc, 0xffff8000 },
  { 0x00000000, 0x00000000, 0x7ffffffe, 0x00007fff },
  { 0x00000000, 0x00000000, 0x7ffffffd, 0x7ffffffd },
  { 0x00000000, 0xffffffff, 0xfffffffd, 0xffff8002 },
  { 0x00000000, 0x00000000, 0x00000002, 0x7fffffff },
  { 0x00000000, 0xffffffff, 0xfffffffe, 0x00000020 },
  { 0x00000000, 0x00000000, 0x0000007e, 0x00007ffe },
  { 0x00000000, 0x00000000, 0x00007ffd, 0xfffffffd },
  { 0x00000000, 0x0000001f, 0x0000007f, 0x00000002 },
  { 0x00000000, 0xffffffff, 0x80000000, 0x7ffffffd },
  { 0x00000000, 0x00003fff, 0x00007fff, 0x80000001 },
  { 0x00000000, 0xffffffff, 0x80000000, 0xaaaaaaaa },
  { 0x00000000, 0xd5555555, 0xaaaaaaaa, 0xffff8001 },
  { 0x00000000, 0xfffffffc, 0xffffffe0, 0xffff8003 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00007ffd },
  { 0x00000000, 0xffffffc0, 0xffffff81, 0x00000001 },
  { 0x00000000, 0xd5555555, 0xaaaaaaaa, 0x80000001 },
  { 0x00000000, 0xffff8000, 0xffff8000, 0xffff8000 },
  { 0x00000000, 0x00000000, 0x00007ffd, 0xaaaaaaaa },
  { 0x00000000, 0x7ffffffe, 0x7ffffffe, 0x80000000 },
  { 0x00000000, 0x00000000, 0x00007ffe, 0xffffff81 },
  { 0x00000000, 0x0000001f, 0x0000007d, 0xffff8002 },
  { 0x00000000, 0x00000000, 0x00000002, 0xffffff81 },
  { 0x00000000, 0xffffffff, 0xfffffffd, 0x7ffffffd },
  { 0x00000000, 0x00000000, 0x00000020, 0xffffff80 },
  { 0x00000000, 0x00000000, 0x7fffffff, 0xffffffe0 },
  { 0x00000000, 0xffffffff, 0xffff8002, 0x0000007f },
  { 0x00000000, 0x1fffffff, 0x7fffffff, 0xffff8002 },
  { 0x00000000, 0xffffffff, 0xfffffffd, 0x00000020 },
  { 0x00000000, 0xffffffff, 0xffffffe0, 0x0000007e },
  { 0x00000000, 0x00000000, 0x00000020, 0x7ffffffe },
  { 0x00000000, 0x0000007f, 0x0000007f, 0xffff8000 },
  { 0x00000000, 0xffffffff, 0x80000001, 0x0000007d },
  { 0x00000000, 0x00000000, 0x0000007f, 0x00007ffd },
  { 0x00000000, 0xffffffff, 0xffffffe0, 0xffffff82 },
  { 0x00000000, 0x0000001f, 0x0000007e, 0xffff8002 },
  { 0x00000000, 0x00000000, 0x55555555, 0x0000007f },
  { 0x00000000, 0x00000000, 0x7fffffff, 0x7ffffffe },
  { 0x00000000, 0xffffffff, 0xfffffffe, 0xffffff80 },
  { 0x00000000, 0xffffffff, 0xffff8002, 0x33333333 },
  { 0x00000000, 0xffffffff, 0xfffffffd, 0xaaaaaaaa },
  { 0x00000000, 0xffffffff, 0xfffffffd, 0x00000020 },
  { 0x00000000, 0x00000000, 0x00007ffe, 0x55555555 },
  { 0x00000000, 0x00000008, 0x00000020, 0x00000002 },
  { 0x00000000, 0xffffffff, 0xffff8002, 0xfffffffe },
  { 0x00000000, 0xe0000000, 0x80000001, 0xffff8002 },
  { 0x00000000, 0x00000000, 0x0000007e, 0x33333333 },
};
const Inputs kOutputs_Asr_RdIsNotRnIsNotRm_al_r7_r12_r5[] = {
  { 0x00000000, 0x00000000, 0x0000007e, 0x0000007d },
  { 0x00000000, 0x00000000, 0x00000002, 0xffff8002 },
  { 0x00000000, 0x80000001, 0x80000001, 0x00000000 },
  { 0x00000000, 0xffffffe0, 0xffffff83, 0x00000002 },
  { 0x00000000, 0xfffffff8, 0xffffffe0, 0x00000002 },
  { 0x00000000, 0xffffffff, 0x80000001, 0xffffff82 },
  { 0x00000000, 0x00000000, 0x00007fff, 0x0000007f },
  { 0x00000000, 0x00000000, 0x0000007d, 0x7ffffffe },
  { 0x00000000, 0x00000008, 0x00000020, 0xffff8002 },
  { 0x00000000, 0x2aaaaaaa, 0x55555555, 0x00000001 },
  { 0x00000000, 0x33333333, 0x33333333, 0x00000000 },
  { 0x00000000, 0x00000000, 0x7ffffffd, 0x55555555 },
  { 0x00000000, 0xffffffff, 0xffff8001, 0x7ffffffe },
  { 0x00000000, 0xfffffff0, 0xffffff83, 0xffff8003 },
  { 0x00000000, 0xffffffff, 0xffffffe0, 0xffffff81 },
  { 0x00000000, 0xffffffff, 0xffff8001, 0x0000007e },
  { 0x00000000, 0x00000000, 0x0000007e, 0x00000020 },
  { 0x00000000, 0xffffffff, 0xfffffffd, 0xaaaaaaaa },
  { 0x00000000, 0xffffffff, 0xffffff82, 0x7ffffffd },
  { 0x00000000, 0xffffffff, 0xcccccccc, 0x7fffffff },
  { 0x00000000, 0xffffffff, 0x80000001, 0xffffffff },
  { 0x00000000, 0x00000000, 0x00000020, 0x7ffffffe },
  { 0x00000000, 0xffffffff, 0xffffff81, 0xffffffe0 },
  { 0x00000000, 0xffffffff, 0xffffff81, 0xfffffffd },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffff8000, 0xcccccccc },
  { 0x00000000, 0x00000000, 0x00007ffe, 0xffffff82 },
  { 0x00000000, 0x0000000f, 0x0000007d, 0xffff8003 },
  { 0x00000000, 0xffffffff, 0xffffff81, 0x0000007e },
  { 0x00000000, 0x00000000, 0x7ffffffd, 0xfffffffe },
  { 0x00000000, 0xffffffff, 0x80000001, 0xffffff81 },
  { 0x00000000, 0x00000000, 0x00007ffd, 0xfffffffd },
  { 0x00000000, 0x0fffffff, 0x7fffffff, 0xffff8003 },
  { 0x00000000, 0x00000000, 0x0000007d, 0x33333333 },
  { 0x00000000, 0xffffffff, 0xffff8000, 0x00007ffe },
  { 0x00000000, 0xffffffff, 0xffff8000, 0x00000020 },
  { 0x00000000, 0x00000000, 0x00007fff, 0xffffffe0 },
  { 0x00000000, 0x00000000, 0x00000000, 0x00007ffe },
  { 0x00000000, 0x19999999, 0x33333333, 0x00000001 },
  { 0x00000000, 0xffffffff, 0xffffff80, 0x00000020 },
  { 0x00000000, 0xffffffff, 0xffffff83, 0x00007ffd },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x80000001 },
  { 0x00000000, 0xffffffff, 0xffffff81, 0xcccccccc },
  { 0x00000000, 0x0000003f, 0x0000007f, 0xffff8001 },
  { 0x00000000, 0x00000020, 0x00000020, 0x80000000 },
  { 0x00000000, 0x00000000, 0x00007fff, 0xffffff80 },
  { 0x00000000, 0x00000000, 0x7ffffffe, 0x7ffffffd },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00000001 },
  { 0x00000000, 0x00000000, 0x7ffffffd, 0xffffff83 },
  { 0x00000000, 0xffffffff, 0xffff8001, 0xffffffe0 },
  { 0x00000000, 0xffffffff, 0xffffff80, 0x00007ffd },
  { 0x00000000, 0x00000000, 0x00007fff, 0x00007ffe },
  { 0x00000000, 0x00000000, 0x00000000, 0xffff8000 },
  { 0x00000000, 0xffffffff, 0xaaaaaaaa, 0x7ffffffe },
  { 0x00000000, 0x00000000, 0x00007ffd, 0xffffffe0 },
  { 0x00000000, 0xffffffff, 0xffffffe0, 0xffffff83 },
  { 0x00000000, 0xffffffff, 0xffffffe0, 0x7ffffffd },
  { 0x00000000, 0xffff8002, 0xffff8002, 0x80000000 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x80000000 },
  { 0x00000000, 0xf0000000, 0x80000001, 0xffff8003 },
  { 0x00000000, 0xffffffff, 0xaaaaaaaa, 0xffffff81 },
  { 0x00000000, 0xffffffff, 0xfffffffd, 0xffffffe0 },
  { 0x00000000, 0xffffffff, 0xffffff80, 0x00007ffe },
  { 0x00000000, 0xffffffff, 0xffff8003, 0xffffffff },
  { 0x00000000, 0xffffff82, 0xffffff82, 0xffff8000 },
  { 0x00000000, 0x00000002, 0x00000002, 0x80000000 },
  { 0x00000000, 0xffffffff, 0xffffff82, 0xffffff81 },
  { 0x00000000, 0xffffffff, 0xcccccccc, 0x00007ffd },
  { 0x00000000, 0x00000000, 0x00007ffe, 0x7fffffff },
  { 0x00000000, 0xffffffff, 0xffffff81, 0xaaaaaaaa },
  { 0x00000000, 0x0000001f, 0x0000007e, 0x00000002 },
  { 0x00000000, 0x00000000, 0x0000007e, 0xffffff80 },
  { 0x00000000, 0x00000000, 0x00007ffe, 0xaaaaaaaa },
  { 0x00000000, 0x0aaaaaaa, 0x55555555, 0xffff8003 },
  { 0x00000000, 0x00000000, 0x00000001, 0xffffff80 },
  { 0x00000000, 0x2aaaaaaa, 0x55555555, 0x80000001 },
  { 0x00000000, 0x00000000, 0x00000000, 0x0000007e },
  { 0x00000000, 0xaaaaaaaa, 0xaaaaaaaa, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffffff81, 0xcccccccc },
  { 0x00000000, 0xffffffff, 0xcccccccc, 0xfffffffd },
  { 0x00000000, 0xffffffff, 0xffff8000, 0x7ffffffd },
  { 0x00000000, 0xffffc000, 0xffff8000, 0x80000001 },
  { 0x00000000, 0xffffc001, 0xffff8003, 0xffff8001 },
  { 0x00000000, 0x00007ffd, 0x00007ffd, 0x80000000 },
  { 0x00000000, 0x00000000, 0x00007fff, 0xcccccccc },
  { 0x00000000, 0xffffffff, 0xffffff80, 0x00007ffe },
  { 0x00000000, 0x00000000, 0x7ffffffd, 0xaaaaaaaa },
  { 0x00000000, 0xffffffff, 0xffff8003, 0x0000007f },
  { 0x00000000, 0xffffffff, 0xfffffffe, 0xfffffffd },
  { 0x00000000, 0xffffffff, 0xfffffffe, 0x55555555 },
  { 0x00000000, 0xffffffff, 0xfffffffe, 0xfffffffe },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00007fff },
  { 0x00000000, 0x00000000, 0x0000007e, 0x00007ffd },
  { 0x00000000, 0xfffffff8, 0xffffffe0, 0x00000002 },
  { 0x00000000, 0x00000000, 0x00007ffd, 0xffffff81 },
  { 0x00000000, 0x00000000, 0x00000020, 0xfffffffd },
  { 0x00000000, 0x00000000, 0x0000007d, 0xffffff83 },
  { 0x00000000, 0x00000000, 0x55555555, 0x7ffffffe },
  { 0x00000000, 0x00001fff, 0x00007ffe, 0x00000002 },
  { 0x00000000, 0x00000000, 0x7fffffff, 0x00007ffd },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00000001 },
  { 0x00000000, 0x00000000, 0x33333333, 0xffffff83 },
  { 0x00000000, 0xffffffff, 0xcccccccc, 0x33333333 },
  { 0x00000000, 0xffffffc0, 0xffffff80, 0x00000001 },
  { 0x00000000, 0xffffffff, 0xcccccccc, 0x00007ffd },
  { 0x00000000, 0xffffffff, 0xfffffffd, 0x7ffffffe },
  { 0x00000000, 0x00000000, 0x7ffffffe, 0xffffff83 },
  { 0x00000000, 0x0000003f, 0x0000007f, 0xffff8001 },
  { 0x00000000, 0x00000000, 0x00007fff, 0xffffff80 },
  { 0x00000000, 0x00000000, 0x00007fff, 0x7ffffffe },
  { 0x00000000, 0x2aaaaaaa, 0x55555555, 0xffff8001 },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffff80 },
  { 0x00000000, 0x00001fff, 0x00007fff, 0x00000002 },
  { 0x00000000, 0x0aaaaaaa, 0x55555555, 0xffff8003 },
  { 0x00000000, 0xffffffff, 0xffff8003, 0x00000020 },
  { 0x00000000, 0xffffffff, 0xffff8002, 0x7fffffff },
  { 0x00000000, 0x55555555, 0x55555555, 0x00000000 },
  { 0x00000000, 0x00000000, 0x00007ffe, 0xffffff81 },
  { 0x00000000, 0xffffffff, 0x80000001, 0x00007ffe },
  { 0x00000000, 0xffffffff, 0xaaaaaaaa, 0x00000020 },
  { 0x00000000, 0xffffffff, 0xfffffffe, 0x00000002 },
  { 0x00000000, 0xffffe000, 0xffff8000, 0xffff8002 },
  { 0x00000000, 0x00000000, 0x00007fff, 0xaaaaaaaa },
  { 0x00000000, 0xffffffff, 0xffffff80, 0x00007ffd },
  { 0x00000000, 0xffffffff, 0x80000000, 0xffffff80 },
  { 0x00000000, 0x00000000, 0x55555555, 0xfffffffd },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00007ffd },
  { 0x00000000, 0xffffffff, 0xfffffffe, 0xffffff80 },
  { 0x00000000, 0xffffffe0, 0xffffff82, 0xffff8002 },
  { 0x00000000, 0x7ffffffe, 0x7ffffffe, 0xffff8000 },
  { 0x00000000, 0xffffffff, 0xffff8003, 0xffffff80 },
  { 0x00000000, 0x00000000, 0x00000020, 0xffffffe0 },
  { 0x00000000, 0xffffffff, 0xffff8001, 0xffffffe0 },
  { 0x00000000, 0xffffe000, 0xffff8000, 0xffff8002 },
  { 0x00000000, 0x00000000, 0x00000002, 0x7ffffffe },
  { 0x00000000, 0x00000000, 0x0000007f, 0xffffff81 },
  { 0x00000000, 0x00000000, 0x00000001, 0x7fffffff },
  { 0x00000000, 0x00000000, 0x00000000, 0x33333333 },
  { 0x00000000, 0xffffffff, 0xffffff83, 0xcccccccc },
  { 0x00000000, 0x00000000, 0x00000020, 0x00007ffd },
  { 0x00000000, 0xcccccccc, 0xcccccccc, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffff8000, 0x00007fff },
  { 0x00000000, 0xffffffff, 0xcccccccc, 0x00007ffe },
  { 0x00000000, 0xffffffff, 0xfffffffd, 0x7ffffffe },
  { 0x00000000, 0xffffffff, 0xaaaaaaaa, 0x55555555 },
  { 0x00000000, 0xffffffff, 0xaaaaaaaa, 0xffffff81 },
  { 0x00000000, 0xfffffffe, 0xfffffffe, 0xffff8000 },
  { 0x00000000, 0xffffffff, 0xffffffe0, 0xfffffffd },
  { 0x00000000, 0x00000000, 0x33333333, 0xfffffffd },
  { 0x00000000, 0xffffc001, 0xffff8002, 0x80000001 },
  { 0x00000000, 0xffffffff, 0xffffff83, 0xffffff83 },
  { 0x00000000, 0xffffffff, 0xffff8002, 0x00000020 },
  { 0x00000000, 0x00000000, 0x7fffffff, 0x0000007f },
  { 0x00000000, 0xcccccccc, 0xcccccccc, 0xffff8000 },
  { 0x00000000, 0x00000000, 0x7ffffffe, 0x00007fff },
  { 0x00000000, 0x00000000, 0x7ffffffd, 0x7ffffffd },
  { 0x00000000, 0xffffffff, 0xfffffffd, 0xffff8002 },
  { 0x00000000, 0x00000000, 0x00000002, 0x7fffffff },
  { 0x00000000, 0xffffffff, 0xfffffffe, 0x00000020 },
  { 0x00000000, 0x00000000, 0x0000007e, 0x00007ffe },
  { 0x00000000, 0x00000000, 0x00007ffd, 0xfffffffd },
  { 0x00000000, 0x0000001f, 0x0000007f, 0x00000002 },
  { 0x00000000, 0xffffffff, 0x80000000, 0x7ffffffd },
  { 0x00000000, 0x00003fff, 0x00007fff, 0x80000001 },
  { 0x00000000, 0xffffffff, 0x80000000, 0xaaaaaaaa },
  { 0x00000000, 0xd5555555, 0xaaaaaaaa, 0xffff8001 },
  { 0x00000000, 0xfffffffc, 0xffffffe0, 0xffff8003 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00007ffd },
  { 0x00000000, 0xffffffc0, 0xffffff81, 0x00000001 },
  { 0x00000000, 0xd5555555, 0xaaaaaaaa, 0x80000001 },
  { 0x00000000, 0xffff8000, 0xffff8000, 0xffff8000 },
  { 0x00000000, 0x00000000, 0x00007ffd, 0xaaaaaaaa },
  { 0x00000000, 0x7ffffffe, 0x7ffffffe, 0x80000000 },
  { 0x00000000, 0x00000000, 0x00007ffe, 0xffffff81 },
  { 0x00000000, 0x0000001f, 0x0000007d, 0xffff8002 },
  { 0x00000000, 0x00000000, 0x00000002, 0xffffff81 },
  { 0x00000000, 0xffffffff, 0xfffffffd, 0x7ffffffd },
  { 0x00000000, 0x00000000, 0x00000020, 0xffffff80 },
  { 0x00000000, 0x00000000, 0x7fffffff, 0xffffffe0 },
  { 0x00000000, 0xffffffff, 0xffff8002, 0x0000007f },
  { 0x00000000, 0x1fffffff, 0x7fffffff, 0xffff8002 },
  { 0x00000000, 0xffffffff, 0xfffffffd, 0x00000020 },
  { 0x00000000, 0xffffffff, 0xffffffe0, 0x0000007e },
  { 0x00000000, 0x00000000, 0x00000020, 0x7ffffffe },
  { 0x00000000, 0x0000007f, 0x0000007f, 0xffff8000 },
  { 0x00000000, 0xffffffff, 0x80000001, 0x0000007d },
  { 0x00000000, 0x00000000, 0x0000007f, 0x00007ffd },
  { 0x00000000, 0xffffffff, 0xffffffe0, 0xffffff82 },
  { 0x00000000, 0x0000001f, 0x0000007e, 0xffff8002 },
  { 0x00000000, 0x00000000, 0x55555555, 0x0000007f },
  { 0x00000000, 0x00000000, 0x7fffffff, 0x7ffffffe },
  { 0x00000000, 0xffffffff, 0xfffffffe, 0xffffff80 },
  { 0x00000000, 0xffffffff, 0xffff8002, 0x33333333 },
  { 0x00000000, 0xffffffff, 0xfffffffd, 0xaaaaaaaa },
  { 0x00000000, 0xffffffff, 0xfffffffd, 0x00000020 },
  { 0x00000000, 0x00000000, 0x00007ffe, 0x55555555 },
  { 0x00000000, 0x00000008, 0x00000020, 0x00000002 },
  { 0x00000000, 0xffffffff, 0xffff8002, 0xfffffffe },
  { 0x00000000, 0xe0000000, 0x80000001, 0xffff8002 },
  { 0x00000000, 0x00000000, 0x0000007e, 0x33333333 },
};
const Inputs kOutputs_Asr_RdIsNotRnIsNotRm_al_r8_r5_r6[] = {
  { 0x00000000, 0x00000000, 0x0000007e, 0x0000007d },
  { 0x00000000, 0x00000000, 0x00000002, 0xffff8002 },
  { 0x00000000, 0x80000001, 0x80000001, 0x00000000 },
  { 0x00000000, 0xffffffe0, 0xffffff83, 0x00000002 },
  { 0x00000000, 0xfffffff8, 0xffffffe0, 0x00000002 },
  { 0x00000000, 0xffffffff, 0x80000001, 0xffffff82 },
  { 0x00000000, 0x00000000, 0x00007fff, 0x0000007f },
  { 0x00000000, 0x00000000, 0x0000007d, 0x7ffffffe },
  { 0x00000000, 0x00000008, 0x00000020, 0xffff8002 },
  { 0x00000000, 0x2aaaaaaa, 0x55555555, 0x00000001 },
  { 0x00000000, 0x33333333, 0x33333333, 0x00000000 },
  { 0x00000000, 0x00000000, 0x7ffffffd, 0x55555555 },
  { 0x00000000, 0xffffffff, 0xffff8001, 0x7ffffffe },
  { 0x00000000, 0xfffffff0, 0xffffff83, 0xffff8003 },
  { 0x00000000, 0xffffffff, 0xffffffe0, 0xffffff81 },
  { 0x00000000, 0xffffffff, 0xffff8001, 0x0000007e },
  { 0x00000000, 0x00000000, 0x0000007e, 0x00000020 },
  { 0x00000000, 0xffffffff, 0xfffffffd, 0xaaaaaaaa },
  { 0x00000000, 0xffffffff, 0xffffff82, 0x7ffffffd },
  { 0x00000000, 0xffffffff, 0xcccccccc, 0x7fffffff },
  { 0x00000000, 0xffffffff, 0x80000001, 0xffffffff },
  { 0x00000000, 0x00000000, 0x00000020, 0x7ffffffe },
  { 0x00000000, 0xffffffff, 0xffffff81, 0xffffffe0 },
  { 0x00000000, 0xffffffff, 0xffffff81, 0xfffffffd },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffff8000, 0xcccccccc },
  { 0x00000000, 0x00000000, 0x00007ffe, 0xffffff82 },
  { 0x00000000, 0x0000000f, 0x0000007d, 0xffff8003 },
  { 0x00000000, 0xffffffff, 0xffffff81, 0x0000007e },
  { 0x00000000, 0x00000000, 0x7ffffffd, 0xfffffffe },
  { 0x00000000, 0xffffffff, 0x80000001, 0xffffff81 },
  { 0x00000000, 0x00000000, 0x00007ffd, 0xfffffffd },
  { 0x00000000, 0x0fffffff, 0x7fffffff, 0xffff8003 },
  { 0x00000000, 0x00000000, 0x0000007d, 0x33333333 },
  { 0x00000000, 0xffffffff, 0xffff8000, 0x00007ffe },
  { 0x00000000, 0xffffffff, 0xffff8000, 0x00000020 },
  { 0x00000000, 0x00000000, 0x00007fff, 0xffffffe0 },
  { 0x00000000, 0x00000000, 0x00000000, 0x00007ffe },
  { 0x00000000, 0x19999999, 0x33333333, 0x00000001 },
  { 0x00000000, 0xffffffff, 0xffffff80, 0x00000020 },
  { 0x00000000, 0xffffffff, 0xffffff83, 0x00007ffd },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x80000001 },
  { 0x00000000, 0xffffffff, 0xffffff81, 0xcccccccc },
  { 0x00000000, 0x0000003f, 0x0000007f, 0xffff8001 },
  { 0x00000000, 0x00000020, 0x00000020, 0x80000000 },
  { 0x00000000, 0x00000000, 0x00007fff, 0xffffff80 },
  { 0x00000000, 0x00000000, 0x7ffffffe, 0x7ffffffd },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00000001 },
  { 0x00000000, 0x00000000, 0x7ffffffd, 0xffffff83 },
  { 0x00000000, 0xffffffff, 0xffff8001, 0xffffffe0 },
  { 0x00000000, 0xffffffff, 0xffffff80, 0x00007ffd },
  { 0x00000000, 0x00000000, 0x00007fff, 0x00007ffe },
  { 0x00000000, 0x00000000, 0x00000000, 0xffff8000 },
  { 0x00000000, 0xffffffff, 0xaaaaaaaa, 0x7ffffffe },
  { 0x00000000, 0x00000000, 0x00007ffd, 0xffffffe0 },
  { 0x00000000, 0xffffffff, 0xffffffe0, 0xffffff83 },
  { 0x00000000, 0xffffffff, 0xffffffe0, 0x7ffffffd },
  { 0x00000000, 0xffff8002, 0xffff8002, 0x80000000 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x80000000 },
  { 0x00000000, 0xf0000000, 0x80000001, 0xffff8003 },
  { 0x00000000, 0xffffffff, 0xaaaaaaaa, 0xffffff81 },
  { 0x00000000, 0xffffffff, 0xfffffffd, 0xffffffe0 },
  { 0x00000000, 0xffffffff, 0xffffff80, 0x00007ffe },
  { 0x00000000, 0xffffffff, 0xffff8003, 0xffffffff },
  { 0x00000000, 0xffffff82, 0xffffff82, 0xffff8000 },
  { 0x00000000, 0x00000002, 0x00000002, 0x80000000 },
  { 0x00000000, 0xffffffff, 0xffffff82, 0xffffff81 },
  { 0x00000000, 0xffffffff, 0xcccccccc, 0x00007ffd },
  { 0x00000000, 0x00000000, 0x00007ffe, 0x7fffffff },
  { 0x00000000, 0xffffffff, 0xffffff81, 0xaaaaaaaa },
  { 0x00000000, 0x0000001f, 0x0000007e, 0x00000002 },
  { 0x00000000, 0x00000000, 0x0000007e, 0xffffff80 },
  { 0x00000000, 0x00000000, 0x00007ffe, 0xaaaaaaaa },
  { 0x00000000, 0x0aaaaaaa, 0x55555555, 0xffff8003 },
  { 0x00000000, 0x00000000, 0x00000001, 0xffffff80 },
  { 0x00000000, 0x2aaaaaaa, 0x55555555, 0x80000001 },
  { 0x00000000, 0x00000000, 0x00000000, 0x0000007e },
  { 0x00000000, 0xaaaaaaaa, 0xaaaaaaaa, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffffff81, 0xcccccccc },
  { 0x00000000, 0xffffffff, 0xcccccccc, 0xfffffffd },
  { 0x00000000, 0xffffffff, 0xffff8000, 0x7ffffffd },
  { 0x00000000, 0xffffc000, 0xffff8000, 0x80000001 },
  { 0x00000000, 0xffffc001, 0xffff8003, 0xffff8001 },
  { 0x00000000, 0x00007ffd, 0x00007ffd, 0x80000000 },
  { 0x00000000, 0x00000000, 0x00007fff, 0xcccccccc },
  { 0x00000000, 0xffffffff, 0xffffff80, 0x00007ffe },
  { 0x00000000, 0x00000000, 0x7ffffffd, 0xaaaaaaaa },
  { 0x00000000, 0xffffffff, 0xffff8003, 0x0000007f },
  { 0x00000000, 0xffffffff, 0xfffffffe, 0xfffffffd },
  { 0x00000000, 0xffffffff, 0xfffffffe, 0x55555555 },
  { 0x00000000, 0xffffffff, 0xfffffffe, 0xfffffffe },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00007fff },
  { 0x00000000, 0x00000000, 0x0000007e, 0x00007ffd },
  { 0x00000000, 0xfffffff8, 0xffffffe0, 0x00000002 },
  { 0x00000000, 0x00000000, 0x00007ffd, 0xffffff81 },
  { 0x00000000, 0x00000000, 0x00000020, 0xfffffffd },
  { 0x00000000, 0x00000000, 0x0000007d, 0xffffff83 },
  { 0x00000000, 0x00000000, 0x55555555, 0x7ffffffe },
  { 0x00000000, 0x00001fff, 0x00007ffe, 0x00000002 },
  { 0x00000000, 0x00000000, 0x7fffffff, 0x00007ffd },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00000001 },
  { 0x00000000, 0x00000000, 0x33333333, 0xffffff83 },
  { 0x00000000, 0xffffffff, 0xcccccccc, 0x33333333 },
  { 0x00000000, 0xffffffc0, 0xffffff80, 0x00000001 },
  { 0x00000000, 0xffffffff, 0xcccccccc, 0x00007ffd },
  { 0x00000000, 0xffffffff, 0xfffffffd, 0x7ffffffe },
  { 0x00000000, 0x00000000, 0x7ffffffe, 0xffffff83 },
  { 0x00000000, 0x0000003f, 0x0000007f, 0xffff8001 },
  { 0x00000000, 0x00000000, 0x00007fff, 0xffffff80 },
  { 0x00000000, 0x00000000, 0x00007fff, 0x7ffffffe },
  { 0x00000000, 0x2aaaaaaa, 0x55555555, 0xffff8001 },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffff80 },
  { 0x00000000, 0x00001fff, 0x00007fff, 0x00000002 },
  { 0x00000000, 0x0aaaaaaa, 0x55555555, 0xffff8003 },
  { 0x00000000, 0xffffffff, 0xffff8003, 0x00000020 },
  { 0x00000000, 0xffffffff, 0xffff8002, 0x7fffffff },
  { 0x00000000, 0x55555555, 0x55555555, 0x00000000 },
  { 0x00000000, 0x00000000, 0x00007ffe, 0xffffff81 },
  { 0x00000000, 0xffffffff, 0x80000001, 0x00007ffe },
  { 0x00000000, 0xffffffff, 0xaaaaaaaa, 0x00000020 },
  { 0x00000000, 0xffffffff, 0xfffffffe, 0x00000002 },
  { 0x00000000, 0xffffe000, 0xffff8000, 0xffff8002 },
  { 0x00000000, 0x00000000, 0x00007fff, 0xaaaaaaaa },
  { 0x00000000, 0xffffffff, 0xffffff80, 0x00007ffd },
  { 0x00000000, 0xffffffff, 0x80000000, 0xffffff80 },
  { 0x00000000, 0x00000000, 0x55555555, 0xfffffffd },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00007ffd },
  { 0x00000000, 0xffffffff, 0xfffffffe, 0xffffff80 },
  { 0x00000000, 0xffffffe0, 0xffffff82, 0xffff8002 },
  { 0x00000000, 0x7ffffffe, 0x7ffffffe, 0xffff8000 },
  { 0x00000000, 0xffffffff, 0xffff8003, 0xffffff80 },
  { 0x00000000, 0x00000000, 0x00000020, 0xffffffe0 },
  { 0x00000000, 0xffffffff, 0xffff8001, 0xffffffe0 },
  { 0x00000000, 0xffffe000, 0xffff8000, 0xffff8002 },
  { 0x00000000, 0x00000000, 0x00000002, 0x7ffffffe },
  { 0x00000000, 0x00000000, 0x0000007f, 0xffffff81 },
  { 0x00000000, 0x00000000, 0x00000001, 0x7fffffff },
  { 0x00000000, 0x00000000, 0x00000000, 0x33333333 },
  { 0x00000000, 0xffffffff, 0xffffff83, 0xcccccccc },
  { 0x00000000, 0x00000000, 0x00000020, 0x00007ffd },
  { 0x00000000, 0xcccccccc, 0xcccccccc, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffff8000, 0x00007fff },
  { 0x00000000, 0xffffffff, 0xcccccccc, 0x00007ffe },
  { 0x00000000, 0xffffffff, 0xfffffffd, 0x7ffffffe },
  { 0x00000000, 0xffffffff, 0xaaaaaaaa, 0x55555555 },
  { 0x00000000, 0xffffffff, 0xaaaaaaaa, 0xffffff81 },
  { 0x00000000, 0xfffffffe, 0xfffffffe, 0xffff8000 },
  { 0x00000000, 0xffffffff, 0xffffffe0, 0xfffffffd },
  { 0x00000000, 0x00000000, 0x33333333, 0xfffffffd },
  { 0x00000000, 0xffffc001, 0xffff8002, 0x80000001 },
  { 0x00000000, 0xffffffff, 0xffffff83, 0xffffff83 },
  { 0x00000000, 0xffffffff, 0xffff8002, 0x00000020 },
  { 0x00000000, 0x00000000, 0x7fffffff, 0x0000007f },
  { 0x00000000, 0xcccccccc, 0xcccccccc, 0xffff8000 },
  { 0x00000000, 0x00000000, 0x7ffffffe, 0x00007fff },
  { 0x00000000, 0x00000000, 0x7ffffffd, 0x7ffffffd },
  { 0x00000000, 0xffffffff, 0xfffffffd, 0xffff8002 },
  { 0x00000000, 0x00000000, 0x00000002, 0x7fffffff },
  { 0x00000000, 0xffffffff, 0xfffffffe, 0x00000020 },
  { 0x00000000, 0x00000000, 0x0000007e, 0x00007ffe },
  { 0x00000000, 0x00000000, 0x00007ffd, 0xfffffffd },
  { 0x00000000, 0x0000001f, 0x0000007f, 0x00000002 },
  { 0x00000000, 0xffffffff, 0x80000000, 0x7ffffffd },
  { 0x00000000, 0x00003fff, 0x00007fff, 0x80000001 },
  { 0x00000000, 0xffffffff, 0x80000000, 0xaaaaaaaa },
  { 0x00000000, 0xd5555555, 0xaaaaaaaa, 0xffff8001 },
  { 0x00000000, 0xfffffffc, 0xffffffe0, 0xffff8003 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00007ffd },
  { 0x00000000, 0xffffffc0, 0xffffff81, 0x00000001 },
  { 0x00000000, 0xd5555555, 0xaaaaaaaa, 0x80000001 },
  { 0x00000000, 0xffff8000, 0xffff8000, 0xffff8000 },
  { 0x00000000, 0x00000000, 0x00007ffd, 0xaaaaaaaa },
  { 0x00000000, 0x7ffffffe, 0x7ffffffe, 0x80000000 },
  { 0x00000000, 0x00000000, 0x00007ffe, 0xffffff81 },
  { 0x00000000, 0x0000001f, 0x0000007d, 0xffff8002 },
  { 0x00000000, 0x00000000, 0x00000002, 0xffffff81 },
  { 0x00000000, 0xffffffff, 0xfffffffd, 0x7ffffffd },
  { 0x00000000, 0x00000000, 0x00000020, 0xffffff80 },
  { 0x00000000, 0x00000000, 0x7fffffff, 0xffffffe0 },
  { 0x00000000, 0xffffffff, 0xffff8002, 0x0000007f },
  { 0x00000000, 0x1fffffff, 0x7fffffff, 0xffff8002 },
  { 0x00000000, 0xffffffff, 0xfffffffd, 0x00000020 },
  { 0x00000000, 0xffffffff, 0xffffffe0, 0x0000007e },
  { 0x00000000, 0x00000000, 0x00000020, 0x7ffffffe },
  { 0x00000000, 0x0000007f, 0x0000007f, 0xffff8000 },
  { 0x00000000, 0xffffffff, 0x80000001, 0x0000007d },
  { 0x00000000, 0x00000000, 0x0000007f, 0x00007ffd },
  { 0x00000000, 0xffffffff, 0xffffffe0, 0xffffff82 },
  { 0x00000000, 0x0000001f, 0x0000007e, 0xffff8002 },
  { 0x00000000, 0x00000000, 0x55555555, 0x0000007f },
  { 0x00000000, 0x00000000, 0x7fffffff, 0x7ffffffe },
  { 0x00000000, 0xffffffff, 0xfffffffe, 0xffffff80 },
  { 0x00000000, 0xffffffff, 0xffff8002, 0x33333333 },
  { 0x00000000, 0xffffffff, 0xfffffffd, 0xaaaaaaaa },
  { 0x00000000, 0xffffffff, 0xfffffffd, 0x00000020 },
  { 0x00000000, 0x00000000, 0x00007ffe, 0x55555555 },
  { 0x00000000, 0x00000008, 0x00000020, 0x00000002 },
  { 0x00000000, 0xffffffff, 0xffff8002, 0xfffffffe },
  { 0x00000000, 0xe0000000, 0x80000001, 0xffff8002 },
  { 0x00000000, 0x00000000, 0x0000007e, 0x33333333 },
};
const Inputs kOutputs_Asr_RdIsNotRnIsNotRm_al_r0_r6_r0[] = {
  { 0x00000000, 0x00000000, 0x0000007e, 0x00000000 },
  { 0x00000000, 0x00000000, 0x00000002, 0x00000000 },
  { 0x00000000, 0x80000001, 0x80000001, 0x80000001 },
  { 0x00000000, 0xffffffe0, 0xffffff83, 0xffffffe0 },
  { 0x00000000, 0xfffffff8, 0xffffffe0, 0xfffffff8 },
  { 0x00000000, 0xffffffff, 0x80000001, 0xffffffff },
  { 0x00000000, 0x00000000, 0x00007fff, 0x00000000 },
  { 0x00000000, 0x00000000, 0x0000007d, 0x00000000 },
  { 0x00000000, 0x00000008, 0x00000020, 0x00000008 },
  { 0x00000000, 0x2aaaaaaa, 0x55555555, 0x2aaaaaaa },
  { 0x00000000, 0x33333333, 0x33333333, 0x33333333 },
  { 0x00000000, 0x00000000, 0x7ffffffd, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffff8001, 0xffffffff },
  { 0x00000000, 0xfffffff0, 0xffffff83, 0xfffffff0 },
  { 0x00000000, 0xffffffff, 0xffffffe0, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffff8001, 0xffffffff },
  { 0x00000000, 0x00000000, 0x0000007e, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xfffffffd, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffff82, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xcccccccc, 0xffffffff },
  { 0x00000000, 0xffffffff, 0x80000001, 0xffffffff },
  { 0x00000000, 0x00000000, 0x00000020, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffffff81, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffff81, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffff8000, 0xffffffff },
  { 0x00000000, 0x00000000, 0x00007ffe, 0x00000000 },
  { 0x00000000, 0x0000000f, 0x0000007d, 0x0000000f },
  { 0x00000000, 0xffffffff, 0xffffff81, 0xffffffff },
  { 0x00000000, 0x00000000, 0x7ffffffd, 0x00000000 },
  { 0x00000000, 0xffffffff, 0x80000001, 0xffffffff },
  { 0x00000000, 0x00000000, 0x00007ffd, 0x00000000 },
  { 0x00000000, 0x0fffffff, 0x7fffffff, 0x0fffffff },
  { 0x00000000, 0x00000000, 0x0000007d, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffff8000, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffff8000, 0xffffffff },
  { 0x00000000, 0x00000000, 0x00007fff, 0x00000000 },
  { 0x00000000, 0x00000000, 0x00000000, 0x00000000 },
  { 0x00000000, 0x19999999, 0x33333333, 0x19999999 },
  { 0x00000000, 0xffffffff, 0xffffff80, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffff83, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffff81, 0xffffffff },
  { 0x00000000, 0x0000003f, 0x0000007f, 0x0000003f },
  { 0x00000000, 0x00000020, 0x00000020, 0x00000020 },
  { 0x00000000, 0x00000000, 0x00007fff, 0x00000000 },
  { 0x00000000, 0x00000000, 0x7ffffffe, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x00000000, 0x00000000, 0x7ffffffd, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffff8001, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffff80, 0xffffffff },
  { 0x00000000, 0x00000000, 0x00007fff, 0x00000000 },
  { 0x00000000, 0x00000000, 0x00000000, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xaaaaaaaa, 0xffffffff },
  { 0x00000000, 0x00000000, 0x00007ffd, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffffffe0, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffffe0, 0xffffffff },
  { 0x00000000, 0xffff8002, 0xffff8002, 0xffff8002 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x00000000, 0xf0000000, 0x80000001, 0xf0000000 },
  { 0x00000000, 0xffffffff, 0xaaaaaaaa, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xfffffffd, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffff80, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffff8003, 0xffffffff },
  { 0x00000000, 0xffffff82, 0xffffff82, 0xffffff82 },
  { 0x00000000, 0x00000002, 0x00000002, 0x00000002 },
  { 0x00000000, 0xffffffff, 0xffffff82, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xcccccccc, 0xffffffff },
  { 0x00000000, 0x00000000, 0x00007ffe, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffffff81, 0xffffffff },
  { 0x00000000, 0x0000001f, 0x0000007e, 0x0000001f },
  { 0x00000000, 0x00000000, 0x0000007e, 0x00000000 },
  { 0x00000000, 0x00000000, 0x00007ffe, 0x00000000 },
  { 0x00000000, 0x0aaaaaaa, 0x55555555, 0x0aaaaaaa },
  { 0x00000000, 0x00000000, 0x00000001, 0x00000000 },
  { 0x00000000, 0x2aaaaaaa, 0x55555555, 0x2aaaaaaa },
  { 0x00000000, 0x00000000, 0x00000000, 0x00000000 },
  { 0x00000000, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa },
  { 0x00000000, 0xffffffff, 0xffffff81, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xcccccccc, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffff8000, 0xffffffff },
  { 0x00000000, 0xffffc000, 0xffff8000, 0xffffc000 },
  { 0x00000000, 0xffffc001, 0xffff8003, 0xffffc001 },
  { 0x00000000, 0x00007ffd, 0x00007ffd, 0x00007ffd },
  { 0x00000000, 0x00000000, 0x00007fff, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffffff80, 0xffffffff },
  { 0x00000000, 0x00000000, 0x7ffffffd, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffff8003, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xfffffffe, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xfffffffe, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xfffffffe, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x00000000, 0x00000000, 0x0000007e, 0x00000000 },
  { 0x00000000, 0xfffffff8, 0xffffffe0, 0xfffffff8 },
  { 0x00000000, 0x00000000, 0x00007ffd, 0x00000000 },
  { 0x00000000, 0x00000000, 0x00000020, 0x00000000 },
  { 0x00000000, 0x00000000, 0x0000007d, 0x00000000 },
  { 0x00000000, 0x00000000, 0x55555555, 0x00000000 },
  { 0x00000000, 0x00001fff, 0x00007ffe, 0x00001fff },
  { 0x00000000, 0x00000000, 0x7fffffff, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x00000000, 0x00000000, 0x33333333, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xcccccccc, 0xffffffff },
  { 0x00000000, 0xffffffc0, 0xffffff80, 0xffffffc0 },
  { 0x00000000, 0xffffffff, 0xcccccccc, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xfffffffd, 0xffffffff },
  { 0x00000000, 0x00000000, 0x7ffffffe, 0x00000000 },
  { 0x00000000, 0x0000003f, 0x0000007f, 0x0000003f },
  { 0x00000000, 0x00000000, 0x00007fff, 0x00000000 },
  { 0x00000000, 0x00000000, 0x00007fff, 0x00000000 },
  { 0x00000000, 0x2aaaaaaa, 0x55555555, 0x2aaaaaaa },
  { 0x00000000, 0x00000000, 0x00000000, 0x00000000 },
  { 0x00000000, 0x00001fff, 0x00007fff, 0x00001fff },
  { 0x00000000, 0x0aaaaaaa, 0x55555555, 0x0aaaaaaa },
  { 0x00000000, 0xffffffff, 0xffff8003, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffff8002, 0xffffffff },
  { 0x00000000, 0x55555555, 0x55555555, 0x55555555 },
  { 0x00000000, 0x00000000, 0x00007ffe, 0x00000000 },
  { 0x00000000, 0xffffffff, 0x80000001, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xaaaaaaaa, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xfffffffe, 0xffffffff },
  { 0x00000000, 0xffffe000, 0xffff8000, 0xffffe000 },
  { 0x00000000, 0x00000000, 0x00007fff, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffffff80, 0xffffffff },
  { 0x00000000, 0xffffffff, 0x80000000, 0xffffffff },
  { 0x00000000, 0x00000000, 0x55555555, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xfffffffe, 0xffffffff },
  { 0x00000000, 0xffffffe0, 0xffffff82, 0xffffffe0 },
  { 0x00000000, 0x7ffffffe, 0x7ffffffe, 0x7ffffffe },
  { 0x00000000, 0xffffffff, 0xffff8003, 0xffffffff },
  { 0x00000000, 0x00000000, 0x00000020, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffff8001, 0xffffffff },
  { 0x00000000, 0xffffe000, 0xffff8000, 0xffffe000 },
  { 0x00000000, 0x00000000, 0x00000002, 0x00000000 },
  { 0x00000000, 0x00000000, 0x0000007f, 0x00000000 },
  { 0x00000000, 0x00000000, 0x00000001, 0x00000000 },
  { 0x00000000, 0x00000000, 0x00000000, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffffff83, 0xffffffff },
  { 0x00000000, 0x00000000, 0x00000020, 0x00000000 },
  { 0x00000000, 0xcccccccc, 0xcccccccc, 0xcccccccc },
  { 0x00000000, 0xffffffff, 0xffff8000, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xcccccccc, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xfffffffd, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xaaaaaaaa, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xaaaaaaaa, 0xffffffff },
  { 0x00000000, 0xfffffffe, 0xfffffffe, 0xfffffffe },
  { 0x00000000, 0xffffffff, 0xffffffe0, 0xffffffff },
  { 0x00000000, 0x00000000, 0x33333333, 0x00000000 },
  { 0x00000000, 0xffffc001, 0xffff8002, 0xffffc001 },
  { 0x00000000, 0xffffffff, 0xffffff83, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffff8002, 0xffffffff },
  { 0x00000000, 0x00000000, 0x7fffffff, 0x00000000 },
  { 0x00000000, 0xcccccccc, 0xcccccccc, 0xcccccccc },
  { 0x00000000, 0x00000000, 0x7ffffffe, 0x00000000 },
  { 0x00000000, 0x00000000, 0x7ffffffd, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xfffffffd, 0xffffffff },
  { 0x00000000, 0x00000000, 0x00000002, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xfffffffe, 0xffffffff },
  { 0x00000000, 0x00000000, 0x0000007e, 0x00000000 },
  { 0x00000000, 0x00000000, 0x00007ffd, 0x00000000 },
  { 0x00000000, 0x0000001f, 0x0000007f, 0x0000001f },
  { 0x00000000, 0xffffffff, 0x80000000, 0xffffffff },
  { 0x00000000, 0x00003fff, 0x00007fff, 0x00003fff },
  { 0x00000000, 0xffffffff, 0x80000000, 0xffffffff },
  { 0x00000000, 0xd5555555, 0xaaaaaaaa, 0xd5555555 },
  { 0x00000000, 0xfffffffc, 0xffffffe0, 0xfffffffc },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x00000000, 0xffffffc0, 0xffffff81, 0xffffffc0 },
  { 0x00000000, 0xd5555555, 0xaaaaaaaa, 0xd5555555 },
  { 0x00000000, 0xffff8000, 0xffff8000, 0xffff8000 },
  { 0x00000000, 0x00000000, 0x00007ffd, 0x00000000 },
  { 0x00000000, 0x7ffffffe, 0x7ffffffe, 0x7ffffffe },
  { 0x00000000, 0x00000000, 0x00007ffe, 0x00000000 },
  { 0x00000000, 0x0000001f, 0x0000007d, 0x0000001f },
  { 0x00000000, 0x00000000, 0x00000002, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xfffffffd, 0xffffffff },
  { 0x00000000, 0x00000000, 0x00000020, 0x00000000 },
  { 0x00000000, 0x00000000, 0x7fffffff, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffff8002, 0xffffffff },
  { 0x00000000, 0x1fffffff, 0x7fffffff, 0x1fffffff },
  { 0x00000000, 0xffffffff, 0xfffffffd, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffffffe0, 0xffffffff },
  { 0x00000000, 0x00000000, 0x00000020, 0x00000000 },
  { 0x00000000, 0x0000007f, 0x0000007f, 0x0000007f },
  { 0x00000000, 0xffffffff, 0x80000001, 0xffffffff },
  { 0x00000000, 0x00000000, 0x0000007f, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffffffe0, 0xffffffff },
  { 0x00000000, 0x0000001f, 0x0000007e, 0x0000001f },
  { 0x00000000, 0x00000000, 0x55555555, 0x00000000 },
  { 0x00000000, 0x00000000, 0x7fffffff, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xfffffffe, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffff8002, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xfffffffd, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xfffffffd, 0xffffffff },
  { 0x00000000, 0x00000000, 0x00007ffe, 0x00000000 },
  { 0x00000000, 0x00000008, 0x00000020, 0x00000008 },
  { 0x00000000, 0xffffffff, 0xffff8002, 0xffffffff },
  { 0x00000000, 0xe0000000, 0x80000001, 0xe0000000 },
  { 0x00000000, 0x00000000, 0x0000007e, 0x00000000 },
};
const Inputs kOutputs_Asr_RdIsNotRnIsNotRm_al_r11_r7_r8[] = {
  { 0x00000000, 0x00000000, 0x0000007e, 0x0000007d },
  { 0x00000000, 0x00000000, 0x00000002, 0xffff8002 },
  { 0x00000000, 0x80000001, 0x80000001, 0x00000000 },
  { 0x00000000, 0xffffffe0, 0xffffff83, 0x00000002 },
  { 0x00000000, 0xfffffff8, 0xffffffe0, 0x00000002 },
  { 0x00000000, 0xffffffff, 0x80000001, 0xffffff82 },
  { 0x00000000, 0x00000000, 0x00007fff, 0x0000007f },
  { 0x00000000, 0x00000000, 0x0000007d, 0x7ffffffe },
  { 0x00000000, 0x00000008, 0x00000020, 0xffff8002 },
  { 0x00000000, 0x2aaaaaaa, 0x55555555, 0x00000001 },
  { 0x00000000, 0x33333333, 0x33333333, 0x00000000 },
  { 0x00000000, 0x00000000, 0x7ffffffd, 0x55555555 },
  { 0x00000000, 0xffffffff, 0xffff8001, 0x7ffffffe },
  { 0x00000000, 0xfffffff0, 0xffffff83, 0xffff8003 },
  { 0x00000000, 0xffffffff, 0xffffffe0, 0xffffff81 },
  { 0x00000000, 0xffffffff, 0xffff8001, 0x0000007e },
  { 0x00000000, 0x00000000, 0x0000007e, 0x00000020 },
  { 0x00000000, 0xffffffff, 0xfffffffd, 0xaaaaaaaa },
  { 0x00000000, 0xffffffff, 0xffffff82, 0x7ffffffd },
  { 0x00000000, 0xffffffff, 0xcccccccc, 0x7fffffff },
  { 0x00000000, 0xffffffff, 0x80000001, 0xffffffff },
  { 0x00000000, 0x00000000, 0x00000020, 0x7ffffffe },
  { 0x00000000, 0xffffffff, 0xffffff81, 0xffffffe0 },
  { 0x00000000, 0xffffffff, 0xffffff81, 0xfffffffd },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffff8000, 0xcccccccc },
  { 0x00000000, 0x00000000, 0x00007ffe, 0xffffff82 },
  { 0x00000000, 0x0000000f, 0x0000007d, 0xffff8003 },
  { 0x00000000, 0xffffffff, 0xffffff81, 0x0000007e },
  { 0x00000000, 0x00000000, 0x7ffffffd, 0xfffffffe },
  { 0x00000000, 0xffffffff, 0x80000001, 0xffffff81 },
  { 0x00000000, 0x00000000, 0x00007ffd, 0xfffffffd },
  { 0x00000000, 0x0fffffff, 0x7fffffff, 0xffff8003 },
  { 0x00000000, 0x00000000, 0x0000007d, 0x33333333 },
  { 0x00000000, 0xffffffff, 0xffff8000, 0x00007ffe },
  { 0x00000000, 0xffffffff, 0xffff8000, 0x00000020 },
  { 0x00000000, 0x00000000, 0x00007fff, 0xffffffe0 },
  { 0x00000000, 0x00000000, 0x00000000, 0x00007ffe },
  { 0x00000000, 0x19999999, 0x33333333, 0x00000001 },
  { 0x00000000, 0xffffffff, 0xffffff80, 0x00000020 },
  { 0x00000000, 0xffffffff, 0xffffff83, 0x00007ffd },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x80000001 },
  { 0x00000000, 0xffffffff, 0xffffff81, 0xcccccccc },
  { 0x00000000, 0x0000003f, 0x0000007f, 0xffff8001 },
  { 0x00000000, 0x00000020, 0x00000020, 0x80000000 },
  { 0x00000000, 0x00000000, 0x00007fff, 0xffffff80 },
  { 0x00000000, 0x00000000, 0x7ffffffe, 0x7ffffffd },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00000001 },
  { 0x00000000, 0x00000000, 0x7ffffffd, 0xffffff83 },
  { 0x00000000, 0xffffffff, 0xffff8001, 0xffffffe0 },
  { 0x00000000, 0xffffffff, 0xffffff80, 0x00007ffd },
  { 0x00000000, 0x00000000, 0x00007fff, 0x00007ffe },
  { 0x00000000, 0x00000000, 0x00000000, 0xffff8000 },
  { 0x00000000, 0xffffffff, 0xaaaaaaaa, 0x7ffffffe },
  { 0x00000000, 0x00000000, 0x00007ffd, 0xffffffe0 },
  { 0x00000000, 0xffffffff, 0xffffffe0, 0xffffff83 },
  { 0x00000000, 0xffffffff, 0xffffffe0, 0x7ffffffd },
  { 0x00000000, 0xffff8002, 0xffff8002, 0x80000000 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x80000000 },
  { 0x00000000, 0xf0000000, 0x80000001, 0xffff8003 },
  { 0x00000000, 0xffffffff, 0xaaaaaaaa, 0xffffff81 },
  { 0x00000000, 0xffffffff, 0xfffffffd, 0xffffffe0 },
  { 0x00000000, 0xffffffff, 0xffffff80, 0x00007ffe },
  { 0x00000000, 0xffffffff, 0xffff8003, 0xffffffff },
  { 0x00000000, 0xffffff82, 0xffffff82, 0xffff8000 },
  { 0x00000000, 0x00000002, 0x00000002, 0x80000000 },
  { 0x00000000, 0xffffffff, 0xffffff82, 0xffffff81 },
  { 0x00000000, 0xffffffff, 0xcccccccc, 0x00007ffd },
  { 0x00000000, 0x00000000, 0x00007ffe, 0x7fffffff },
  { 0x00000000, 0xffffffff, 0xffffff81, 0xaaaaaaaa },
  { 0x00000000, 0x0000001f, 0x0000007e, 0x00000002 },
  { 0x00000000, 0x00000000, 0x0000007e, 0xffffff80 },
  { 0x00000000, 0x00000000, 0x00007ffe, 0xaaaaaaaa },
  { 0x00000000, 0x0aaaaaaa, 0x55555555, 0xffff8003 },
  { 0x00000000, 0x00000000, 0x00000001, 0xffffff80 },
  { 0x00000000, 0x2aaaaaaa, 0x55555555, 0x80000001 },
  { 0x00000000, 0x00000000, 0x00000000, 0x0000007e },
  { 0x00000000, 0xaaaaaaaa, 0xaaaaaaaa, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffffff81, 0xcccccccc },
  { 0x00000000, 0xffffffff, 0xcccccccc, 0xfffffffd },
  { 0x00000000, 0xffffffff, 0xffff8000, 0x7ffffffd },
  { 0x00000000, 0xffffc000, 0xffff8000, 0x80000001 },
  { 0x00000000, 0xffffc001, 0xffff8003, 0xffff8001 },
  { 0x00000000, 0x00007ffd, 0x00007ffd, 0x80000000 },
  { 0x00000000, 0x00000000, 0x00007fff, 0xcccccccc },
  { 0x00000000, 0xffffffff, 0xffffff80, 0x00007ffe },
  { 0x00000000, 0x00000000, 0x7ffffffd, 0xaaaaaaaa },
  { 0x00000000, 0xffffffff, 0xffff8003, 0x0000007f },
  { 0x00000000, 0xffffffff, 0xfffffffe, 0xfffffffd },
  { 0x00000000, 0xffffffff, 0xfffffffe, 0x55555555 },
  { 0x00000000, 0xffffffff, 0xfffffffe, 0xfffffffe },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00007fff },
  { 0x00000000, 0x00000000, 0x0000007e, 0x00007ffd },
  { 0x00000000, 0xfffffff8, 0xffffffe0, 0x00000002 },
  { 0x00000000, 0x00000000, 0x00007ffd, 0xffffff81 },
  { 0x00000000, 0x00000000, 0x00000020, 0xfffffffd },
  { 0x00000000, 0x00000000, 0x0000007d, 0xffffff83 },
  { 0x00000000, 0x00000000, 0x55555555, 0x7ffffffe },
  { 0x00000000, 0x00001fff, 0x00007ffe, 0x00000002 },
  { 0x00000000, 0x00000000, 0x7fffffff, 0x00007ffd },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00000001 },
  { 0x00000000, 0x00000000, 0x33333333, 0xffffff83 },
  { 0x00000000, 0xffffffff, 0xcccccccc, 0x33333333 },
  { 0x00000000, 0xffffffc0, 0xffffff80, 0x00000001 },
  { 0x00000000, 0xffffffff, 0xcccccccc, 0x00007ffd },
  { 0x00000000, 0xffffffff, 0xfffffffd, 0x7ffffffe },
  { 0x00000000, 0x00000000, 0x7ffffffe, 0xffffff83 },
  { 0x00000000, 0x0000003f, 0x0000007f, 0xffff8001 },
  { 0x00000000, 0x00000000, 0x00007fff, 0xffffff80 },
  { 0x00000000, 0x00000000, 0x00007fff, 0x7ffffffe },
  { 0x00000000, 0x2aaaaaaa, 0x55555555, 0xffff8001 },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffff80 },
  { 0x00000000, 0x00001fff, 0x00007fff, 0x00000002 },
  { 0x00000000, 0x0aaaaaaa, 0x55555555, 0xffff8003 },
  { 0x00000000, 0xffffffff, 0xffff8003, 0x00000020 },
  { 0x00000000, 0xffffffff, 0xffff8002, 0x7fffffff },
  { 0x00000000, 0x55555555, 0x55555555, 0x00000000 },
  { 0x00000000, 0x00000000, 0x00007ffe, 0xffffff81 },
  { 0x00000000, 0xffffffff, 0x80000001, 0x00007ffe },
  { 0x00000000, 0xffffffff, 0xaaaaaaaa, 0x00000020 },
  { 0x00000000, 0xffffffff, 0xfffffffe, 0x00000002 },
  { 0x00000000, 0xffffe000, 0xffff8000, 0xffff8002 },
  { 0x00000000, 0x00000000, 0x00007fff, 0xaaaaaaaa },
  { 0x00000000, 0xffffffff, 0xffffff80, 0x00007ffd },
  { 0x00000000, 0xffffffff, 0x80000000, 0xffffff80 },
  { 0x00000000, 0x00000000, 0x55555555, 0xfffffffd },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00007ffd },
  { 0x00000000, 0xffffffff, 0xfffffffe, 0xffffff80 },
  { 0x00000000, 0xffffffe0, 0xffffff82, 0xffff8002 },
  { 0x00000000, 0x7ffffffe, 0x7ffffffe, 0xffff8000 },
  { 0x00000000, 0xffffffff, 0xffff8003, 0xffffff80 },
  { 0x00000000, 0x00000000, 0x00000020, 0xffffffe0 },
  { 0x00000000, 0xffffffff, 0xffff8001, 0xffffffe0 },
  { 0x00000000, 0xffffe000, 0xffff8000, 0xffff8002 },
  { 0x00000000, 0x00000000, 0x00000002, 0x7ffffffe },
  { 0x00000000, 0x00000000, 0x0000007f, 0xffffff81 },
  { 0x00000000, 0x00000000, 0x00000001, 0x7fffffff },
  { 0x00000000, 0x00000000, 0x00000000, 0x33333333 },
  { 0x00000000, 0xffffffff, 0xffffff83, 0xcccccccc },
  { 0x00000000, 0x00000000, 0x00000020, 0x00007ffd },
  { 0x00000000, 0xcccccccc, 0xcccccccc, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffff8000, 0x00007fff },
  { 0x00000000, 0xffffffff, 0xcccccccc, 0x00007ffe },
  { 0x00000000, 0xffffffff, 0xfffffffd, 0x7ffffffe },
  { 0x00000000, 0xffffffff, 0xaaaaaaaa, 0x55555555 },
  { 0x00000000, 0xffffffff, 0xaaaaaaaa, 0xffffff81 },
  { 0x00000000, 0xfffffffe, 0xfffffffe, 0xffff8000 },
  { 0x00000000, 0xffffffff, 0xffffffe0, 0xfffffffd },
  { 0x00000000, 0x00000000, 0x33333333, 0xfffffffd },
  { 0x00000000, 0xffffc001, 0xffff8002, 0x80000001 },
  { 0x00000000, 0xffffffff, 0xffffff83, 0xffffff83 },
  { 0x00000000, 0xffffffff, 0xffff8002, 0x00000020 },
  { 0x00000000, 0x00000000, 0x7fffffff, 0x0000007f },
  { 0x00000000, 0xcccccccc, 0xcccccccc, 0xffff8000 },
  { 0x00000000, 0x00000000, 0x7ffffffe, 0x00007fff },
  { 0x00000000, 0x00000000, 0x7ffffffd, 0x7ffffffd },
  { 0x00000000, 0xffffffff, 0xfffffffd, 0xffff8002 },
  { 0x00000000, 0x00000000, 0x00000002, 0x7fffffff },
  { 0x00000000, 0xffffffff, 0xfffffffe, 0x00000020 },
  { 0x00000000, 0x00000000, 0x0000007e, 0x00007ffe },
  { 0x00000000, 0x00000000, 0x00007ffd, 0xfffffffd },
  { 0x00000000, 0x0000001f, 0x0000007f, 0x00000002 },
  { 0x00000000, 0xffffffff, 0x80000000, 0x7ffffffd },
  { 0x00000000, 0x00003fff, 0x00007fff, 0x80000001 },
  { 0x00000000, 0xffffffff, 0x80000000, 0xaaaaaaaa },
  { 0x00000000, 0xd5555555, 0xaaaaaaaa, 0xffff8001 },
  { 0x00000000, 0xfffffffc, 0xffffffe0, 0xffff8003 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00007ffd },
  { 0x00000000, 0xffffffc0, 0xffffff81, 0x00000001 },
  { 0x00000000, 0xd5555555, 0xaaaaaaaa, 0x80000001 },
  { 0x00000000, 0xffff8000, 0xffff8000, 0xffff8000 },
  { 0x00000000, 0x00000000, 0x00007ffd, 0xaaaaaaaa },
  { 0x00000000, 0x7ffffffe, 0x7ffffffe, 0x80000000 },
  { 0x00000000, 0x00000000, 0x00007ffe, 0xffffff81 },
  { 0x00000000, 0x0000001f, 0x0000007d, 0xffff8002 },
  { 0x00000000, 0x00000000, 0x00000002, 0xffffff81 },
  { 0x00000000, 0xffffffff, 0xfffffffd, 0x7ffffffd },
  { 0x00000000, 0x00000000, 0x00000020, 0xffffff80 },
  { 0x00000000, 0x00000000, 0x7fffffff, 0xffffffe0 },
  { 0x00000000, 0xffffffff, 0xffff8002, 0x0000007f },
  { 0x00000000, 0x1fffffff, 0x7fffffff, 0xffff8002 },
  { 0x00000000, 0xffffffff, 0xfffffffd, 0x00000020 },
  { 0x00000000, 0xffffffff, 0xffffffe0, 0x0000007e },
  { 0x00000000, 0x00000000, 0x00000020, 0x7ffffffe },
  { 0x00000000, 0x0000007f, 0x0000007f, 0xffff8000 },
  { 0x00000000, 0xffffffff, 0x80000001, 0x0000007d },
  { 0x00000000, 0x00000000, 0x0000007f, 0x00007ffd },
  { 0x00000000, 0xffffffff, 0xffffffe0, 0xffffff82 },
  { 0x00000000, 0x0000001f, 0x0000007e, 0xffff8002 },
  { 0x00000000, 0x00000000, 0x55555555, 0x0000007f },
  { 0x00000000, 0x00000000, 0x7fffffff, 0x7ffffffe },
  { 0x00000000, 0xffffffff, 0xfffffffe, 0xffffff80 },
  { 0x00000000, 0xffffffff, 0xffff8002, 0x33333333 },
  { 0x00000000, 0xffffffff, 0xfffffffd, 0xaaaaaaaa },
  { 0x00000000, 0xffffffff, 0xfffffffd, 0x00000020 },
  { 0x00000000, 0x00000000, 0x00007ffe, 0x55555555 },
  { 0x00000000, 0x00000008, 0x00000020, 0x00000002 },
  { 0x00000000, 0xffffffff, 0xffff8002, 0xfffffffe },
  { 0x00000000, 0xe0000000, 0x80000001, 0xffff8002 },
  { 0x00000000, 0x00000000, 0x0000007e, 0x33333333 },
};
const Inputs kOutputs_Asr_RdIsNotRnIsNotRm_al_r12_r2_r3[] = {
  { 0x00000000, 0x00000000, 0x0000007e, 0x0000007d },
  { 0x00000000, 0x00000000, 0x00000002, 0xffff8002 },
  { 0x00000000, 0x80000001, 0x80000001, 0x00000000 },
  { 0x00000000, 0xffffffe0, 0xffffff83, 0x00000002 },
  { 0x00000000, 0xfffffff8, 0xffffffe0, 0x00000002 },
  { 0x00000000, 0xffffffff, 0x80000001, 0xffffff82 },
  { 0x00000000, 0x00000000, 0x00007fff, 0x0000007f },
  { 0x00000000, 0x00000000, 0x0000007d, 0x7ffffffe },
  { 0x00000000, 0x00000008, 0x00000020, 0xffff8002 },
  { 0x00000000, 0x2aaaaaaa, 0x55555555, 0x00000001 },
  { 0x00000000, 0x33333333, 0x33333333, 0x00000000 },
  { 0x00000000, 0x00000000, 0x7ffffffd, 0x55555555 },
  { 0x00000000, 0xffffffff, 0xffff8001, 0x7ffffffe },
  { 0x00000000, 0xfffffff0, 0xffffff83, 0xffff8003 },
  { 0x00000000, 0xffffffff, 0xffffffe0, 0xffffff81 },
  { 0x00000000, 0xffffffff, 0xffff8001, 0x0000007e },
  { 0x00000000, 0x00000000, 0x0000007e, 0x00000020 },
  { 0x00000000, 0xffffffff, 0xfffffffd, 0xaaaaaaaa },
  { 0x00000000, 0xffffffff, 0xffffff82, 0x7ffffffd },
  { 0x00000000, 0xffffffff, 0xcccccccc, 0x7fffffff },
  { 0x00000000, 0xffffffff, 0x80000001, 0xffffffff },
  { 0x00000000, 0x00000000, 0x00000020, 0x7ffffffe },
  { 0x00000000, 0xffffffff, 0xffffff81, 0xffffffe0 },
  { 0x00000000, 0xffffffff, 0xffffff81, 0xfffffffd },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffff8000, 0xcccccccc },
  { 0x00000000, 0x00000000, 0x00007ffe, 0xffffff82 },
  { 0x00000000, 0x0000000f, 0x0000007d, 0xffff8003 },
  { 0x00000000, 0xffffffff, 0xffffff81, 0x0000007e },
  { 0x00000000, 0x00000000, 0x7ffffffd, 0xfffffffe },
  { 0x00000000, 0xffffffff, 0x80000001, 0xffffff81 },
  { 0x00000000, 0x00000000, 0x00007ffd, 0xfffffffd },
  { 0x00000000, 0x0fffffff, 0x7fffffff, 0xffff8003 },
  { 0x00000000, 0x00000000, 0x0000007d, 0x33333333 },
  { 0x00000000, 0xffffffff, 0xffff8000, 0x00007ffe },
  { 0x00000000, 0xffffffff, 0xffff8000, 0x00000020 },
  { 0x00000000, 0x00000000, 0x00007fff, 0xffffffe0 },
  { 0x00000000, 0x00000000, 0x00000000, 0x00007ffe },
  { 0x00000000, 0x19999999, 0x33333333, 0x00000001 },
  { 0x00000000, 0xffffffff, 0xffffff80, 0x00000020 },
  { 0x00000000, 0xffffffff, 0xffffff83, 0x00007ffd },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x80000001 },
  { 0x00000000, 0xffffffff, 0xffffff81, 0xcccccccc },
  { 0x00000000, 0x0000003f, 0x0000007f, 0xffff8001 },
  { 0x00000000, 0x00000020, 0x00000020, 0x80000000 },
  { 0x00000000, 0x00000000, 0x00007fff, 0xffffff80 },
  { 0x00000000, 0x00000000, 0x7ffffffe, 0x7ffffffd },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00000001 },
  { 0x00000000, 0x00000000, 0x7ffffffd, 0xffffff83 },
  { 0x00000000, 0xffffffff, 0xffff8001, 0xffffffe0 },
  { 0x00000000, 0xffffffff, 0xffffff80, 0x00007ffd },
  { 0x00000000, 0x00000000, 0x00007fff, 0x00007ffe },
  { 0x00000000, 0x00000000, 0x00000000, 0xffff8000 },
  { 0x00000000, 0xffffffff, 0xaaaaaaaa, 0x7ffffffe },
  { 0x00000000, 0x00000000, 0x00007ffd, 0xffffffe0 },
  { 0x00000000, 0xffffffff, 0xffffffe0, 0xffffff83 },
  { 0x00000000, 0xffffffff, 0xffffffe0, 0x7ffffffd },
  { 0x00000000, 0xffff8002, 0xffff8002, 0x80000000 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x80000000 },
  { 0x00000000, 0xf0000000, 0x80000001, 0xffff8003 },
  { 0x00000000, 0xffffffff, 0xaaaaaaaa, 0xffffff81 },
  { 0x00000000, 0xffffffff, 0xfffffffd, 0xffffffe0 },
  { 0x00000000, 0xffffffff, 0xffffff80, 0x00007ffe },
  { 0x00000000, 0xffffffff, 0xffff8003, 0xffffffff },
  { 0x00000000, 0xffffff82, 0xffffff82, 0xffff8000 },
  { 0x00000000, 0x00000002, 0x00000002, 0x80000000 },
  { 0x00000000, 0xffffffff, 0xffffff82, 0xffffff81 },
  { 0x00000000, 0xffffffff, 0xcccccccc, 0x00007ffd },
  { 0x00000000, 0x00000000, 0x00007ffe, 0x7fffffff },
  { 0x00000000, 0xffffffff, 0xffffff81, 0xaaaaaaaa },
  { 0x00000000, 0x0000001f, 0x0000007e, 0x00000002 },
  { 0x00000000, 0x00000000, 0x0000007e, 0xffffff80 },
  { 0x00000000, 0x00000000, 0x00007ffe, 0xaaaaaaaa },
  { 0x00000000, 0x0aaaaaaa, 0x55555555, 0xffff8003 },
  { 0x00000000, 0x00000000, 0x00000001, 0xffffff80 },
  { 0x00000000, 0x2aaaaaaa, 0x55555555, 0x80000001 },
  { 0x00000000, 0x00000000, 0x00000000, 0x0000007e },
  { 0x00000000, 0xaaaaaaaa, 0xaaaaaaaa, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffffff81, 0xcccccccc },
  { 0x00000000, 0xffffffff, 0xcccccccc, 0xfffffffd },
  { 0x00000000, 0xffffffff, 0xffff8000, 0x7ffffffd },
  { 0x00000000, 0xffffc000, 0xffff8000, 0x80000001 },
  { 0x00000000, 0xffffc001, 0xffff8003, 0xffff8001 },
  { 0x00000000, 0x00007ffd, 0x00007ffd, 0x80000000 },
  { 0x00000000, 0x00000000, 0x00007fff, 0xcccccccc },
  { 0x00000000, 0xffffffff, 0xffffff80, 0x00007ffe },
  { 0x00000000, 0x00000000, 0x7ffffffd, 0xaaaaaaaa },
  { 0x00000000, 0xffffffff, 0xffff8003, 0x0000007f },
  { 0x00000000, 0xffffffff, 0xfffffffe, 0xfffffffd },
  { 0x00000000, 0xffffffff, 0xfffffffe, 0x55555555 },
  { 0x00000000, 0xffffffff, 0xfffffffe, 0xfffffffe },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00007fff },
  { 0x00000000, 0x00000000, 0x0000007e, 0x00007ffd },
  { 0x00000000, 0xfffffff8, 0xffffffe0, 0x00000002 },
  { 0x00000000, 0x00000000, 0x00007ffd, 0xffffff81 },
  { 0x00000000, 0x00000000, 0x00000020, 0xfffffffd },
  { 0x00000000, 0x00000000, 0x0000007d, 0xffffff83 },
  { 0x00000000, 0x00000000, 0x55555555, 0x7ffffffe },
  { 0x00000000, 0x00001fff, 0x00007ffe, 0x00000002 },
  { 0x00000000, 0x00000000, 0x7fffffff, 0x00007ffd },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00000001 },
  { 0x00000000, 0x00000000, 0x33333333, 0xffffff83 },
  { 0x00000000, 0xffffffff, 0xcccccccc, 0x33333333 },
  { 0x00000000, 0xffffffc0, 0xffffff80, 0x00000001 },
  { 0x00000000, 0xffffffff, 0xcccccccc, 0x00007ffd },
  { 0x00000000, 0xffffffff, 0xfffffffd, 0x7ffffffe },
  { 0x00000000, 0x00000000, 0x7ffffffe, 0xffffff83 },
  { 0x00000000, 0x0000003f, 0x0000007f, 0xffff8001 },
  { 0x00000000, 0x00000000, 0x00007fff, 0xffffff80 },
  { 0x00000000, 0x00000000, 0x00007fff, 0x7ffffffe },
  { 0x00000000, 0x2aaaaaaa, 0x55555555, 0xffff8001 },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffff80 },
  { 0x00000000, 0x00001fff, 0x00007fff, 0x00000002 },
  { 0x00000000, 0x0aaaaaaa, 0x55555555, 0xffff8003 },
  { 0x00000000, 0xffffffff, 0xffff8003, 0x00000020 },
  { 0x00000000, 0xffffffff, 0xffff8002, 0x7fffffff },
  { 0x00000000, 0x55555555, 0x55555555, 0x00000000 },
  { 0x00000000, 0x00000000, 0x00007ffe, 0xffffff81 },
  { 0x00000000, 0xffffffff, 0x80000001, 0x00007ffe },
  { 0x00000000, 0xffffffff, 0xaaaaaaaa, 0x00000020 },
  { 0x00000000, 0xffffffff, 0xfffffffe, 0x00000002 },
  { 0x00000000, 0xffffe000, 0xffff8000, 0xffff8002 },
  { 0x00000000, 0x00000000, 0x00007fff, 0xaaaaaaaa },
  { 0x00000000, 0xffffffff, 0xffffff80, 0x00007ffd },
  { 0x00000000, 0xffffffff, 0x80000000, 0xffffff80 },
  { 0x00000000, 0x00000000, 0x55555555, 0xfffffffd },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00007ffd },
  { 0x00000000, 0xffffffff, 0xfffffffe, 0xffffff80 },
  { 0x00000000, 0xffffffe0, 0xffffff82, 0xffff8002 },
  { 0x00000000, 0x7ffffffe, 0x7ffffffe, 0xffff8000 },
  { 0x00000000, 0xffffffff, 0xffff8003, 0xffffff80 },
  { 0x00000000, 0x00000000, 0x00000020, 0xffffffe0 },
  { 0x00000000, 0xffffffff, 0xffff8001, 0xffffffe0 },
  { 0x00000000, 0xffffe000, 0xffff8000, 0xffff8002 },
  { 0x00000000, 0x00000000, 0x00000002, 0x7ffffffe },
  { 0x00000000, 0x00000000, 0x0000007f, 0xffffff81 },
  { 0x00000000, 0x00000000, 0x00000001, 0x7fffffff },
  { 0x00000000, 0x00000000, 0x00000000, 0x33333333 },
  { 0x00000000, 0xffffffff, 0xffffff83, 0xcccccccc },
  { 0x00000000, 0x00000000, 0x00000020, 0x00007ffd },
  { 0x00000000, 0xcccccccc, 0xcccccccc, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffff8000, 0x00007fff },
  { 0x00000000, 0xffffffff, 0xcccccccc, 0x00007ffe },
  { 0x00000000, 0xffffffff, 0xfffffffd, 0x7ffffffe },
  { 0x00000000, 0xffffffff, 0xaaaaaaaa, 0x55555555 },
  { 0x00000000, 0xffffffff, 0xaaaaaaaa, 0xffffff81 },
  { 0x00000000, 0xfffffffe, 0xfffffffe, 0xffff8000 },
  { 0x00000000, 0xffffffff, 0xffffffe0, 0xfffffffd },
  { 0x00000000, 0x00000000, 0x33333333, 0xfffffffd },
  { 0x00000000, 0xffffc001, 0xffff8002, 0x80000001 },
  { 0x00000000, 0xffffffff, 0xffffff83, 0xffffff83 },
  { 0x00000000, 0xffffffff, 0xffff8002, 0x00000020 },
  { 0x00000000, 0x00000000, 0x7fffffff, 0x0000007f },
  { 0x00000000, 0xcccccccc, 0xcccccccc, 0xffff8000 },
  { 0x00000000, 0x00000000, 0x7ffffffe, 0x00007fff },
  { 0x00000000, 0x00000000, 0x7ffffffd, 0x7ffffffd },
  { 0x00000000, 0xffffffff, 0xfffffffd, 0xffff8002 },
  { 0x00000000, 0x00000000, 0x00000002, 0x7fffffff },
  { 0x00000000, 0xffffffff, 0xfffffffe, 0x00000020 },
  { 0x00000000, 0x00000000, 0x0000007e, 0x00007ffe },
  { 0x00000000, 0x00000000, 0x00007ffd, 0xfffffffd },
  { 0x00000000, 0x0000001f, 0x0000007f, 0x00000002 },
  { 0x00000000, 0xffffffff, 0x80000000, 0x7ffffffd },
  { 0x00000000, 0x00003fff, 0x00007fff, 0x80000001 },
  { 0x00000000, 0xffffffff, 0x80000000, 0xaaaaaaaa },
  { 0x00000000, 0xd5555555, 0xaaaaaaaa, 0xffff8001 },
  { 0x00000000, 0xfffffffc, 0xffffffe0, 0xffff8003 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00007ffd },
  { 0x00000000, 0xffffffc0, 0xffffff81, 0x00000001 },
  { 0x00000000, 0xd5555555, 0xaaaaaaaa, 0x80000001 },
  { 0x00000000, 0xffff8000, 0xffff8000, 0xffff8000 },
  { 0x00000000, 0x00000000, 0x00007ffd, 0xaaaaaaaa },
  { 0x00000000, 0x7ffffffe, 0x7ffffffe, 0x80000000 },
  { 0x00000000, 0x00000000, 0x00007ffe, 0xffffff81 },
  { 0x00000000, 0x0000001f, 0x0000007d, 0xffff8002 },
  { 0x00000000, 0x00000000, 0x00000002, 0xffffff81 },
  { 0x00000000, 0xffffffff, 0xfffffffd, 0x7ffffffd },
  { 0x00000000, 0x00000000, 0x00000020, 0xffffff80 },
  { 0x00000000, 0x00000000, 0x7fffffff, 0xffffffe0 },
  { 0x00000000, 0xffffffff, 0xffff8002, 0x0000007f },
  { 0x00000000, 0x1fffffff, 0x7fffffff, 0xffff8002 },
  { 0x00000000, 0xffffffff, 0xfffffffd, 0x00000020 },
  { 0x00000000, 0xffffffff, 0xffffffe0, 0x0000007e },
  { 0x00000000, 0x00000000, 0x00000020, 0x7ffffffe },
  { 0x00000000, 0x0000007f, 0x0000007f, 0xffff8000 },
  { 0x00000000, 0xffffffff, 0x80000001, 0x0000007d },
  { 0x00000000, 0x00000000, 0x0000007f, 0x00007ffd },
  { 0x00000000, 0xffffffff, 0xffffffe0, 0xffffff82 },
  { 0x00000000, 0x0000001f, 0x0000007e, 0xffff8002 },
  { 0x00000000, 0x00000000, 0x55555555, 0x0000007f },
  { 0x00000000, 0x00000000, 0x7fffffff, 0x7ffffffe },
  { 0x00000000, 0xffffffff, 0xfffffffe, 0xffffff80 },
  { 0x00000000, 0xffffffff, 0xffff8002, 0x33333333 },
  { 0x00000000, 0xffffffff, 0xfffffffd, 0xaaaaaaaa },
  { 0x00000000, 0xffffffff, 0xfffffffd, 0x00000020 },
  { 0x00000000, 0x00000000, 0x00007ffe, 0x55555555 },
  { 0x00000000, 0x00000008, 0x00000020, 0x00000002 },
  { 0x00000000, 0xffffffff, 0xffff8002, 0xfffffffe },
  { 0x00000000, 0xe0000000, 0x80000001, 0xffff8002 },
  { 0x00000000, 0x00000000, 0x0000007e, 0x33333333 },
};
const Inputs kOutputs_Asr_RdIsNotRnIsNotRm_al_r7_r4_r10[] = {
  { 0x00000000, 0x00000000, 0x0000007e, 0x0000007d },
  { 0x00000000, 0x00000000, 0x00000002, 0xffff8002 },
  { 0x00000000, 0x80000001, 0x80000001, 0x00000000 },
  { 0x00000000, 0xffffffe0, 0xffffff83, 0x00000002 },
  { 0x00000000, 0xfffffff8, 0xffffffe0, 0x00000002 },
  { 0x00000000, 0xffffffff, 0x80000001, 0xffffff82 },
  { 0x00000000, 0x00000000, 0x00007fff, 0x0000007f },
  { 0x00000000, 0x00000000, 0x0000007d, 0x7ffffffe },
  { 0x00000000, 0x00000008, 0x00000020, 0xffff8002 },
  { 0x00000000, 0x2aaaaaaa, 0x55555555, 0x00000001 },
  { 0x00000000, 0x33333333, 0x33333333, 0x00000000 },
  { 0x00000000, 0x00000000, 0x7ffffffd, 0x55555555 },
  { 0x00000000, 0xffffffff, 0xffff8001, 0x7ffffffe },
  { 0x00000000, 0xfffffff0, 0xffffff83, 0xffff8003 },
  { 0x00000000, 0xffffffff, 0xffffffe0, 0xffffff81 },
  { 0x00000000, 0xffffffff, 0xffff8001, 0x0000007e },
  { 0x00000000, 0x00000000, 0x0000007e, 0x00000020 },
  { 0x00000000, 0xffffffff, 0xfffffffd, 0xaaaaaaaa },
  { 0x00000000, 0xffffffff, 0xffffff82, 0x7ffffffd },
  { 0x00000000, 0xffffffff, 0xcccccccc, 0x7fffffff },
  { 0x00000000, 0xffffffff, 0x80000001, 0xffffffff },
  { 0x00000000, 0x00000000, 0x00000020, 0x7ffffffe },
  { 0x00000000, 0xffffffff, 0xffffff81, 0xffffffe0 },
  { 0x00000000, 0xffffffff, 0xffffff81, 0xfffffffd },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffff8000, 0xcccccccc },
  { 0x00000000, 0x00000000, 0x00007ffe, 0xffffff82 },
  { 0x00000000, 0x0000000f, 0x0000007d, 0xffff8003 },
  { 0x00000000, 0xffffffff, 0xffffff81, 0x0000007e },
  { 0x00000000, 0x00000000, 0x7ffffffd, 0xfffffffe },
  { 0x00000000, 0xffffffff, 0x80000001, 0xffffff81 },
  { 0x00000000, 0x00000000, 0x00007ffd, 0xfffffffd },
  { 0x00000000, 0x0fffffff, 0x7fffffff, 0xffff8003 },
  { 0x00000000, 0x00000000, 0x0000007d, 0x33333333 },
  { 0x00000000, 0xffffffff, 0xffff8000, 0x00007ffe },
  { 0x00000000, 0xffffffff, 0xffff8000, 0x00000020 },
  { 0x00000000, 0x00000000, 0x00007fff, 0xffffffe0 },
  { 0x00000000, 0x00000000, 0x00000000, 0x00007ffe },
  { 0x00000000, 0x19999999, 0x33333333, 0x00000001 },
  { 0x00000000, 0xffffffff, 0xffffff80, 0x00000020 },
  { 0x00000000, 0xffffffff, 0xffffff83, 0x00007ffd },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x80000001 },
  { 0x00000000, 0xffffffff, 0xffffff81, 0xcccccccc },
  { 0x00000000, 0x0000003f, 0x0000007f, 0xffff8001 },
  { 0x00000000, 0x00000020, 0x00000020, 0x80000000 },
  { 0x00000000, 0x00000000, 0x00007fff, 0xffffff80 },
  { 0x00000000, 0x00000000, 0x7ffffffe, 0x7ffffffd },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00000001 },
  { 0x00000000, 0x00000000, 0x7ffffffd, 0xffffff83 },
  { 0x00000000, 0xffffffff, 0xffff8001, 0xffffffe0 },
  { 0x00000000, 0xffffffff, 0xffffff80, 0x00007ffd },
  { 0x00000000, 0x00000000, 0x00007fff, 0x00007ffe },
  { 0x00000000, 0x00000000, 0x00000000, 0xffff8000 },
  { 0x00000000, 0xffffffff, 0xaaaaaaaa, 0x7ffffffe },
  { 0x00000000, 0x00000000, 0x00007ffd, 0xffffffe0 },
  { 0x00000000, 0xffffffff, 0xffffffe0, 0xffffff83 },
  { 0x00000000, 0xffffffff, 0xffffffe0, 0x7ffffffd },
  { 0x00000000, 0xffff8002, 0xffff8002, 0x80000000 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x80000000 },
  { 0x00000000, 0xf0000000, 0x80000001, 0xffff8003 },
  { 0x00000000, 0xffffffff, 0xaaaaaaaa, 0xffffff81 },
  { 0x00000000, 0xffffffff, 0xfffffffd, 0xffffffe0 },
  { 0x00000000, 0xffffffff, 0xffffff80, 0x00007ffe },
  { 0x00000000, 0xffffffff, 0xffff8003, 0xffffffff },
  { 0x00000000, 0xffffff82, 0xffffff82, 0xffff8000 },
  { 0x00000000, 0x00000002, 0x00000002, 0x80000000 },
  { 0x00000000, 0xffffffff, 0xffffff82, 0xffffff81 },
  { 0x00000000, 0xffffffff, 0xcccccccc, 0x00007ffd },
  { 0x00000000, 0x00000000, 0x00007ffe, 0x7fffffff },
  { 0x00000000, 0xffffffff, 0xffffff81, 0xaaaaaaaa },
  { 0x00000000, 0x0000001f, 0x0000007e, 0x00000002 },
  { 0x00000000, 0x00000000, 0x0000007e, 0xffffff80 },
  { 0x00000000, 0x00000000, 0x00007ffe, 0xaaaaaaaa },
  { 0x00000000, 0x0aaaaaaa, 0x55555555, 0xffff8003 },
  { 0x00000000, 0x00000000, 0x00000001, 0xffffff80 },
  { 0x00000000, 0x2aaaaaaa, 0x55555555, 0x80000001 },
  { 0x00000000, 0x00000000, 0x00000000, 0x0000007e },
  { 0x00000000, 0xaaaaaaaa, 0xaaaaaaaa, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffffff81, 0xcccccccc },
  { 0x00000000, 0xffffffff, 0xcccccccc, 0xfffffffd },
  { 0x00000000, 0xffffffff, 0xffff8000, 0x7ffffffd },
  { 0x00000000, 0xffffc000, 0xffff8000, 0x80000001 },
  { 0x00000000, 0xffffc001, 0xffff8003, 0xffff8001 },
  { 0x00000000, 0x00007ffd, 0x00007ffd, 0x80000000 },
  { 0x00000000, 0x00000000, 0x00007fff, 0xcccccccc },
  { 0x00000000, 0xffffffff, 0xffffff80, 0x00007ffe },
  { 0x00000000, 0x00000000, 0x7ffffffd, 0xaaaaaaaa },
  { 0x00000000, 0xffffffff, 0xffff8003, 0x0000007f },
  { 0x00000000, 0xffffffff, 0xfffffffe, 0xfffffffd },
  { 0x00000000, 0xffffffff, 0xfffffffe, 0x55555555 },
  { 0x00000000, 0xffffffff, 0xfffffffe, 0xfffffffe },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00007fff },
  { 0x00000000, 0x00000000, 0x0000007e, 0x00007ffd },
  { 0x00000000, 0xfffffff8, 0xffffffe0, 0x00000002 },
  { 0x00000000, 0x00000000, 0x00007ffd, 0xffffff81 },
  { 0x00000000, 0x00000000, 0x00000020, 0xfffffffd },
  { 0x00000000, 0x00000000, 0x0000007d, 0xffffff83 },
  { 0x00000000, 0x00000000, 0x55555555, 0x7ffffffe },
  { 0x00000000, 0x00001fff, 0x00007ffe, 0x00000002 },
  { 0x00000000, 0x00000000, 0x7fffffff, 0x00007ffd },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00000001 },
  { 0x00000000, 0x00000000, 0x33333333, 0xffffff83 },
  { 0x00000000, 0xffffffff, 0xcccccccc, 0x33333333 },
  { 0x00000000, 0xffffffc0, 0xffffff80, 0x00000001 },
  { 0x00000000, 0xffffffff, 0xcccccccc, 0x00007ffd },
  { 0x00000000, 0xffffffff, 0xfffffffd, 0x7ffffffe },
  { 0x00000000, 0x00000000, 0x7ffffffe, 0xffffff83 },
  { 0x00000000, 0x0000003f, 0x0000007f, 0xffff8001 },
  { 0x00000000, 0x00000000, 0x00007fff, 0xffffff80 },
  { 0x00000000, 0x00000000, 0x00007fff, 0x7ffffffe },
  { 0x00000000, 0x2aaaaaaa, 0x55555555, 0xffff8001 },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffff80 },
  { 0x00000000, 0x00001fff, 0x00007fff, 0x00000002 },
  { 0x00000000, 0x0aaaaaaa, 0x55555555, 0xffff8003 },
  { 0x00000000, 0xffffffff, 0xffff8003, 0x00000020 },
  { 0x00000000, 0xffffffff, 0xffff8002, 0x7fffffff },
  { 0x00000000, 0x55555555, 0x55555555, 0x00000000 },
  { 0x00000000, 0x00000000, 0x00007ffe, 0xffffff81 },
  { 0x00000000, 0xffffffff, 0x80000001, 0x00007ffe },
  { 0x00000000, 0xffffffff, 0xaaaaaaaa, 0x00000020 },
  { 0x00000000, 0xffffffff, 0xfffffffe, 0x00000002 },
  { 0x00000000, 0xffffe000, 0xffff8000, 0xffff8002 },
  { 0x00000000, 0x00000000, 0x00007fff, 0xaaaaaaaa },
  { 0x00000000, 0xffffffff, 0xffffff80, 0x00007ffd },
  { 0x00000000, 0xffffffff, 0x80000000, 0xffffff80 },
  { 0x00000000, 0x00000000, 0x55555555, 0xfffffffd },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00007ffd },
  { 0x00000000, 0xffffffff, 0xfffffffe, 0xffffff80 },
  { 0x00000000, 0xffffffe0, 0xffffff82, 0xffff8002 },
  { 0x00000000, 0x7ffffffe, 0x7ffffffe, 0xffff8000 },
  { 0x00000000, 0xffffffff, 0xffff8003, 0xffffff80 },
  { 0x00000000, 0x00000000, 0x00000020, 0xffffffe0 },
  { 0x00000000, 0xffffffff, 0xffff8001, 0xffffffe0 },
  { 0x00000000, 0xffffe000, 0xffff8000, 0xffff8002 },
  { 0x00000000, 0x00000000, 0x00000002, 0x7ffffffe },
  { 0x00000000, 0x00000000, 0x0000007f, 0xffffff81 },
  { 0x00000000, 0x00000000, 0x00000001, 0x7fffffff },
  { 0x00000000, 0x00000000, 0x00000000, 0x33333333 },
  { 0x00000000, 0xffffffff, 0xffffff83, 0xcccccccc },
  { 0x00000000, 0x00000000, 0x00000020, 0x00007ffd },
  { 0x00000000, 0xcccccccc, 0xcccccccc, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffff8000, 0x00007fff },
  { 0x00000000, 0xffffffff, 0xcccccccc, 0x00007ffe },
  { 0x00000000, 0xffffffff, 0xfffffffd, 0x7ffffffe },
  { 0x00000000, 0xffffffff, 0xaaaaaaaa, 0x55555555 },
  { 0x00000000, 0xffffffff, 0xaaaaaaaa, 0xffffff81 },
  { 0x00000000, 0xfffffffe, 0xfffffffe, 0xffff8000 },
  { 0x00000000, 0xffffffff, 0xffffffe0, 0xfffffffd },
  { 0x00000000, 0x00000000, 0x33333333, 0xfffffffd },
  { 0x00000000, 0xffffc001, 0xffff8002, 0x80000001 },
  { 0x00000000, 0xffffffff, 0xffffff83, 0xffffff83 },
  { 0x00000000, 0xffffffff, 0xffff8002, 0x00000020 },
  { 0x00000000, 0x00000000, 0x7fffffff, 0x0000007f },
  { 0x00000000, 0xcccccccc, 0xcccccccc, 0xffff8000 },
  { 0x00000000, 0x00000000, 0x7ffffffe, 0x00007fff },
  { 0x00000000, 0x00000000, 0x7ffffffd, 0x7ffffffd },
  { 0x00000000, 0xffffffff, 0xfffffffd, 0xffff8002 },
  { 0x00000000, 0x00000000, 0x00000002, 0x7fffffff },
  { 0x00000000, 0xffffffff, 0xfffffffe, 0x00000020 },
  { 0x00000000, 0x00000000, 0x0000007e, 0x00007ffe },
  { 0x00000000, 0x00000000, 0x00007ffd, 0xfffffffd },
  { 0x00000000, 0x0000001f, 0x0000007f, 0x00000002 },
  { 0x00000000, 0xffffffff, 0x80000000, 0x7ffffffd },
  { 0x00000000, 0x00003fff, 0x00007fff, 0x80000001 },
  { 0x00000000, 0xffffffff, 0x80000000, 0xaaaaaaaa },
  { 0x00000000, 0xd5555555, 0xaaaaaaaa, 0xffff8001 },
  { 0x00000000, 0xfffffffc, 0xffffffe0, 0xffff8003 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00007ffd },
  { 0x00000000, 0xffffffc0, 0xffffff81, 0x00000001 },
  { 0x00000000, 0xd5555555, 0xaaaaaaaa, 0x80000001 },
  { 0x00000000, 0xffff8000, 0xffff8000, 0xffff8000 },
  { 0x00000000, 0x00000000, 0x00007ffd, 0xaaaaaaaa },
  { 0x00000000, 0x7ffffffe, 0x7ffffffe, 0x80000000 },
  { 0x00000000, 0x00000000, 0x00007ffe, 0xffffff81 },
  { 0x00000000, 0x0000001f, 0x0000007d, 0xffff8002 },
  { 0x00000000, 0x00000000, 0x00000002, 0xffffff81 },
  { 0x00000000, 0xffffffff, 0xfffffffd, 0x7ffffffd },
  { 0x00000000, 0x00000000, 0x00000020, 0xffffff80 },
  { 0x00000000, 0x00000000, 0x7fffffff, 0xffffffe0 },
  { 0x00000000, 0xffffffff, 0xffff8002, 0x0000007f },
  { 0x00000000, 0x1fffffff, 0x7fffffff, 0xffff8002 },
  { 0x00000000, 0xffffffff, 0xfffffffd, 0x00000020 },
  { 0x00000000, 0xffffffff, 0xffffffe0, 0x0000007e },
  { 0x00000000, 0x00000000, 0x00000020, 0x7ffffffe },
  { 0x00000000, 0x0000007f, 0x0000007f, 0xffff8000 },
  { 0x00000000, 0xffffffff, 0x80000001, 0x0000007d },
  { 0x00000000, 0x00000000, 0x0000007f, 0x00007ffd },
  { 0x00000000, 0xffffffff, 0xffffffe0, 0xffffff82 },
  { 0x00000000, 0x0000001f, 0x0000007e, 0xffff8002 },
  { 0x00000000, 0x00000000, 0x55555555, 0x0000007f },
  { 0x00000000, 0x00000000, 0x7fffffff, 0x7ffffffe },
  { 0x00000000, 0xffffffff, 0xfffffffe, 0xffffff80 },
  { 0x00000000, 0xffffffff, 0xffff8002, 0x33333333 },
  { 0x00000000, 0xffffffff, 0xfffffffd, 0xaaaaaaaa },
  { 0x00000000, 0xffffffff, 0xfffffffd, 0x00000020 },
  { 0x00000000, 0x00000000, 0x00007ffe, 0x55555555 },
  { 0x00000000, 0x00000008, 0x00000020, 0x00000002 },
  { 0x00000000, 0xffffffff, 0xffff8002, 0xfffffffe },
  { 0x00000000, 0xe0000000, 0x80000001, 0xffff8002 },
  { 0x00000000, 0x00000000, 0x0000007e, 0x33333333 },
};
const Inputs kOutputs_Asr_RdIsNotRnIsNotRm_al_r9_r6_r1[] = {
  { 0x00000000, 0x00000000, 0x0000007e, 0x0000007d },
  { 0x00000000, 0x00000000, 0x00000002, 0xffff8002 },
  { 0x00000000, 0x80000001, 0x80000001, 0x00000000 },
  { 0x00000000, 0xffffffe0, 0xffffff83, 0x00000002 },
  { 0x00000000, 0xfffffff8, 0xffffffe0, 0x00000002 },
  { 0x00000000, 0xffffffff, 0x80000001, 0xffffff82 },
  { 0x00000000, 0x00000000, 0x00007fff, 0x0000007f },
  { 0x00000000, 0x00000000, 0x0000007d, 0x7ffffffe },
  { 0x00000000, 0x00000008, 0x00000020, 0xffff8002 },
  { 0x00000000, 0x2aaaaaaa, 0x55555555, 0x00000001 },
  { 0x00000000, 0x33333333, 0x33333333, 0x00000000 },
  { 0x00000000, 0x00000000, 0x7ffffffd, 0x55555555 },
  { 0x00000000, 0xffffffff, 0xffff8001, 0x7ffffffe },
  { 0x00000000, 0xfffffff0, 0xffffff83, 0xffff8003 },
  { 0x00000000, 0xffffffff, 0xffffffe0, 0xffffff81 },
  { 0x00000000, 0xffffffff, 0xffff8001, 0x0000007e },
  { 0x00000000, 0x00000000, 0x0000007e, 0x00000020 },
  { 0x00000000, 0xffffffff, 0xfffffffd, 0xaaaaaaaa },
  { 0x00000000, 0xffffffff, 0xffffff82, 0x7ffffffd },
  { 0x00000000, 0xffffffff, 0xcccccccc, 0x7fffffff },
  { 0x00000000, 0xffffffff, 0x80000001, 0xffffffff },
  { 0x00000000, 0x00000000, 0x00000020, 0x7ffffffe },
  { 0x00000000, 0xffffffff, 0xffffff81, 0xffffffe0 },
  { 0x00000000, 0xffffffff, 0xffffff81, 0xfffffffd },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffff8000, 0xcccccccc },
  { 0x00000000, 0x00000000, 0x00007ffe, 0xffffff82 },
  { 0x00000000, 0x0000000f, 0x0000007d, 0xffff8003 },
  { 0x00000000, 0xffffffff, 0xffffff81, 0x0000007e },
  { 0x00000000, 0x00000000, 0x7ffffffd, 0xfffffffe },
  { 0x00000000, 0xffffffff, 0x80000001, 0xffffff81 },
  { 0x00000000, 0x00000000, 0x00007ffd, 0xfffffffd },
  { 0x00000000, 0x0fffffff, 0x7fffffff, 0xffff8003 },
  { 0x00000000, 0x00000000, 0x0000007d, 0x33333333 },
  { 0x00000000, 0xffffffff, 0xffff8000, 0x00007ffe },
  { 0x00000000, 0xffffffff, 0xffff8000, 0x00000020 },
  { 0x00000000, 0x00000000, 0x00007fff, 0xffffffe0 },
  { 0x00000000, 0x00000000, 0x00000000, 0x00007ffe },
  { 0x00000000, 0x19999999, 0x33333333, 0x00000001 },
  { 0x00000000, 0xffffffff, 0xffffff80, 0x00000020 },
  { 0x00000000, 0xffffffff, 0xffffff83, 0x00007ffd },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x80000001 },
  { 0x00000000, 0xffffffff, 0xffffff81, 0xcccccccc },
  { 0x00000000, 0x0000003f, 0x0000007f, 0xffff8001 },
  { 0x00000000, 0x00000020, 0x00000020, 0x80000000 },
  { 0x00000000, 0x00000000, 0x00007fff, 0xffffff80 },
  { 0x00000000, 0x00000000, 0x7ffffffe, 0x7ffffffd },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00000001 },
  { 0x00000000, 0x00000000, 0x7ffffffd, 0xffffff83 },
  { 0x00000000, 0xffffffff, 0xffff8001, 0xffffffe0 },
  { 0x00000000, 0xffffffff, 0xffffff80, 0x00007ffd },
  { 0x00000000, 0x00000000, 0x00007fff, 0x00007ffe },
  { 0x00000000, 0x00000000, 0x00000000, 0xffff8000 },
  { 0x00000000, 0xffffffff, 0xaaaaaaaa, 0x7ffffffe },
  { 0x00000000, 0x00000000, 0x00007ffd, 0xffffffe0 },
  { 0x00000000, 0xffffffff, 0xffffffe0, 0xffffff83 },
  { 0x00000000, 0xffffffff, 0xffffffe0, 0x7ffffffd },
  { 0x00000000, 0xffff8002, 0xffff8002, 0x80000000 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x80000000 },
  { 0x00000000, 0xf0000000, 0x80000001, 0xffff8003 },
  { 0x00000000, 0xffffffff, 0xaaaaaaaa, 0xffffff81 },
  { 0x00000000, 0xffffffff, 0xfffffffd, 0xffffffe0 },
  { 0x00000000, 0xffffffff, 0xffffff80, 0x00007ffe },
  { 0x00000000, 0xffffffff, 0xffff8003, 0xffffffff },
  { 0x00000000, 0xffffff82, 0xffffff82, 0xffff8000 },
  { 0x00000000, 0x00000002, 0x00000002, 0x80000000 },
  { 0x00000000, 0xffffffff, 0xffffff82, 0xffffff81 },
  { 0x00000000, 0xffffffff, 0xcccccccc, 0x00007ffd },
  { 0x00000000, 0x00000000, 0x00007ffe, 0x7fffffff },
  { 0x00000000, 0xffffffff, 0xffffff81, 0xaaaaaaaa },
  { 0x00000000, 0x0000001f, 0x0000007e, 0x00000002 },
  { 0x00000000, 0x00000000, 0x0000007e, 0xffffff80 },
  { 0x00000000, 0x00000000, 0x00007ffe, 0xaaaaaaaa },
  { 0x00000000, 0x0aaaaaaa, 0x55555555, 0xffff8003 },
  { 0x00000000, 0x00000000, 0x00000001, 0xffffff80 },
  { 0x00000000, 0x2aaaaaaa, 0x55555555, 0x80000001 },
  { 0x00000000, 0x00000000, 0x00000000, 0x0000007e },
  { 0x00000000, 0xaaaaaaaa, 0xaaaaaaaa, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffffff81, 0xcccccccc },
  { 0x00000000, 0xffffffff, 0xcccccccc, 0xfffffffd },
  { 0x00000000, 0xffffffff, 0xffff8000, 0x7ffffffd },
  { 0x00000000, 0xffffc000, 0xffff8000, 0x80000001 },
  { 0x00000000, 0xffffc001, 0xffff8003, 0xffff8001 },
  { 0x00000000, 0x00007ffd, 0x00007ffd, 0x80000000 },
  { 0x00000000, 0x00000000, 0x00007fff, 0xcccccccc },
  { 0x00000000, 0xffffffff, 0xffffff80, 0x00007ffe },
  { 0x00000000, 0x00000000, 0x7ffffffd, 0xaaaaaaaa },
  { 0x00000000, 0xffffffff, 0xffff8003, 0x0000007f },
  { 0x00000000, 0xffffffff, 0xfffffffe, 0xfffffffd },
  { 0x00000000, 0xffffffff, 0xfffffffe, 0x55555555 },
  { 0x00000000, 0xffffffff, 0xfffffffe, 0xfffffffe },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00007fff },
  { 0x00000000, 0x00000000, 0x0000007e, 0x00007ffd },
  { 0x00000000, 0xfffffff8, 0xffffffe0, 0x00000002 },
  { 0x00000000, 0x00000000, 0x00007ffd, 0xffffff81 },
  { 0x00000000, 0x00000000, 0x00000020, 0xfffffffd },
  { 0x00000000, 0x00000000, 0x0000007d, 0xffffff83 },
  { 0x00000000, 0x00000000, 0x55555555, 0x7ffffffe },
  { 0x00000000, 0x00001fff, 0x00007ffe, 0x00000002 },
  { 0x00000000, 0x00000000, 0x7fffffff, 0x00007ffd },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00000001 },
  { 0x00000000, 0x00000000, 0x33333333, 0xffffff83 },
  { 0x00000000, 0xffffffff, 0xcccccccc, 0x33333333 },
  { 0x00000000, 0xffffffc0, 0xffffff80, 0x00000001 },
  { 0x00000000, 0xffffffff, 0xcccccccc, 0x00007ffd },
  { 0x00000000, 0xffffffff, 0xfffffffd, 0x7ffffffe },
  { 0x00000000, 0x00000000, 0x7ffffffe, 0xffffff83 },
  { 0x00000000, 0x0000003f, 0x0000007f, 0xffff8001 },
  { 0x00000000, 0x00000000, 0x00007fff, 0xffffff80 },
  { 0x00000000, 0x00000000, 0x00007fff, 0x7ffffffe },
  { 0x00000000, 0x2aaaaaaa, 0x55555555, 0xffff8001 },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffff80 },
  { 0x00000000, 0x00001fff, 0x00007fff, 0x00000002 },
  { 0x00000000, 0x0aaaaaaa, 0x55555555, 0xffff8003 },
  { 0x00000000, 0xffffffff, 0xffff8003, 0x00000020 },
  { 0x00000000, 0xffffffff, 0xffff8002, 0x7fffffff },
  { 0x00000000, 0x55555555, 0x55555555, 0x00000000 },
  { 0x00000000, 0x00000000, 0x00007ffe, 0xffffff81 },
  { 0x00000000, 0xffffffff, 0x80000001, 0x00007ffe },
  { 0x00000000, 0xffffffff, 0xaaaaaaaa, 0x00000020 },
  { 0x00000000, 0xffffffff, 0xfffffffe, 0x00000002 },
  { 0x00000000, 0xffffe000, 0xffff8000, 0xffff8002 },
  { 0x00000000, 0x00000000, 0x00007fff, 0xaaaaaaaa },
  { 0x00000000, 0xffffffff, 0xffffff80, 0x00007ffd },
  { 0x00000000, 0xffffffff, 0x80000000, 0xffffff80 },
  { 0x00000000, 0x00000000, 0x55555555, 0xfffffffd },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00007ffd },
  { 0x00000000, 0xffffffff, 0xfffffffe, 0xffffff80 },
  { 0x00000000, 0xffffffe0, 0xffffff82, 0xffff8002 },
  { 0x00000000, 0x7ffffffe, 0x7ffffffe, 0xffff8000 },
  { 0x00000000, 0xffffffff, 0xffff8003, 0xffffff80 },
  { 0x00000000, 0x00000000, 0x00000020, 0xffffffe0 },
  { 0x00000000, 0xffffffff, 0xffff8001, 0xffffffe0 },
  { 0x00000000, 0xffffe000, 0xffff8000, 0xffff8002 },
  { 0x00000000, 0x00000000, 0x00000002, 0x7ffffffe },
  { 0x00000000, 0x00000000, 0x0000007f, 0xffffff81 },
  { 0x00000000, 0x00000000, 0x00000001, 0x7fffffff },
  { 0x00000000, 0x00000000, 0x00000000, 0x33333333 },
  { 0x00000000, 0xffffffff, 0xffffff83, 0xcccccccc },
  { 0x00000000, 0x00000000, 0x00000020, 0x00007ffd },
  { 0x00000000, 0xcccccccc, 0xcccccccc, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffff8000, 0x00007fff },
  { 0x00000000, 0xffffffff, 0xcccccccc, 0x00007ffe },
  { 0x00000000, 0xffffffff, 0xfffffffd, 0x7ffffffe },
  { 0x00000000, 0xffffffff, 0xaaaaaaaa, 0x55555555 },
  { 0x00000000, 0xffffffff, 0xaaaaaaaa, 0xffffff81 },
  { 0x00000000, 0xfffffffe, 0xfffffffe, 0xffff8000 },
  { 0x00000000, 0xffffffff, 0xffffffe0, 0xfffffffd },
  { 0x00000000, 0x00000000, 0x33333333, 0xfffffffd },
  { 0x00000000, 0xffffc001, 0xffff8002, 0x80000001 },
  { 0x00000000, 0xffffffff, 0xffffff83, 0xffffff83 },
  { 0x00000000, 0xffffffff, 0xffff8002, 0x00000020 },
  { 0x00000000, 0x00000000, 0x7fffffff, 0x0000007f },
  { 0x00000000, 0xcccccccc, 0xcccccccc, 0xffff8000 },
  { 0x00000000, 0x00000000, 0x7ffffffe, 0x00007fff },
  { 0x00000000, 0x00000000, 0x7ffffffd, 0x7ffffffd },
  { 0x00000000, 0xffffffff, 0xfffffffd, 0xffff8002 },
  { 0x00000000, 0x00000000, 0x00000002, 0x7fffffff },
  { 0x00000000, 0xffffffff, 0xfffffffe, 0x00000020 },
  { 0x00000000, 0x00000000, 0x0000007e, 0x00007ffe },
  { 0x00000000, 0x00000000, 0x00007ffd, 0xfffffffd },
  { 0x00000000, 0x0000001f, 0x0000007f, 0x00000002 },
  { 0x00000000, 0xffffffff, 0x80000000, 0x7ffffffd },
  { 0x00000000, 0x00003fff, 0x00007fff, 0x80000001 },
  { 0x00000000, 0xffffffff, 0x80000000, 0xaaaaaaaa },
  { 0x00000000, 0xd5555555, 0xaaaaaaaa, 0xffff8001 },
  { 0x00000000, 0xfffffffc, 0xffffffe0, 0xffff8003 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00007ffd },
  { 0x00000000, 0xffffffc0, 0xffffff81, 0x00000001 },
  { 0x00000000, 0xd5555555, 0xaaaaaaaa, 0x80000001 },
  { 0x00000000, 0xffff8000, 0xffff8000, 0xffff8000 },
  { 0x00000000, 0x00000000, 0x00007ffd, 0xaaaaaaaa },
  { 0x00000000, 0x7ffffffe, 0x7ffffffe, 0x80000000 },
  { 0x00000000, 0x00000000, 0x00007ffe, 0xffffff81 },
  { 0x00000000, 0x0000001f, 0x0000007d, 0xffff8002 },
  { 0x00000000, 0x00000000, 0x00000002, 0xffffff81 },
  { 0x00000000, 0xffffffff, 0xfffffffd, 0x7ffffffd },
  { 0x00000000, 0x00000000, 0x00000020, 0xffffff80 },
  { 0x00000000, 0x00000000, 0x7fffffff, 0xffffffe0 },
  { 0x00000000, 0xffffffff, 0xffff8002, 0x0000007f },
  { 0x00000000, 0x1fffffff, 0x7fffffff, 0xffff8002 },
  { 0x00000000, 0xffffffff, 0xfffffffd, 0x00000020 },
  { 0x00000000, 0xffffffff, 0xffffffe0, 0x0000007e },
  { 0x00000000, 0x00000000, 0x00000020, 0x7ffffffe },
  { 0x00000000, 0x0000007f, 0x0000007f, 0xffff8000 },
  { 0x00000000, 0xffffffff, 0x80000001, 0x0000007d },
  { 0x00000000, 0x00000000, 0x0000007f, 0x00007ffd },
  { 0x00000000, 0xffffffff, 0xffffffe0, 0xffffff82 },
  { 0x00000000, 0x0000001f, 0x0000007e, 0xffff8002 },
  { 0x00000000, 0x00000000, 0x55555555, 0x0000007f },
  { 0x00000000, 0x00000000, 0x7fffffff, 0x7ffffffe },
  { 0x00000000, 0xffffffff, 0xfffffffe, 0xffffff80 },
  { 0x00000000, 0xffffffff, 0xffff8002, 0x33333333 },
  { 0x00000000, 0xffffffff, 0xfffffffd, 0xaaaaaaaa },
  { 0x00000000, 0xffffffff, 0xfffffffd, 0x00000020 },
  { 0x00000000, 0x00000000, 0x00007ffe, 0x55555555 },
  { 0x00000000, 0x00000008, 0x00000020, 0x00000002 },
  { 0x00000000, 0xffffffff, 0xffff8002, 0xfffffffe },
  { 0x00000000, 0xe0000000, 0x80000001, 0xffff8002 },
  { 0x00000000, 0x00000000, 0x0000007e, 0x33333333 },
};
const Inputs kOutputs_Asr_RdIsNotRnIsNotRm_al_r10_r14_r3[] = {
  { 0x00000000, 0x00000000, 0x0000007e, 0x0000007d },
  { 0x00000000, 0x00000000, 0x00000002, 0xffff8002 },
  { 0x00000000, 0x80000001, 0x80000001, 0x00000000 },
  { 0x00000000, 0xffffffe0, 0xffffff83, 0x00000002 },
  { 0x00000000, 0xfffffff8, 0xffffffe0, 0x00000002 },
  { 0x00000000, 0xffffffff, 0x80000001, 0xffffff82 },
  { 0x00000000, 0x00000000, 0x00007fff, 0x0000007f },
  { 0x00000000, 0x00000000, 0x0000007d, 0x7ffffffe },
  { 0x00000000, 0x00000008, 0x00000020, 0xffff8002 },
  { 0x00000000, 0x2aaaaaaa, 0x55555555, 0x00000001 },
  { 0x00000000, 0x33333333, 0x33333333, 0x00000000 },
  { 0x00000000, 0x00000000, 0x7ffffffd, 0x55555555 },
  { 0x00000000, 0xffffffff, 0xffff8001, 0x7ffffffe },
  { 0x00000000, 0xfffffff0, 0xffffff83, 0xffff8003 },
  { 0x00000000, 0xffffffff, 0xffffffe0, 0xffffff81 },
  { 0x00000000, 0xffffffff, 0xffff8001, 0x0000007e },
  { 0x00000000, 0x00000000, 0x0000007e, 0x00000020 },
  { 0x00000000, 0xffffffff, 0xfffffffd, 0xaaaaaaaa },
  { 0x00000000, 0xffffffff, 0xffffff82, 0x7ffffffd },
  { 0x00000000, 0xffffffff, 0xcccccccc, 0x7fffffff },
  { 0x00000000, 0xffffffff, 0x80000001, 0xffffffff },
  { 0x00000000, 0x00000000, 0x00000020, 0x7ffffffe },
  { 0x00000000, 0xffffffff, 0xffffff81, 0xffffffe0 },
  { 0x00000000, 0xffffffff, 0xffffff81, 0xfffffffd },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffff8000, 0xcccccccc },
  { 0x00000000, 0x00000000, 0x00007ffe, 0xffffff82 },
  { 0x00000000, 0x0000000f, 0x0000007d, 0xffff8003 },
  { 0x00000000, 0xffffffff, 0xffffff81, 0x0000007e },
  { 0x00000000, 0x00000000, 0x7ffffffd, 0xfffffffe },
  { 0x00000000, 0xffffffff, 0x80000001, 0xffffff81 },
  { 0x00000000, 0x00000000, 0x00007ffd, 0xfffffffd },
  { 0x00000000, 0x0fffffff, 0x7fffffff, 0xffff8003 },
  { 0x00000000, 0x00000000, 0x0000007d, 0x33333333 },
  { 0x00000000, 0xffffffff, 0xffff8000, 0x00007ffe },
  { 0x00000000, 0xffffffff, 0xffff8000, 0x00000020 },
  { 0x00000000, 0x00000000, 0x00007fff, 0xffffffe0 },
  { 0x00000000, 0x00000000, 0x00000000, 0x00007ffe },
  { 0x00000000, 0x19999999, 0x33333333, 0x00000001 },
  { 0x00000000, 0xffffffff, 0xffffff80, 0x00000020 },
  { 0x00000000, 0xffffffff, 0xffffff83, 0x00007ffd },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x80000001 },
  { 0x00000000, 0xffffffff, 0xffffff81, 0xcccccccc },
  { 0x00000000, 0x0000003f, 0x0000007f, 0xffff8001 },
  { 0x00000000, 0x00000020, 0x00000020, 0x80000000 },
  { 0x00000000, 0x00000000, 0x00007fff, 0xffffff80 },
  { 0x00000000, 0x00000000, 0x7ffffffe, 0x7ffffffd },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00000001 },
  { 0x00000000, 0x00000000, 0x7ffffffd, 0xffffff83 },
  { 0x00000000, 0xffffffff, 0xffff8001, 0xffffffe0 },
  { 0x00000000, 0xffffffff, 0xffffff80, 0x00007ffd },
  { 0x00000000, 0x00000000, 0x00007fff, 0x00007ffe },
  { 0x00000000, 0x00000000, 0x00000000, 0xffff8000 },
  { 0x00000000, 0xffffffff, 0xaaaaaaaa, 0x7ffffffe },
  { 0x00000000, 0x00000000, 0x00007ffd, 0xffffffe0 },
  { 0x00000000, 0xffffffff, 0xffffffe0, 0xffffff83 },
  { 0x00000000, 0xffffffff, 0xffffffe0, 0x7ffffffd },
  { 0x00000000, 0xffff8002, 0xffff8002, 0x80000000 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x80000000 },
  { 0x00000000, 0xf0000000, 0x80000001, 0xffff8003 },
  { 0x00000000, 0xffffffff, 0xaaaaaaaa, 0xffffff81 },
  { 0x00000000, 0xffffffff, 0xfffffffd, 0xffffffe0 },
  { 0x00000000, 0xffffffff, 0xffffff80, 0x00007ffe },
  { 0x00000000, 0xffffffff, 0xffff8003, 0xffffffff },
  { 0x00000000, 0xffffff82, 0xffffff82, 0xffff8000 },
  { 0x00000000, 0x00000002, 0x00000002, 0x80000000 },
  { 0x00000000, 0xffffffff, 0xffffff82, 0xffffff81 },
  { 0x00000000, 0xffffffff, 0xcccccccc, 0x00007ffd },
  { 0x00000000, 0x00000000, 0x00007ffe, 0x7fffffff },
  { 0x00000000, 0xffffffff, 0xffffff81, 0xaaaaaaaa },
  { 0x00000000, 0x0000001f, 0x0000007e, 0x00000002 },
  { 0x00000000, 0x00000000, 0x0000007e, 0xffffff80 },
  { 0x00000000, 0x00000000, 0x00007ffe, 0xaaaaaaaa },
  { 0x00000000, 0x0aaaaaaa, 0x55555555, 0xffff8003 },
  { 0x00000000, 0x00000000, 0x00000001, 0xffffff80 },
  { 0x00000000, 0x2aaaaaaa, 0x55555555, 0x80000001 },
  { 0x00000000, 0x00000000, 0x00000000, 0x0000007e },
  { 0x00000000, 0xaaaaaaaa, 0xaaaaaaaa, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffffff81, 0xcccccccc },
  { 0x00000000, 0xffffffff, 0xcccccccc, 0xfffffffd },
  { 0x00000000, 0xffffffff, 0xffff8000, 0x7ffffffd },
  { 0x00000000, 0xffffc000, 0xffff8000, 0x80000001 },
  { 0x00000000, 0xffffc001, 0xffff8003, 0xffff8001 },
  { 0x00000000, 0x00007ffd, 0x00007ffd, 0x80000000 },
  { 0x00000000, 0x00000000, 0x00007fff, 0xcccccccc },
  { 0x00000000, 0xffffffff, 0xffffff80, 0x00007ffe },
  { 0x00000000, 0x00000000, 0x7ffffffd, 0xaaaaaaaa },
  { 0x00000000, 0xffffffff, 0xffff8003, 0x0000007f },
  { 0x00000000, 0xffffffff, 0xfffffffe, 0xfffffffd },
  { 0x00000000, 0xffffffff, 0xfffffffe, 0x55555555 },
  { 0x00000000, 0xffffffff, 0xfffffffe, 0xfffffffe },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00007fff },
  { 0x00000000, 0x00000000, 0x0000007e, 0x00007ffd },
  { 0x00000000, 0xfffffff8, 0xffffffe0, 0x00000002 },
  { 0x00000000, 0x00000000, 0x00007ffd, 0xffffff81 },
  { 0x00000000, 0x00000000, 0x00000020, 0xfffffffd },
  { 0x00000000, 0x00000000, 0x0000007d, 0xffffff83 },
  { 0x00000000, 0x00000000, 0x55555555, 0x7ffffffe },
  { 0x00000000, 0x00001fff, 0x00007ffe, 0x00000002 },
  { 0x00000000, 0x00000000, 0x7fffffff, 0x00007ffd },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00000001 },
  { 0x00000000, 0x00000000, 0x33333333, 0xffffff83 },
  { 0x00000000, 0xffffffff, 0xcccccccc, 0x33333333 },
  { 0x00000000, 0xffffffc0, 0xffffff80, 0x00000001 },
  { 0x00000000, 0xffffffff, 0xcccccccc, 0x00007ffd },
  { 0x00000000, 0xffffffff, 0xfffffffd, 0x7ffffffe },
  { 0x00000000, 0x00000000, 0x7ffffffe, 0xffffff83 },
  { 0x00000000, 0x0000003f, 0x0000007f, 0xffff8001 },
  { 0x00000000, 0x00000000, 0x00007fff, 0xffffff80 },
  { 0x00000000, 0x00000000, 0x00007fff, 0x7ffffffe },
  { 0x00000000, 0x2aaaaaaa, 0x55555555, 0xffff8001 },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffff80 },
  { 0x00000000, 0x00001fff, 0x00007fff, 0x00000002 },
  { 0x00000000, 0x0aaaaaaa, 0x55555555, 0xffff8003 },
  { 0x00000000, 0xffffffff, 0xffff8003, 0x00000020 },
  { 0x00000000, 0xffffffff, 0xffff8002, 0x7fffffff },
  { 0x00000000, 0x55555555, 0x55555555, 0x00000000 },
  { 0x00000000, 0x00000000, 0x00007ffe, 0xffffff81 },
  { 0x00000000, 0xffffffff, 0x80000001, 0x00007ffe },
  { 0x00000000, 0xffffffff, 0xaaaaaaaa, 0x00000020 },
  { 0x00000000, 0xffffffff, 0xfffffffe, 0x00000002 },
  { 0x00000000, 0xffffe000, 0xffff8000, 0xffff8002 },
  { 0x00000000, 0x00000000, 0x00007fff, 0xaaaaaaaa },
  { 0x00000000, 0xffffffff, 0xffffff80, 0x00007ffd },
  { 0x00000000, 0xffffffff, 0x80000000, 0xffffff80 },
  { 0x00000000, 0x00000000, 0x55555555, 0xfffffffd },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00007ffd },
  { 0x00000000, 0xffffffff, 0xfffffffe, 0xffffff80 },
  { 0x00000000, 0xffffffe0, 0xffffff82, 0xffff8002 },
  { 0x00000000, 0x7ffffffe, 0x7ffffffe, 0xffff8000 },
  { 0x00000000, 0xffffffff, 0xffff8003, 0xffffff80 },
  { 0x00000000, 0x00000000, 0x00000020, 0xffffffe0 },
  { 0x00000000, 0xffffffff, 0xffff8001, 0xffffffe0 },
  { 0x00000000, 0xffffe000, 0xffff8000, 0xffff8002 },
  { 0x00000000, 0x00000000, 0x00000002, 0x7ffffffe },
  { 0x00000000, 0x00000000, 0x0000007f, 0xffffff81 },
  { 0x00000000, 0x00000000, 0x00000001, 0x7fffffff },
  { 0x00000000, 0x00000000, 0x00000000, 0x33333333 },
  { 0x00000000, 0xffffffff, 0xffffff83, 0xcccccccc },
  { 0x00000000, 0x00000000, 0x00000020, 0x00007ffd },
  { 0x00000000, 0xcccccccc, 0xcccccccc, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffff8000, 0x00007fff },
  { 0x00000000, 0xffffffff, 0xcccccccc, 0x00007ffe },
  { 0x00000000, 0xffffffff, 0xfffffffd, 0x7ffffffe },
  { 0x00000000, 0xffffffff, 0xaaaaaaaa, 0x55555555 },
  { 0x00000000, 0xffffffff, 0xaaaaaaaa, 0xffffff81 },
  { 0x00000000, 0xfffffffe, 0xfffffffe, 0xffff8000 },
  { 0x00000000, 0xffffffff, 0xffffffe0, 0xfffffffd },
  { 0x00000000, 0x00000000, 0x33333333, 0xfffffffd },
  { 0x00000000, 0xffffc001, 0xffff8002, 0x80000001 },
  { 0x00000000, 0xffffffff, 0xffffff83, 0xffffff83 },
  { 0x00000000, 0xffffffff, 0xffff8002, 0x00000020 },
  { 0x00000000, 0x00000000, 0x7fffffff, 0x0000007f },
  { 0x00000000, 0xcccccccc, 0xcccccccc, 0xffff8000 },
  { 0x00000000, 0x00000000, 0x7ffffffe, 0x00007fff },
  { 0x00000000, 0x00000000, 0x7ffffffd, 0x7ffffffd },
  { 0x00000000, 0xffffffff, 0xfffffffd, 0xffff8002 },
  { 0x00000000, 0x00000000, 0x00000002, 0x7fffffff },
  { 0x00000000, 0xffffffff, 0xfffffffe, 0x00000020 },
  { 0x00000000, 0x00000000, 0x0000007e, 0x00007ffe },
  { 0x00000000, 0x00000000, 0x00007ffd, 0xfffffffd },
  { 0x00000000, 0x0000001f, 0x0000007f, 0x00000002 },
  { 0x00000000, 0xffffffff, 0x80000000, 0x7ffffffd },
  { 0x00000000, 0x00003fff, 0x00007fff, 0x80000001 },
  { 0x00000000, 0xffffffff, 0x80000000, 0xaaaaaaaa },
  { 0x00000000, 0xd5555555, 0xaaaaaaaa, 0xffff8001 },
  { 0x00000000, 0xfffffffc, 0xffffffe0, 0xffff8003 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00007ffd },
  { 0x00000000, 0xffffffc0, 0xffffff81, 0x00000001 },
  { 0x00000000, 0xd5555555, 0xaaaaaaaa, 0x80000001 },
  { 0x00000000, 0xffff8000, 0xffff8000, 0xffff8000 },
  { 0x00000000, 0x00000000, 0x00007ffd, 0xaaaaaaaa },
  { 0x00000000, 0x7ffffffe, 0x7ffffffe, 0x80000000 },
  { 0x00000000, 0x00000000, 0x00007ffe, 0xffffff81 },
  { 0x00000000, 0x0000001f, 0x0000007d, 0xffff8002 },
  { 0x00000000, 0x00000000, 0x00000002, 0xffffff81 },
  { 0x00000000, 0xffffffff, 0xfffffffd, 0x7ffffffd },
  { 0x00000000, 0x00000000, 0x00000020, 0xffffff80 },
  { 0x00000000, 0x00000000, 0x7fffffff, 0xffffffe0 },
  { 0x00000000, 0xffffffff, 0xffff8002, 0x0000007f },
  { 0x00000000, 0x1fffffff, 0x7fffffff, 0xffff8002 },
  { 0x00000000, 0xffffffff, 0xfffffffd, 0x00000020 },
  { 0x00000000, 0xffffffff, 0xffffffe0, 0x0000007e },
  { 0x00000000, 0x00000000, 0x00000020, 0x7ffffffe },
  { 0x00000000, 0x0000007f, 0x0000007f, 0xffff8000 },
  { 0x00000000, 0xffffffff, 0x80000001, 0x0000007d },
  { 0x00000000, 0x00000000, 0x0000007f, 0x00007ffd },
  { 0x00000000, 0xffffffff, 0xffffffe0, 0xffffff82 },
  { 0x00000000, 0x0000001f, 0x0000007e, 0xffff8002 },
  { 0x00000000, 0x00000000, 0x55555555, 0x0000007f },
  { 0x00000000, 0x00000000, 0x7fffffff, 0x7ffffffe },
  { 0x00000000, 0xffffffff, 0xfffffffe, 0xffffff80 },
  { 0x00000000, 0xffffffff, 0xffff8002, 0x33333333 },
  { 0x00000000, 0xffffffff, 0xfffffffd, 0xaaaaaaaa },
  { 0x00000000, 0xffffffff, 0xfffffffd, 0x00000020 },
  { 0x00000000, 0x00000000, 0x00007ffe, 0x55555555 },
  { 0x00000000, 0x00000008, 0x00000020, 0x00000002 },
  { 0x00000000, 0xffffffff, 0xffff8002, 0xfffffffe },
  { 0x00000000, 0xe0000000, 0x80000001, 0xffff8002 },
  { 0x00000000, 0x00000000, 0x0000007e, 0x33333333 },
};
const Inputs kOutputs_Asr_RdIsNotRnIsNotRm_al_r14_r3_r6[] = {
  { 0x00000000, 0x00000000, 0x0000007e, 0x0000007d },
  { 0x00000000, 0x00000000, 0x00000002, 0xffff8002 },
  { 0x00000000, 0x80000001, 0x80000001, 0x00000000 },
  { 0x00000000, 0xffffffe0, 0xffffff83, 0x00000002 },
  { 0x00000000, 0xfffffff8, 0xffffffe0, 0x00000002 },
  { 0x00000000, 0xffffffff, 0x80000001, 0xffffff82 },
  { 0x00000000, 0x00000000, 0x00007fff, 0x0000007f },
  { 0x00000000, 0x00000000, 0x0000007d, 0x7ffffffe },
  { 0x00000000, 0x00000008, 0x00000020, 0xffff8002 },
  { 0x00000000, 0x2aaaaaaa, 0x55555555, 0x00000001 },
  { 0x00000000, 0x33333333, 0x33333333, 0x00000000 },
  { 0x00000000, 0x00000000, 0x7ffffffd, 0x55555555 },
  { 0x00000000, 0xffffffff, 0xffff8001, 0x7ffffffe },
  { 0x00000000, 0xfffffff0, 0xffffff83, 0xffff8003 },
  { 0x00000000, 0xffffffff, 0xffffffe0, 0xffffff81 },
  { 0x00000000, 0xffffffff, 0xffff8001, 0x0000007e },
  { 0x00000000, 0x00000000, 0x0000007e, 0x00000020 },
  { 0x00000000, 0xffffffff, 0xfffffffd, 0xaaaaaaaa },
  { 0x00000000, 0xffffffff, 0xffffff82, 0x7ffffffd },
  { 0x00000000, 0xffffffff, 0xcccccccc, 0x7fffffff },
  { 0x00000000, 0xffffffff, 0x80000001, 0xffffffff },
  { 0x00000000, 0x00000000, 0x00000020, 0x7ffffffe },
  { 0x00000000, 0xffffffff, 0xffffff81, 0xffffffe0 },
  { 0x00000000, 0xffffffff, 0xffffff81, 0xfffffffd },
  { 0x00000000, 0xffffffff, 0xffffffff, 0xffffffff },
  { 0x00000000, 0xffffffff, 0xffff8000, 0xcccccccc },
  { 0x00000000, 0x00000000, 0x00007ffe, 0xffffff82 },
  { 0x00000000, 0x0000000f, 0x0000007d, 0xffff8003 },
  { 0x00000000, 0xffffffff, 0xffffff81, 0x0000007e },
  { 0x00000000, 0x00000000, 0x7ffffffd, 0xfffffffe },
  { 0x00000000, 0xffffffff, 0x80000001, 0xffffff81 },
  { 0x00000000, 0x00000000, 0x00007ffd, 0xfffffffd },
  { 0x00000000, 0x0fffffff, 0x7fffffff, 0xffff8003 },
  { 0x00000000, 0x00000000, 0x0000007d, 0x33333333 },
  { 0x00000000, 0xffffffff, 0xffff8000, 0x00007ffe },
  { 0x00000000, 0xffffffff, 0xffff8000, 0x00000020 },
  { 0x00000000, 0x00000000, 0x00007fff, 0xffffffe0 },
  { 0x00000000, 0x00000000, 0x00000000, 0x00007ffe },
  { 0x00000000, 0x19999999, 0x33333333, 0x00000001 },
  { 0x00000000, 0xffffffff, 0xffffff80, 0x00000020 },
  { 0x00000000, 0xffffffff, 0xffffff83, 0x00007ffd },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x80000001 },
  { 0x00000000, 0xffffffff, 0xffffff81, 0xcccccccc },
  { 0x00000000, 0x0000003f, 0x0000007f, 0xffff8001 },
  { 0x00000000, 0x00000020, 0x00000020, 0x80000000 },
  { 0x00000000, 0x00000000, 0x00007fff, 0xffffff80 },
  { 0x00000000, 0x00000000, 0x7ffffffe, 0x7ffffffd },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00000001 },
  { 0x00000000, 0x00000000, 0x7ffffffd, 0xffffff83 },
  { 0x00000000, 0xffffffff, 0xffff8001, 0xffffffe0 },
  { 0x00000000, 0xffffffff, 0xffffff80, 0x00007ffd },
  { 0x00000000, 0x00000000, 0x00007fff, 0x00007ffe },
  { 0x00000000, 0x00000000, 0x00000000, 0xffff8000 },
  { 0x00000000, 0xffffffff, 0xaaaaaaaa, 0x7ffffffe },
  { 0x00000000, 0x00000000, 0x00007ffd, 0xffffffe0 },
  { 0x00000000, 0xffffffff, 0xffffffe0, 0xffffff83 },
  { 0x00000000, 0xffffffff, 0xffffffe0, 0x7ffffffd },
  { 0x00000000, 0xffff8002, 0xffff8002, 0x80000000 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x80000000 },
  { 0x00000000, 0xf0000000, 0x80000001, 0xffff8003 },
  { 0x00000000, 0xffffffff, 0xaaaaaaaa, 0xffffff81 },
  { 0x00000000, 0xffffffff, 0xfffffffd, 0xffffffe0 },
  { 0x00000000, 0xffffffff, 0xffffff80, 0x00007ffe },
  { 0x00000000, 0xffffffff, 0xffff8003, 0xffffffff },
  { 0x00000000, 0xffffff82, 0xffffff82, 0xffff8000 },
  { 0x00000000, 0x00000002, 0x00000002, 0x80000000 },
  { 0x00000000, 0xffffffff, 0xffffff82, 0xffffff81 },
  { 0x00000000, 0xffffffff, 0xcccccccc, 0x00007ffd },
  { 0x00000000, 0x00000000, 0x00007ffe, 0x7fffffff },
  { 0x00000000, 0xffffffff, 0xffffff81, 0xaaaaaaaa },
  { 0x00000000, 0x0000001f, 0x0000007e, 0x00000002 },
  { 0x00000000, 0x00000000, 0x0000007e, 0xffffff80 },
  { 0x00000000, 0x00000000, 0x00007ffe, 0xaaaaaaaa },
  { 0x00000000, 0x0aaaaaaa, 0x55555555, 0xffff8003 },
  { 0x00000000, 0x00000000, 0x00000001, 0xffffff80 },
  { 0x00000000, 0x2aaaaaaa, 0x55555555, 0x80000001 },
  { 0x00000000, 0x00000000, 0x00000000, 0x0000007e },
  { 0x00000000, 0xaaaaaaaa, 0xaaaaaaaa, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffffff81, 0xcccccccc },
  { 0x00000000, 0xffffffff, 0xcccccccc, 0xfffffffd },
  { 0x00000000, 0xffffffff, 0xffff8000, 0x7ffffffd },
  { 0x00000000, 0xffffc000, 0xffff8000, 0x80000001 },
  { 0x00000000, 0xffffc001, 0xffff8003, 0xffff8001 },
  { 0x00000000, 0x00007ffd, 0x00007ffd, 0x80000000 },
  { 0x00000000, 0x00000000, 0x00007fff, 0xcccccccc },
  { 0x00000000, 0xffffffff, 0xffffff80, 0x00007ffe },
  { 0x00000000, 0x00000000, 0x7ffffffd, 0xaaaaaaaa },
  { 0x00000000, 0xffffffff, 0xffff8003, 0x0000007f },
  { 0x00000000, 0xffffffff, 0xfffffffe, 0xfffffffd },
  { 0x00000000, 0xffffffff, 0xfffffffe, 0x55555555 },
  { 0x00000000, 0xffffffff, 0xfffffffe, 0xfffffffe },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00007fff },
  { 0x00000000, 0x00000000, 0x0000007e, 0x00007ffd },
  { 0x00000000, 0xfffffff8, 0xffffffe0, 0x00000002 },
  { 0x00000000, 0x00000000, 0x00007ffd, 0xffffff81 },
  { 0x00000000, 0x00000000, 0x00000020, 0xfffffffd },
  { 0x00000000, 0x00000000, 0x0000007d, 0xffffff83 },
  { 0x00000000, 0x00000000, 0x55555555, 0x7ffffffe },
  { 0x00000000, 0x00001fff, 0x00007ffe, 0x00000002 },
  { 0x00000000, 0x00000000, 0x7fffffff, 0x00007ffd },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00000001 },
  { 0x00000000, 0x00000000, 0x33333333, 0xffffff83 },
  { 0x00000000, 0xffffffff, 0xcccccccc, 0x33333333 },
  { 0x00000000, 0xffffffc0, 0xffffff80, 0x00000001 },
  { 0x00000000, 0xffffffff, 0xcccccccc, 0x00007ffd },
  { 0x00000000, 0xffffffff, 0xfffffffd, 0x7ffffffe },
  { 0x00000000, 0x00000000, 0x7ffffffe, 0xffffff83 },
  { 0x00000000, 0x0000003f, 0x0000007f, 0xffff8001 },
  { 0x00000000, 0x00000000, 0x00007fff, 0xffffff80 },
  { 0x00000000, 0x00000000, 0x00007fff, 0x7ffffffe },
  { 0x00000000, 0x2aaaaaaa, 0x55555555, 0xffff8001 },
  { 0x00000000, 0x00000000, 0x00000000, 0xffffff80 },
  { 0x00000000, 0x00001fff, 0x00007fff, 0x00000002 },
  { 0x00000000, 0x0aaaaaaa, 0x55555555, 0xffff8003 },
  { 0x00000000, 0xffffffff, 0xffff8003, 0x00000020 },
  { 0x00000000, 0xffffffff, 0xffff8002, 0x7fffffff },
  { 0x00000000, 0x55555555, 0x55555555, 0x00000000 },
  { 0x00000000, 0x00000000, 0x00007ffe, 0xffffff81 },
  { 0x00000000, 0xffffffff, 0x80000001, 0x00007ffe },
  { 0x00000000, 0xffffffff, 0xaaaaaaaa, 0x00000020 },
  { 0x00000000, 0xffffffff, 0xfffffffe, 0x00000002 },
  { 0x00000000, 0xffffe000, 0xffff8000, 0xffff8002 },
  { 0x00000000, 0x00000000, 0x00007fff, 0xaaaaaaaa },
  { 0x00000000, 0xffffffff, 0xffffff80, 0x00007ffd },
  { 0x00000000, 0xffffffff, 0x80000000, 0xffffff80 },
  { 0x00000000, 0x00000000, 0x55555555, 0xfffffffd },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00007ffd },
  { 0x00000000, 0xffffffff, 0xfffffffe, 0xffffff80 },
  { 0x00000000, 0xffffffe0, 0xffffff82, 0xffff8002 },
  { 0x00000000, 0x7ffffffe, 0x7ffffffe, 0xffff8000 },
  { 0x00000000, 0xffffffff, 0xffff8003, 0xffffff80 },
  { 0x00000000, 0x00000000, 0x00000020, 0xffffffe0 },
  { 0x00000000, 0xffffffff, 0xffff8001, 0xffffffe0 },
  { 0x00000000, 0xffffe000, 0xffff8000, 0xffff8002 },
  { 0x00000000, 0x00000000, 0x00000002, 0x7ffffffe },
  { 0x00000000, 0x00000000, 0x0000007f, 0xffffff81 },
  { 0x00000000, 0x00000000, 0x00000001, 0x7fffffff },
  { 0x00000000, 0x00000000, 0x00000000, 0x33333333 },
  { 0x00000000, 0xffffffff, 0xffffff83, 0xcccccccc },
  { 0x00000000, 0x00000000, 0x00000020, 0x00007ffd },
  { 0x00000000, 0xcccccccc, 0xcccccccc, 0x00000000 },
  { 0x00000000, 0xffffffff, 0xffff8000, 0x00007fff },
  { 0x00000000, 0xffffffff, 0xcccccccc, 0x00007ffe },
  { 0x00000000, 0xffffffff, 0xfffffffd, 0x7ffffffe },
  { 0x00000000, 0xffffffff, 0xaaaaaaaa, 0x55555555 },
  { 0x00000000, 0xffffffff, 0xaaaaaaaa, 0xffffff81 },
  { 0x00000000, 0xfffffffe, 0xfffffffe, 0xffff8000 },
  { 0x00000000, 0xffffffff, 0xffffffe0, 0xfffffffd },
  { 0x00000000, 0x00000000, 0x33333333, 0xfffffffd },
  { 0x00000000, 0xffffc001, 0xffff8002, 0x80000001 },
  { 0x00000000, 0xffffffff, 0xffffff83, 0xffffff83 },
  { 0x00000000, 0xffffffff, 0xffff8002, 0x00000020 },
  { 0x00000000, 0x00000000, 0x7fffffff, 0x0000007f },
  { 0x00000000, 0xcccccccc, 0xcccccccc, 0xffff8000 },
  { 0x00000000, 0x00000000, 0x7ffffffe, 0x00007fff },
  { 0x00000000, 0x00000000, 0x7ffffffd, 0x7ffffffd },
  { 0x00000000, 0xffffffff, 0xfffffffd, 0xffff8002 },
  { 0x00000000, 0x00000000, 0x00000002, 0x7fffffff },
  { 0x00000000, 0xffffffff, 0xfffffffe, 0x00000020 },
  { 0x00000000, 0x00000000, 0x0000007e, 0x00007ffe },
  { 0x00000000, 0x00000000, 0x00007ffd, 0xfffffffd },
  { 0x00000000, 0x0000001f, 0x0000007f, 0x00000002 },
  { 0x00000000, 0xffffffff, 0x80000000, 0x7ffffffd },
  { 0x00000000, 0x00003fff, 0x00007fff, 0x80000001 },
  { 0x00000000, 0xffffffff, 0x80000000, 0xaaaaaaaa },
  { 0x00000000, 0xd5555555, 0xaaaaaaaa, 0xffff8001 },
  { 0x00000000, 0xfffffffc, 0xffffffe0, 0xffff8003 },
  { 0x00000000, 0xffffffff, 0xffffffff, 0x00007ffd },
  { 0x00000000, 0xffffffc0, 0xffffff81, 0x00000001 },
  { 0x00000000, 0xd5555555, 0xaaaaaaaa, 0x80000001 },
  { 0x00000000, 0xffff8000, 0xffff8000, 0xffff8000 },
  { 0x00000000, 0x00000000, 0x00007ffd, 0xaaaaaaaa },
  { 0x00000000, 0x7ffffffe, 0x7ffffffe, 0x80000000 },
  { 0x00000000, 0x00000000, 0x00007ffe, 0xffffff81 },
  { 0x00000000, 0x0000001f, 0x0000007d, 0xffff8002 },
  { 0x00000000, 0x00000000, 0x00000002, 0xffffff81 },
  { 0x00000000, 0xffffffff, 0xfffffffd, 0x7ffffffd },
  { 0x00000000, 0x00000000, 0x00000020, 0xffffff80 },
  { 0x00000000, 0x00000000, 0x7fffffff, 0xffffffe0 },
  { 0x00000000, 0xffffffff, 0xffff8002, 0x0000007f },
  { 0x00000000, 0x1fffffff, 0x7fffffff, 0xffff8002 },
  { 0x00000000, 0xffffffff, 0xfffffffd, 0x00000020 },
  { 0x00000000, 0xffffffff, 0xffffffe0, 0x0000007e },
  { 0x00000000, 0x00000000, 0x00000020, 0x7ffffffe },
  { 0x00000000, 0x0000007f, 0x0000007f, 0xffff8000 },
  { 0x00000000, 0xffffffff, 0x80000001, 0x0000007d },
  { 0x00000000, 0x00000000, 0x0000007f, 0x00007ffd },
  { 0x00000000, 0xffffffff, 0xffffffe0, 0xffffff82 },
  { 0x00000000, 0x0000001f, 0x0000007e, 0xffff8002 },
  { 0x00000000, 0x00000000, 0x55555555, 0x0000007f },
  { 0x00000000, 0x00000000, 0x7fffffff, 0x7ffffffe },
  { 0x00000000, 0xffffffff, 0xfffffffe, 0xffffff80 },
  { 0x00000000, 0xffffffff, 0xffff8002, 0x33333333 },
  { 0x00000000, 0xffffffff, 0xfffffffd, 0xaaaaaaaa },
  { 0x00000000, 0xffffffff, 0xfffffffd, 0x00000020 },
  { 0x00000000, 0x00000000, 0x00007ffe, 0x55555555 },
  { 0x00000000, 0x00000008, 0x00000020, 0x00000002 },
  { 0x00000000, 0xffffffff, 0xffff8002, 0xfffffffe },
  { 0x00000000, 0xe0000000, 0x80000001, 0xffff8002 },
  { 0x00000000, 0x00000000, 0x0000007e, 0x33333333 },
};
const TestResult kReferenceAsr[] = {
  {
    ARRAY_SIZE(kOutputs_Asr_Condition_eq_r0_r0_r0),
    kOutputs_Asr_Condition_eq_r0_r0_r0,
  },
  {
    ARRAY_SIZE(kOutputs_Asr_Condition_ne_r0_r0_r0),
    kOutputs_Asr_Condition_ne_r0_r0_r0,
  },
  {
    ARRAY_SIZE(kOutputs_Asr_Condition_cs_r0_r0_r0),
    kOutputs_Asr_Condition_cs_r0_r0_r0,
  },
  {
    ARRAY_SIZE(kOutputs_Asr_Condition_cc_r0_r0_r0),
    kOutputs_Asr_Condition_cc_r0_r0_r0,
  },
  {
    ARRAY_SIZE(kOutputs_Asr_Condition_mi_r0_r0_r0),
    kOutputs_Asr_Condition_mi_r0_r0_r0,
  },
  {
    ARRAY_SIZE(kOutputs_Asr_Condition_pl_r0_r0_r0),
    kOutputs_Asr_Condition_pl_r0_r0_r0,
  },
  {
    ARRAY_SIZE(kOutputs_Asr_Condition_vs_r0_r0_r0),
    kOutputs_Asr_Condition_vs_r0_r0_r0,
  },
  {
    ARRAY_SIZE(kOutputs_Asr_Condition_vc_r0_r0_r0),
    kOutputs_Asr_Condition_vc_r0_r0_r0,
  },
  {
    ARRAY_SIZE(kOutputs_Asr_Condition_hi_r0_r0_r0),
    kOutputs_Asr_Condition_hi_r0_r0_r0,
  },
  {
    ARRAY_SIZE(kOutputs_Asr_Condition_ls_r0_r0_r0),
    kOutputs_Asr_Condition_ls_r0_r0_r0,
  },
  {
    ARRAY_SIZE(kOutputs_Asr_Condition_ge_r0_r0_r0),
    kOutputs_Asr_Condition_ge_r0_r0_r0,
  },
  {
    ARRAY_SIZE(kOutputs_Asr_Condition_lt_r0_r0_r0),
    kOutputs_Asr_Condition_lt_r0_r0_r0,
  },
  {
    ARRAY_SIZE(kOutputs_Asr_Condition_gt_r0_r0_r0),
    kOutputs_Asr_Condition_gt_r0_r0_r0,
  },
  {
    ARRAY_SIZE(kOutputs_Asr_Condition_le_r0_r0_r0),
    kOutputs_Asr_Condition_le_r0_r0_r0,
  },
  {
    ARRAY_SIZE(kOutputs_Asr_Condition_al_r0_r0_r0),
    kOutputs_Asr_Condition_al_r0_r0_r0,
  },
  {
    ARRAY_SIZE(kOutputs_Asr_RdIsRn_al_r3_r3_r4),
    kOutputs_Asr_RdIsRn_al_r3_r3_r4,
  },
  {
    ARRAY_SIZE(kOutputs_Asr_RdIsRn_al_r2_r2_r12),
    kOutputs_Asr_RdIsRn_al_r2_r2_r12,
  },
  {
    ARRAY_SIZE(kOutputs_Asr_RdIsRn_al_r8_r8_r5),
    kOutputs_Asr_RdIsRn_al_r8_r8_r5,
  },
  {
    ARRAY_SIZE(kOutputs_Asr_RdIsRn_al_r14_r14_r0),
    kOutputs_Asr_RdIsRn_al_r14_r14_r0,
  },
  {
    ARRAY_SIZE(kOutputs_Asr_RdIsRn_al_r11_r11_r10),
    kOutputs_Asr_RdIsRn_al_r11_r11_r10,
  },
  {
    ARRAY_SIZE(kOutputs_Asr_RdIsRn_al_r12_r12_r10),
    kOutputs_Asr_RdIsRn_al_r12_r12_r10,
  },
  {
    ARRAY_SIZE(kOutputs_Asr_RdIsRn_al_r4_r4_r8),
    kOutputs_Asr_RdIsRn_al_r4_r4_r8,
  },
  {
    ARRAY_SIZE(kOutputs_Asr_RdIsRn_al_r5_r5_r14),
    kOutputs_Asr_RdIsRn_al_r5_r5_r14,
  },
  {
    ARRAY_SIZE(kOutputs_Asr_RdIsRn_al_r0_r0_r6),
    kOutputs_Asr_RdIsRn_al_r0_r0_r6,
  },
  {
    ARRAY_SIZE(kOutputs_Asr_RdIsRn_al_r12_r12_r1),
    kOutputs_Asr_RdIsRn_al_r12_r12_r1,
  },
  {
    ARRAY_SIZE(kOutputs_Asr_RdIsRm_al_r6_r11_r6),
    kOutputs_Asr_RdIsRm_al_r6_r11_r6,
  },
  {
    ARRAY_SIZE(kOutputs_Asr_RdIsRm_al_r11_r9_r11),
    kOutputs_Asr_RdIsRm_al_r11_r9_r11,
  },
  {
    ARRAY_SIZE(kOutputs_Asr_RdIsRm_al_r0_r8_r0),
    kOutputs_Asr_RdIsRm_al_r0_r8_r0,
  },
  {
    ARRAY_SIZE(kOutputs_Asr_RdIsRm_al_r2_r11_r2),
    kOutputs_Asr_RdIsRm_al_r2_r11_r2,
  },
  {
    ARRAY_SIZE(kOutputs_Asr_RdIsRm_al_r9_r4_r9),
    kOutputs_Asr_RdIsRm_al_r9_r4_r9,
  },
  {
    ARRAY_SIZE(kOutputs_Asr_RdIsRm_al_r14_r10_r14),
    kOutputs_Asr_RdIsRm_al_r14_r10_r14,
  },
  {
    ARRAY_SIZE(kOutputs_Asr_RdIsRm_al_r7_r0_r7),
    kOutputs_Asr_RdIsRm_al_r7_r0_r7,
  },
  {
    ARRAY_SIZE(kOutputs_Asr_RdIsRm_al_r4_r9_r4),
    kOutputs_Asr_RdIsRm_al_r4_r9_r4,
  },
  {
    ARRAY_SIZE(kOutputs_Asr_RdIsRm_al_r6_r10_r6),
    kOutputs_Asr_RdIsRm_al_r6_r10_r6,
  },
  {
    ARRAY_SIZE(kOutputs_Asr_RdIsRm_al_r7_r6_r7),
    kOutputs_Asr_RdIsRm_al_r7_r6_r7,
  },
  {
    ARRAY_SIZE(kOutputs_Asr_RdIsNotRnIsNotRm_al_r3_r9_r10),
    kOutputs_Asr_RdIsNotRnIsNotRm_al_r3_r9_r10,
  },
  {
    ARRAY_SIZE(kOutputs_Asr_RdIsNotRnIsNotRm_al_r7_r12_r5),
    kOutputs_Asr_RdIsNotRnIsNotRm_al_r7_r12_r5,
  },
  {
    ARRAY_SIZE(kOutputs_Asr_RdIsNotRnIsNotRm_al_r8_r5_r6),
    kOutputs_Asr_RdIsNotRnIsNotRm_al_r8_r5_r6,
  },
  {
    ARRAY_SIZE(kOutputs_Asr_RdIsNotRnIsNotRm_al_r0_r6_r0),
    kOutputs_Asr_RdIsNotRnIsNotRm_al_r0_r6_r0,
  },
  {
    ARRAY_SIZE(kOutputs_Asr_RdIsNotRnIsNotRm_al_r11_r7_r8),
    kOutputs_Asr_RdIsNotRnIsNotRm_al_r11_r7_r8,
  },
  {
    ARRAY_SIZE(kOutputs_Asr_RdIsNotRnIsNotRm_al_r12_r2_r3),
    kOutputs_Asr_RdIsNotRnIsNotRm_al_r12_r2_r3,
  },
  {
    ARRAY_SIZE(kOutputs_Asr_RdIsNotRnIsNotRm_al_r7_r4_r10),
    kOutputs_Asr_RdIsNotRnIsNotRm_al_r7_r4_r10,
  },
  {
    ARRAY_SIZE(kOutputs_Asr_RdIsNotRnIsNotRm_al_r9_r6_r1),
    kOutputs_Asr_RdIsNotRnIsNotRm_al_r9_r6_r1,
  },
  {
    ARRAY_SIZE(kOutputs_Asr_RdIsNotRnIsNotRm_al_r10_r14_r3),
    kOutputs_Asr_RdIsNotRnIsNotRm_al_r10_r14_r3,
  },
  {
    ARRAY_SIZE(kOutputs_Asr_RdIsNotRnIsNotRm_al_r14_r3_r6),
    kOutputs_Asr_RdIsNotRnIsNotRm_al_r14_r3_r6,
  },
};

#endif  // VIXL_SIMULATOR_COND_RD_RN_OPERAND_RM_ASR_A32_H_
